using System;

namespace SBU.HTRRL.FlowPattern.DataAnalysis
{
	/// <summary>
	/// Define the kind of properties.
	/// </summary>
	/// 
	public class AirWater1bar0CProperty
	{
		public readonly double Temperature, Pressure;

		public AirWater1bar0CProperty()
		{
			Temperature=0;  //C
			Pressure=100000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 1000;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 1.29;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.001791;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000172;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0756;
			}
		}
	}	

	public class AirWater1bar15CProperty
	{
		public readonly double Temperature, Pressure;

		public AirWater1bar15CProperty()
		{
			Temperature=15.5;  //C
			Pressure=100000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 998;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 1.22;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.0012329;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000179;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.07335;
			}
		}
	}	

	public class AirWater1bar20CProperty
	{
		public readonly double Temperature, Pressure;

		public AirWater1bar20CProperty()
		{
			Temperature=20;  //C
			Pressure=100000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 998;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
					return 1.21;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.001071;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000181;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0728;
			}
		}
	}	

	public class AirWater1bar25CProperty
	{
		public readonly double Temperature, Pressure;

		public AirWater1bar25CProperty()
		{
			Temperature=25;  //C
			Pressure=100000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 997;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 1.19;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.0008909;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000184;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.072;
			}
		}
	}	

	public class AirWater1bar50CProperty
	{
		public readonly double Temperature, Pressure;

		public AirWater1bar50CProperty()
		{
			Temperature=50;  //C
			Pressure=100000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 988;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 1.07;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.000547;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000195;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0679;
			}
		}
	}	

	public class AirWater1bar100CProperty
	{
		public readonly double Temperature, Pressure;

		public AirWater1bar100CProperty()
		{
			Temperature=100;  //C
			Pressure=100000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 958;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 0.95;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.000282;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000217;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0589;
			}
		}
	}	

	public class SteamWater34barProperty
	{
		public readonly double Temperature, Pressure;

		public SteamWater34barProperty()
		{
			Temperature=241.7;  //C
			Pressure=3450000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 811;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 17.28;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.000115;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000175;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.028;
			}
		}
	}	

	public class SteamWater69barProperty
	{
		public readonly double Temperature, Pressure;

		public SteamWater69barProperty()
		{
			Temperature=284.8;  //C
			Pressure=6900000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 740;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 36.5;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.000096;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000192;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0178;
			}
		}
	}	

	public class R134a6barProperty
	{
		public readonly double Temperature, Pressure;

		public R134a6barProperty()
		{
			Temperature=21.6;  //C
			Pressure=600000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 1218;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 29.0;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.0002102;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000117;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0084;
			}
		}
	}	

	public class R134a10barProperty
	{
		public readonly double Temperature, Pressure;

		public R134a10barProperty()
		{
			Temperature=39.4;  //C
			Pressure=1000000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 1148;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 49.1;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.0001708;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000126;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0062;
			}
		}
	}	

	public class R134a14barProperty
	{
		public readonly double Temperature, Pressure;

		public R134a14barProperty()
		{
			Temperature=52.5;  //C
			Pressure=1400000; //Pa
		}

		public double LiquidDensity // kg/m3
		{
			get
			{
				return 1090;

			}
		}

		public double VapourDensity // kg/m3
		{
			get
			{
				return 70.7;
			}
		}

		public double LiquidViscosity // Pa.s
		{
			get
			{
				return 0.0001473;
			}
		}

		public double VapourViscosity // Pa.s
		{
			get
			{
				return 0.0000133;			
			}
		}

		public double SurfaceTension // N/m
		{
			get
			{
				return 0.0046;
			}
		}
	}	
}