using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.IO;
using System.Drawing.Printing;

namespace SBU.HTRRL.FlowPattern.DataAnalysis
{
	/// <summary>
	/// Summary description for FrmFlowPatternGraph.
	/// </summary>

	public class FrmFlowPatternGraph : Symbol
	//public class FrmFlowPatternGraph : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		private FrmConstantQualityLineInputData inputData;
		private FrmConditionInput modelCondition;
		private FrmSetMcQuillanWhalleyModelConstant inputMcQuillanWhalleyModelConstant;
		private FrmSetTaitelModelLDRatio inputTaitelModelLDRatio;

		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuFile;
		private System.Windows.Forms.MenuItem menuRefresh;
		private System.Windows.Forms.MenuItem menuSetModelCondition;
		private System.Windows.Forms.MenuItem menuFinishSetting;
		private System.Windows.Forms.MenuItem menuBoubdaryA;
		private System.Windows.Forms.MenuItem menuAllBoundariesA;
		private System.Windows.Forms.MenuItem menuBoundaryA1;
		private System.Windows.Forms.MenuItem menuBoundaryA2;
		private System.Windows.Forms.MenuItem menuBoundaryA3;
		private System.Windows.Forms.MenuItem menuBoundaryA4;
		private System.Windows.Forms.MenuItem menuBoundaryA5;
		private System.Windows.Forms.MenuItem menuBoubdaryB;
		private System.Windows.Forms.MenuItem menuAllBoundariesB;
		private System.Windows.Forms.MenuItem menuBoundaryB1;
		private System.Windows.Forms.MenuItem menuBoundaryB2;
		private System.Windows.Forms.MenuItem menuBoundaryB3;
		private System.Windows.Forms.MenuItem menuBoundaryB4;
		private System.Windows.Forms.MenuItem menuBoundaryB5;
		private System.Windows.Forms.MenuItem menuSetLDRatio;
		private System.Windows.Forms.MenuItem menuBoubdaryC;
		private System.Windows.Forms.MenuItem menuAllBoundariesC;
		private System.Windows.Forms.MenuItem menuBoundaryC1;
		private System.Windows.Forms.MenuItem menuBoundaryC2;
		private System.Windows.Forms.MenuItem menuBoundaryC3;
		private System.Windows.Forms.MenuItem menuBoundaryC4;
		private System.Windows.Forms.MenuItem menuBoubdaryD;
		private System.Windows.Forms.MenuItem menuAllBoundariesD;
		private System.Windows.Forms.MenuItem menuBoundaryD1;
		private System.Windows.Forms.MenuItem menuBoundaryD2;
		private System.Windows.Forms.MenuItem menuBoundaryD3;
		private System.Windows.Forms.MenuItem menuBoundaryD4;
		private System.Windows.Forms.MenuItem menuBoundaryD5;
		private System.Windows.Forms.MenuItem menuSetPlugChurnCriticalConstant;
		private System.Windows.Forms.MenuItem menuBoubdaryE;
		private System.Windows.Forms.MenuItem menuAllBoundariesE;
		private System.Windows.Forms.MenuItem menuBoundaryE1;
		private System.Windows.Forms.MenuItem menuBoundaryE2;
		private System.Windows.Forms.MenuItem menuBoundaryE3;
		private System.Windows.Forms.MenuItem menuBoundaryE4;
		private System.Windows.Forms.MenuItem menuBoundaryE5;
		private System.Windows.Forms.MenuItem menuBoundaryE6;
		private System.Windows.Forms.MenuItem menuBoundaryE7;
		private System.Windows.Forms.MenuItem menuBoundaryE8;
		private System.Windows.Forms.MenuItem menuBoubdaryF;
		private System.Windows.Forms.MenuItem menuAllBoundariesF;
		private System.Windows.Forms.MenuItem menuBoundaryF1;
		private System.Windows.Forms.MenuItem menuBoundaryF2;
		private System.Windows.Forms.MenuItem menuBoundaryF4;
		private System.Windows.Forms.MenuItem menuBoundaryF5;
		private System.Windows.Forms.MenuItem menuBoundaryF6;
		private System.Windows.Forms.MenuItem menuBoundaryF3;
		private System.Windows.Forms.MenuItem menuConstantQuality;
		private System.Windows.Forms.MenuItem menuSetQuality;
		private System.Windows.Forms.MenuItem menuShowIsoQualityLine;
		private System.Windows.Forms.MenuItem menuIsoQualityLineClear;
		private System.Windows.Forms.MenuItem menuShowAllIsoQualityLine;
		private System.Windows.Forms.MenuItem menuShowAllIsoFluxLine;
		private System.Windows.Forms.MenuItem menuExit;
		private System.Windows.Forms.MenuItem menuLine1;
		private System.Windows.Forms.MenuItem menuLine2;
		private System.Windows.Forms.MenuItem menuLine3;
		private System.Windows.Forms.MenuItem menuLine4;
		private System.Windows.Forms.MenuItem menuLine5;
		private System.Windows.Forms.MenuItem menuLine6;
		private System.Windows.Forms.MenuItem menuLine7;
		private System.Windows.Forms.MenuItem menuLine8;
		private System.Windows.Forms.MenuItem menuLine9;
		private System.Windows.Forms.MenuItem menuLine10;

		internal static bool isBoundaryA1Valid;
		private int startPointA1,endPointA1;
		private PointF[] boundaryPointA1;
		internal static bool isBoundaryA2Valid;
		private int startPointA2,endPointA2;
		private PointF[] boundaryPointA2;
		internal static bool isBoundaryA3Valid;
		private int startPointA3,endPointA3;
		private PointF[] boundaryPointA3;
		internal static bool isBoundaryA4Valid;
		private int startPointA4,endPointA4;
		private PointF[] boundaryPointA4;
		internal static bool isBoundaryA5Valid;
		private int startPointA5,endPointA5;
		private PointF[] boundaryPointA5;

		internal static bool isBoundaryB1Valid;
		private int startPointB1,endPointB1;
		private PointF[] boundaryPointB1;
		internal static bool isBoundaryB2Valid;
		private int startPointB2,endPointB2;
		private PointF[] boundaryPointB2;
		internal static bool isBoundaryB3Valid;
		private int startPointB3,endPointB3;
		private PointF[] boundaryPointB3;
		internal static bool isBoundaryB4Valid;
		private int startPointB4,endPointB4;
		private PointF[] boundaryPointB4;
		internal static bool isBoundaryB5Valid;
		private int startPointB5,endPointB5;
		private PointF[] boundaryPointB5;

		internal static bool isBoundaryC1Valid;
		private int startPointC1,endPointC1;
		private PointF[] boundaryPointC1;
		internal static bool isBoundaryC2Valid;
		private int startPointC2,endPointC2;
		private PointF[] boundaryPointC2;
		internal static bool isBoundaryC3Valid;
		private int startPointC3,endPointC3;
		private PointF[] boundaryPointC3;
		internal static bool isBoundaryC4Valid;
		private int startPointC4,endPointC4;
		private PointF[] boundaryPointC4;

		internal static bool isBoundaryD1Valid;
		private int startPointD1,endPointD1;
		private PointF[] boundaryPointD1;
		internal static bool isBoundaryD2Valid;
		private int startPointD2,endPointD2;
		private PointF[] boundaryPointD2;
		internal static bool isBoundaryD3Valid;
		private int startPointD3,endPointD3;
		private PointF[] boundaryPointD3;
		internal static bool isBoundaryD4Valid;
		private int startPointD4,endPointD4;
		private PointF[] boundaryPointD4;
		internal static bool isBoundaryD5Valid;
		private int startPointD5,endPointD5;
		private PointF[] boundaryPointD5;

		internal static bool isBoundaryE1Valid;
		private int startPointE1,endPointE1;
		private PointF[] boundaryPointE1;
		internal static bool isBoundaryE2Valid;
		private int startPointE2,endPointE2;
		private PointF[] boundaryPointE2;
		internal static bool isBoundaryE3Valid;
		private int startPointE3,endPointE3;
		private PointF[] boundaryPointE3;
		internal static bool isBoundaryE4Valid;
		private int startPointE4,endPointE4;
		private PointF[] boundaryPointE4;
		internal static bool isBoundaryE5Valid;
		private int startPointE5,endPointE5;
		private PointF[] boundaryPointE5;
		internal static bool isBoundaryE6Valid;
		private int startPointE6,endPointE6;
		private PointF[] boundaryPointE6;
		internal static bool isBoundaryE7Valid;
		private int startPointE7,endPointE7;
		private PointF[] boundaryPointE7;
		internal static bool isBoundaryE8Valid;
		private int startPointE8,endPointE8;
		private PointF[] boundaryPointE8;

		internal static bool isBoundaryF1Valid;
		private int startPointF1,endPointF1;
		private PointF[] boundaryPointF1;
		internal static bool isBoundaryF2Valid;
		private int startPointF2,endPointF2;
		private PointF[] boundaryPointF2;
		internal static bool isBoundaryF3Valid;
		private int startPointF3,endPointF3;
		private PointF[] boundaryPointF3;
		internal static bool isBoundaryF4Valid;
		private int startPointF4,endPointF4;
		private PointF[] boundaryPointF4;
		internal static bool isBoundaryF5Valid;
		private int startPointF5,endPointF5;
		private PointF[] boundaryPointF5;
		internal static bool isBoundaryF6Valid;
		private int startPointF6,endPointF6;
		private PointF[] boundaryPointF6;

		//private bool isConstantQualityBoundaryValid;
		private int startPointCQ,endPointCQ;
		private PointF[] boundaryPointCQ;
		public static double [] Quality={0.0001,0.0002,0.0005,0.001,0.002,0.005,0.01,0.02,0.05,0.1,0.2,0.4,0.6,0.8,0.9};
		private int [] startPointCQs=new int[Quality.Length];
		private int [] endPointCQs=new int[Quality.Length];
		private PointF[][] boundaryPointCQs=new PointF[Quality.Length][];
		internal static bool isBoundaryCQsValid;
		public static double [] MassFlux={25,50,100,200,400,800,1600,3200,6400};
		private int [] startPointMFs=new int[MassFlux.Length];
		private int [] endPointMFs=new int[MassFlux.Length];
		private PointF[][] boundaryPointMFs=new PointF[MassFlux.Length][];
		internal static bool isBoundaryMFsValid;
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		private System.Windows.Forms.OpenFileDialog openFileDialog3;
		private System.Windows.Forms.OpenFileDialog openFileDialog4;
		private System.Windows.Forms.OpenFileDialog openFileDialog5;

		public FrmFlowPatternGraph()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuFile = new System.Windows.Forms.MenuItem();
			this.menuSetModelCondition = new System.Windows.Forms.MenuItem();
			this.menuFinishSetting = new System.Windows.Forms.MenuItem();
			this.menuLine1 = new System.Windows.Forms.MenuItem();
			this.menuRefresh = new System.Windows.Forms.MenuItem();
			this.menuBoubdaryA = new System.Windows.Forms.MenuItem();
			this.menuAllBoundariesA = new System.Windows.Forms.MenuItem();
			this.menuLine2 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryA1 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryA2 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryA3 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryA4 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryA5 = new System.Windows.Forms.MenuItem();
			this.menuBoubdaryB = new System.Windows.Forms.MenuItem();
			this.menuAllBoundariesB = new System.Windows.Forms.MenuItem();
			this.menuLine3 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryB1 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryB2 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryB3 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryB4 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryB5 = new System.Windows.Forms.MenuItem();
			this.menuLine7 = new System.Windows.Forms.MenuItem();
			this.menuSetLDRatio = new System.Windows.Forms.MenuItem();
			this.menuBoubdaryC = new System.Windows.Forms.MenuItem();
			this.menuAllBoundariesC = new System.Windows.Forms.MenuItem();
			this.menuLine4 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryC1 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryC2 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryC3 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryC4 = new System.Windows.Forms.MenuItem();
			this.menuBoubdaryD = new System.Windows.Forms.MenuItem();
			this.menuAllBoundariesD = new System.Windows.Forms.MenuItem();
			this.menuLine5 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryD1 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryD2 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryD3 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryD4 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryD5 = new System.Windows.Forms.MenuItem();
			this.menuLine6 = new System.Windows.Forms.MenuItem();
			this.menuSetPlugChurnCriticalConstant = new System.Windows.Forms.MenuItem();
			this.menuBoubdaryE = new System.Windows.Forms.MenuItem();
			this.menuAllBoundariesE = new System.Windows.Forms.MenuItem();
			this.menuLine8 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE1 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE2 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE3 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE7 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE8 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE4 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE6 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryE5 = new System.Windows.Forms.MenuItem();
			this.menuConstantQuality = new System.Windows.Forms.MenuItem();
			this.menuSetQuality = new System.Windows.Forms.MenuItem();
			this.menuShowIsoQualityLine = new System.Windows.Forms.MenuItem();
			this.menuIsoQualityLineClear = new System.Windows.Forms.MenuItem();
			this.menuLine9 = new System.Windows.Forms.MenuItem();
			this.menuShowAllIsoQualityLine = new System.Windows.Forms.MenuItem();
			this.menuShowAllIsoFluxLine = new System.Windows.Forms.MenuItem();
			this.menuExit = new System.Windows.Forms.MenuItem();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog3 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog4 = new System.Windows.Forms.OpenFileDialog();
			this.openFileDialog5 = new System.Windows.Forms.OpenFileDialog();
			this.menuBoubdaryF = new System.Windows.Forms.MenuItem();
			this.menuAllBoundariesF = new System.Windows.Forms.MenuItem();
			this.menuLine10 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryF1 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryF2 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryF4 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryF5 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryF6 = new System.Windows.Forms.MenuItem();
			this.menuBoundaryF3 = new System.Windows.Forms.MenuItem();
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog1_FileOk);
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuFile,
																					  this.menuBoubdaryA,
																					  this.menuBoubdaryB,
																					  this.menuBoubdaryC,
																					  this.menuBoubdaryD,
																					  this.menuBoubdaryE,
																					  this.menuBoubdaryF,
																					  this.menuConstantQuality,
																					  this.menuExit});
			// 
			// menuFile
			// 
			this.menuFile.Index = 0;
			this.menuFile.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.menuSetModelCondition,
																					 this.menuFinishSetting,
																					 this.menuLine1,
																					 this.menuRefresh});
			this.menuFile.Text = "File";
			// 
			// menuSetModelCondition
			// 
			this.menuSetModelCondition.Index = 0;
			this.menuSetModelCondition.Text = "Set Model Condition";
			this.menuSetModelCondition.Click += new System.EventHandler(this.menuSetModelCondition_Click);
			// 
			// menuFinishSetting
			// 
			this.menuFinishSetting.Enabled = false;
			this.menuFinishSetting.Index = 1;
			this.menuFinishSetting.Text = "Finish Setting";
			this.menuFinishSetting.Click += new System.EventHandler(this.menuFinishSetting_Click);
			// 
			// menuLine1
			// 
			this.menuLine1.Index = 2;
			this.menuLine1.Text = "-";
			// 
			// menuRefresh
			// 
			this.menuRefresh.Index = 3;
			this.menuRefresh.Text = "Refresh";
			this.menuRefresh.Click += new System.EventHandler(this.menuRefresh_Click);
			// 
			// menuBoubdaryA
			// 
			this.menuBoubdaryA.Index = 1;
			this.menuBoubdaryA.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuAllBoundariesA,
																						  this.menuLine2,
																						  this.menuBoundaryA1,
																						  this.menuBoundaryA2,
																						  this.menuBoundaryA3,
																						  this.menuBoundaryA4,
																						  this.menuBoundaryA5});
			this.menuBoubdaryA.Text = "Unified Model";
			// 
			// menuAllBoundariesA
			// 
			this.menuAllBoundariesA.Index = 0;
			this.menuAllBoundariesA.Text = "All Boundaries";
			this.menuAllBoundariesA.Click += new System.EventHandler(this.menuAllBoundariesA_Click);
			// 
			// menuLine2
			// 
			this.menuLine2.Index = 1;
			this.menuLine2.Text = "-";
			// 
			// menuBoundaryA1
			// 
			this.menuBoundaryA1.Index = 2;
			this.menuBoundaryA1.Text = "Bubbly - Dispersed Bubble";
			this.menuBoundaryA1.Click += new System.EventHandler(this.menuBoundaryA1_Click);
			// 
			// menuBoundaryA2
			// 
			this.menuBoundaryA2.Index = 3;
			this.menuBoundaryA2.Text = "Dispersed Bubble - Churn";
			this.menuBoundaryA2.Click += new System.EventHandler(this.menuBoundaryA2_Click);
			// 
			// menuBoundaryA3
			// 
			this.menuBoundaryA3.Index = 4;
			this.menuBoundaryA3.Text = "Intermitent - Churn";
			this.menuBoundaryA3.Click += new System.EventHandler(this.menuBoundaryA3_Click);
			// 
			// menuBoundaryA4
			// 
			this.menuBoundaryA4.Index = 5;
			this.menuBoundaryA4.Text = "Churn - Annular";
			this.menuBoundaryA4.Click += new System.EventHandler(this.menuBoundaryA4_Click);
			// 
			// menuBoundaryA5
			// 
			this.menuBoundaryA5.Index = 6;
			this.menuBoundaryA5.Text = "Bubbly - Slug";
			this.menuBoundaryA5.Click += new System.EventHandler(this.menuBoundaryA5_Click);
			// 
			// menuBoubdaryB
			// 
			this.menuBoubdaryB.Index = 2;
			this.menuBoubdaryB.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuAllBoundariesB,
																						  this.menuLine3,
																						  this.menuBoundaryB1,
																						  this.menuBoundaryB2,
																						  this.menuBoundaryB3,
																						  this.menuBoundaryB4,
																						  this.menuBoundaryB5,
																						  this.menuLine7,
																						  this.menuSetLDRatio});
			this.menuBoubdaryB.Text = "Taitel Models";
			// 
			// menuAllBoundariesB
			// 
			this.menuAllBoundariesB.Index = 0;
			this.menuAllBoundariesB.Text = "All Boundaries";
			this.menuAllBoundariesB.Click += new System.EventHandler(this.menuAllBoundariesB_Click);
			// 
			// menuLine3
			// 
			this.menuLine3.Index = 1;
			this.menuLine3.Text = "-";
			// 
			// menuBoundaryB1
			// 
			this.menuBoundaryB1.Index = 2;
			this.menuBoundaryB1.Text = "Churn - Annular";
			this.menuBoundaryB1.Click += new System.EventHandler(this.menuBoundaryB1_Click);
			// 
			// menuBoundaryB2
			// 
			this.menuBoundaryB2.Index = 3;
			this.menuBoundaryB2.Text = "Dispersed Bubble - Bubbly";
			this.menuBoundaryB2.Click += new System.EventHandler(this.menuBoundaryB2_Click);
			// 
			// menuBoundaryB3
			// 
			this.menuBoundaryB3.Index = 4;
			this.menuBoundaryB3.Text = "Dispersed Bubble - Churn";
			this.menuBoundaryB3.Click += new System.EventHandler(this.menuBoundaryB3_Click);
			// 
			// menuBoundaryB4
			// 
			this.menuBoundaryB4.Index = 5;
			this.menuBoundaryB4.Text = "Bubbly - Slug";
			this.menuBoundaryB4.Click += new System.EventHandler(this.menuBoundaryB4_Click);
			// 
			// menuBoundaryB5
			// 
			this.menuBoundaryB5.Index = 6;
			this.menuBoundaryB5.Text = "Slug - Churn";
			this.menuBoundaryB5.Click += new System.EventHandler(this.menuBoundaryB5_Click);
			// 
			// menuLine7
			// 
			this.menuLine7.Index = 7;
			this.menuLine7.Text = "-";
			// 
			// menuSetLDRatio
			// 
			this.menuSetLDRatio.Index = 8;
			this.menuSetLDRatio.Text = "Set LD Ratio (Default=100)";
			this.menuSetLDRatio.Click += new System.EventHandler(this.menuSetLDRatio_Click);
			// 
			// menuBoubdaryC
			// 
			this.menuBoubdaryC.Index = 3;
			this.menuBoubdaryC.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuAllBoundariesC,
																						  this.menuLine4,
																						  this.menuBoundaryC1,
																						  this.menuBoundaryC2,
																						  this.menuBoundaryC3,
																						  this.menuBoundaryC4});
			this.menuBoubdaryC.Text = "Mishima-Ishii Model";
			// 
			// menuAllBoundariesC
			// 
			this.menuAllBoundariesC.Index = 0;
			this.menuAllBoundariesC.Text = "All Boundaries";
			this.menuAllBoundariesC.Click += new System.EventHandler(this.menuAllBoundariesC_Click);
			// 
			// menuLine4
			// 
			this.menuLine4.Index = 1;
			this.menuLine4.Text = "-";
			// 
			// menuBoundaryC1
			// 
			this.menuBoundaryC1.Index = 2;
			this.menuBoundaryC1.Text = "Bubbly - Slug";
			this.menuBoundaryC1.Click += new System.EventHandler(this.menuBoundaryC1_Click);
			// 
			// menuBoundaryC2
			// 
			this.menuBoundaryC2.Index = 3;
			this.menuBoundaryC2.Text = "Slug - Churn";
			this.menuBoundaryC2.Click += new System.EventHandler(this.menuBoundaryC2_Click);
			// 
			// menuBoundaryC3
			// 
			this.menuBoundaryC3.Index = 4;
			this.menuBoundaryC3.Text = "Slug - Annular";
			this.menuBoundaryC3.Click += new System.EventHandler(this.menuBoundaryC3_Click);
			// 
			// menuBoundaryC4
			// 
			this.menuBoundaryC4.Index = 5;
			this.menuBoundaryC4.Text = "Churn - Annular";
			this.menuBoundaryC4.Click += new System.EventHandler(this.menuBoundaryC4_Click);
			// 
			// menuBoubdaryD
			// 
			this.menuBoubdaryD.Index = 4;
			this.menuBoubdaryD.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuAllBoundariesD,
																						  this.menuLine5,
																						  this.menuBoundaryD1,
																						  this.menuBoundaryD2,
																						  this.menuBoundaryD3,
																						  this.menuBoundaryD4,
																						  this.menuBoundaryD5,
																						  this.menuLine6,
																						  this.menuSetPlugChurnCriticalConstant});
			this.menuBoubdaryD.Text = "McQuillan-Whalley Model";
			// 
			// menuAllBoundariesD
			// 
			this.menuAllBoundariesD.Index = 0;
			this.menuAllBoundariesD.Text = "All Boundaries";
			this.menuAllBoundariesD.Click += new System.EventHandler(this.menuAllBoundariesD_Click);
			// 
			// menuLine5
			// 
			this.menuLine5.Index = 1;
			this.menuLine5.Text = "-";
			// 
			// menuBoundaryD1
			// 
			this.menuBoundaryD1.Index = 2;
			this.menuBoundaryD1.Text = "Bubbly - Plug, Churn";
			this.menuBoundaryD1.Click += new System.EventHandler(this.menuBoundaryD1_Click);
			// 
			// menuBoundaryD2
			// 
			this.menuBoundaryD2.Index = 3;
			this.menuBoundaryD2.Text = "Dispersed Bubble - Churn";
			this.menuBoundaryD2.Click += new System.EventHandler(this.menuBoundaryD2_Click);
			// 
			// menuBoundaryD3
			// 
			this.menuBoundaryD3.Index = 4;
			this.menuBoundaryD3.Text = "From Dispersed Bubble";
			this.menuBoundaryD3.Click += new System.EventHandler(this.menuBoundaryD3_Click);
			// 
			// menuBoundaryD4
			// 
			this.menuBoundaryD4.Index = 5;
			this.menuBoundaryD4.Text = "Plug - Churn";
			this.menuBoundaryD4.Click += new System.EventHandler(this.menuBoundaryD4_Click);
			// 
			// menuBoundaryD5
			// 
			this.menuBoundaryD5.Index = 6;
			this.menuBoundaryD5.Text = "From Annular";
			this.menuBoundaryD5.Click += new System.EventHandler(this.menuBoundaryD5_Click);
			// 
			// menuLine6
			// 
			this.menuLine6.Index = 7;
			this.menuLine6.Text = "-";
			// 
			// menuSetPlugChurnCriticalConstant
			// 
			this.menuSetPlugChurnCriticalConstant.Index = 8;
			this.menuSetPlugChurnCriticalConstant.Text = "Set Plug - Churn Critical Constant (Default=1.0)";
			this.menuSetPlugChurnCriticalConstant.Click += new System.EventHandler(this.menuSetPlugChurnCriticalConstant_Click);
			// 
			// menuBoubdaryE
			// 
			this.menuBoubdaryE.Index = 5;
			this.menuBoubdaryE.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuAllBoundariesE,
																						  this.menuLine8,
																						  this.menuBoundaryE1,
																						  this.menuBoundaryE2,
																						  this.menuBoundaryE3,
																						  this.menuBoundaryE7,
																						  this.menuBoundaryE8,
																						  this.menuBoundaryE4,
																						  this.menuBoundaryE6,
																						  this.menuBoundaryE5});
			this.menuBoubdaryE.Text = "Chen Model 1";
			// 
			// menuAllBoundariesE
			// 
			this.menuAllBoundariesE.Index = 0;
			this.menuAllBoundariesE.Text = "All Boundaries";
			this.menuAllBoundariesE.Click += new System.EventHandler(this.menuAllBoundariesE_Click);
			// 
			// menuLine8
			// 
			this.menuLine8.Index = 1;
			this.menuLine8.Text = "-";
			// 
			// menuBoundaryE1
			// 
			this.menuBoundaryE1.Index = 2;
			this.menuBoundaryE1.Text = "Bubbly - Slug";
			this.menuBoundaryE1.Click += new System.EventHandler(this.menuBoundaryE1_Click);
			// 
			// menuBoundaryE2
			// 
			this.menuBoundaryE2.Index = 3;
			this.menuBoundaryE2.Text = "Dispersed bubble - Bubbly";
			this.menuBoundaryE2.Click += new System.EventHandler(this.menuBoundaryE2_Click);
			// 
			// menuBoundaryE3
			// 
			this.menuBoundaryE3.Index = 4;
			this.menuBoundaryE3.Text = "Slug - Churn (1)";
			this.menuBoundaryE3.Click += new System.EventHandler(this.menuBoundaryE3_Click);
			// 
			// menuBoundaryE7
			// 
			this.menuBoundaryE7.Index = 5;
			this.menuBoundaryE7.Text = "Slug - Churn (2)";
			this.menuBoundaryE7.Click += new System.EventHandler(this.menuBoundaryE7_Click);
			// 
			// menuBoundaryE8
			// 
			this.menuBoundaryE8.Index = 6;
			this.menuBoundaryE8.Text = "Slug - Churn (3)";
			this.menuBoundaryE8.Click += new System.EventHandler(this.menuBoundaryE8_Click);
			// 
			// menuBoundaryE4
			// 
			this.menuBoundaryE4.Index = 7;
			this.menuBoundaryE4.Text = "Churn - Annular(1)";
			this.menuBoundaryE4.Click += new System.EventHandler(this.menuBoundaryE4_Click);
			// 
			// menuBoundaryE6
			// 
			this.menuBoundaryE6.Index = 8;
			this.menuBoundaryE6.Text = "Churn - Annular(2)";
			this.menuBoundaryE6.Click += new System.EventHandler(this.menuBoundaryE6_Click);
			// 
			// menuBoundaryE5
			// 
			this.menuBoundaryE5.Index = 9;
			this.menuBoundaryE5.Text = "Dispersed bubble - Churn";
			this.menuBoundaryE5.Visible = false;
			this.menuBoundaryE5.Click += new System.EventHandler(this.menuBoundaryE5_Click);
			// 
			// menuConstantQuality
			// 
			this.menuConstantQuality.Index = 7;
			this.menuConstantQuality.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																								this.menuSetQuality,
																								this.menuShowIsoQualityLine,
																								this.menuIsoQualityLineClear,
																								this.menuLine9,
																								this.menuShowAllIsoQualityLine,
																								this.menuShowAllIsoFluxLine});
			this.menuConstantQuality.Text = "Constant Quality Line";
			// 
			// menuSetQuality
			// 
			this.menuSetQuality.Index = 0;
			this.menuSetQuality.Text = "Set Quality";
			this.menuSetQuality.Click += new System.EventHandler(this.menuSetQuality_Click);
			// 
			// menuShowIsoQualityLine
			// 
			this.menuShowIsoQualityLine.Enabled = false;
			this.menuShowIsoQualityLine.Index = 1;
			this.menuShowIsoQualityLine.Text = "Show IsoQuality Line";
			this.menuShowIsoQualityLine.Click += new System.EventHandler(this.menuShowIsoQualityLine_Click);
			// 
			// menuIsoQualityLineClear
			// 
			this.menuIsoQualityLineClear.Index = 2;
			this.menuIsoQualityLineClear.Text = "Clear";
			this.menuIsoQualityLineClear.Click += new System.EventHandler(this.menuIsoQualityLineClear_Click);
			// 
			// menuLine9
			// 
			this.menuLine9.Index = 3;
			this.menuLine9.Text = "-";
			// 
			// menuShowAllIsoQualityLine
			// 
			this.menuShowAllIsoQualityLine.Index = 4;
			this.menuShowAllIsoQualityLine.Text = "Show All IsoQuality Lines";
			this.menuShowAllIsoQualityLine.Click += new System.EventHandler(this.menuShowAllIsoQualityLine_Click);
			// 
			// menuShowAllIsoFluxLine
			// 
			this.menuShowAllIsoFluxLine.Index = 5;
			this.menuShowAllIsoFluxLine.Text = "Show All IsoFlux Lines";
			this.menuShowAllIsoFluxLine.Click += new System.EventHandler(this.menuShowAllIsoFluxLine_Click);
			// 
			// menuExit
			// 
			this.menuExit.Index = 8;
			this.menuExit.Text = "Exit";
			this.menuExit.Click += new System.EventHandler(this.menuExit_Click);
			// 
			// openFileDialog2
			// 
			this.openFileDialog2.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog2_FileOk);
			// 
			// openFileDialog3
			// 
			this.openFileDialog3.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog3_FileOk);
			// 
			// openFileDialog4
			// 
			this.openFileDialog4.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog4_FileOk);
			// 
			// openFileDialog5
			// 
			this.openFileDialog5.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog5_FileOk);
			// 
			// menuBoubdaryF
			// 
			this.menuBoubdaryF.Index = 6;
			this.menuBoubdaryF.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						  this.menuAllBoundariesF,
																						  this.menuLine10,
																						  this.menuBoundaryF1,
																						  this.menuBoundaryF2,
																						  this.menuBoundaryF3,
																						  this.menuBoundaryF4,
																						  this.menuBoundaryF5,
																						  this.menuBoundaryF6});
			this.menuBoubdaryF.Text = "Chen Model 2";
			// 
			// menuAllBoundariesF
			// 
			this.menuAllBoundariesF.Index = 0;
			this.menuAllBoundariesF.Text = "All Boundaries";
			this.menuAllBoundariesF.Click += new System.EventHandler(this.menuAllBoundariesF_Click);
			// 
			// menuLine10
			// 
			this.menuLine10.Index = 1;
			this.menuLine10.Text = "-";
			// 
			// menuBoundaryF1
			// 
			this.menuBoundaryF1.Index = 2;
			this.menuBoundaryF1.Text = "Bubbly - Slug";
			this.menuBoundaryF1.Click += new System.EventHandler(this.menuBoundaryF1_Click);
			// 
			// menuBoundaryF2
			// 
			this.menuBoundaryF2.Index = 3;
			this.menuBoundaryF2.Text = "Dispersed bubble - Bubbly";
			this.menuBoundaryF2.Click += new System.EventHandler(this.menuBoundaryF2_Click);
			// 
			// menuBoundaryF4
			// 
			this.menuBoundaryF4.Index = 5;
			this.menuBoundaryF4.Text = "Slug - Churn (1)";
			this.menuBoundaryF4.Click += new System.EventHandler(this.menuBoundaryF4_Click);
			// 
			// menuBoundaryF5
			// 
			this.menuBoundaryF5.Index = 6;
			this.menuBoundaryF5.Text = "Slug - Churn (2)";
			this.menuBoundaryF5.Click += new System.EventHandler(this.menuBoundaryF5_Click);
			// 
			// menuBoundaryF6
			// 
			this.menuBoundaryF6.Index = 7;
			this.menuBoundaryF6.Text = "Churn - Annular";
			this.menuBoundaryF6.Click += new System.EventHandler(this.menuBoundaryF6_Click);
			// 
			// menuBoundaryF3
			// 
			this.menuBoundaryF3.Index = 4;
			this.menuBoundaryF3.Text = "Dispersed bubble - Churn";
			this.menuBoundaryF3.Click += new System.EventHandler(this.menuBoundaryF3_Click);
			// 
			// FrmFlowPatternGraph
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.BackColor = System.Drawing.Color.White;
			this.ClientSize = new System.Drawing.Size(900, 700);
			this.Menu = this.mainMenu1;
			this.Name = "FrmFlowPatternGraph";
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "Flow Pattern Map";

		}
		#endregion

		public void DrawMap()
		{
			singleMapFlag=true;
			multiMapFlag=false;
			firstMapFlag=false;
			secondMapFlag=false;
			thirdMapFlag=false;
			fourthMapFlag=false;
			menuFile.Enabled=true;
			menuBoubdaryA.Enabled=true;
			menuBoubdaryB.Enabled=true;
			menuBoubdaryC.Enabled=true;
			menuBoubdaryD.Enabled=true;
			menuConstantQuality.Enabled=true;
			menuAllBoundariesA.Checked=false;
			menuAllBoundariesB.Checked=false;
			menuAllBoundariesC.Checked=false;
			menuAllBoundariesD.Checked=false;
			menuShowIsoQualityLine.Checked=false;
			menuSetModelCondition.Checked=false;
			menuFinishSetting.Checked=false;
			isBoundaryA1Valid=false;
			isBoundaryA2Valid=false;
			isBoundaryA3Valid=false;
			isBoundaryA4Valid=false;
			isBoundaryA5Valid=false;
			isBoundaryB1Valid=false;
			isBoundaryB2Valid=false;
			isBoundaryB3Valid=false;
			isBoundaryB4Valid=false;
			isBoundaryB5Valid=false;
			isBoundaryC1Valid=false;
			isBoundaryC2Valid=false;
			isBoundaryC3Valid=false;
			isBoundaryC4Valid=false;
			isBoundaryD1Valid=false;
			isBoundaryD2Valid=false;
			isBoundaryD3Valid=false;
			isBoundaryD4Valid=false;
			isBoundaryD5Valid=false;
			isBoundaryE1Valid=false;
			isBoundaryE2Valid=false;
			isBoundaryE3Valid=false;
			isBoundaryE4Valid=false;
			isBoundaryE5Valid=false;
			isBoundaryE6Valid=false;
			isBoundaryE7Valid=false;
			isBoundaryE8Valid=false;
			isBoundaryF1Valid=false;
			isBoundaryF2Valid=false;
			isBoundaryF3Valid=false;
			isBoundaryF4Valid=false;
			isBoundaryF5Valid=false;
			isBoundaryF6Valid=false;
			includeDispersedBubbleSymbol=false;
			includeConfinedBubbleSymbol=false;
			includeBubblySymbol=false;
			includeBubbleSymbol=false;
			includeIntermittentSymbol=false;
			includeSlugSymbol=false;
			includeChurnSymbol=false;
			includeAnnularSymbol=false;
			includeMistSymbol=false;
			includeTransitionZoneSymbol=false;
			sourceFile=null;
			openFileDialog1.Filter="Text files (*.txt)|*.txt|All files (*.*)|*.*";
			openFileDialog1.ShowDialog();
			if (sourceFile != null)
			{
				this.sourceData(sourceFile);
				this.Show();
			}
		}

		public void DrawModelMap()
		{
			menuFile.Enabled=true;
			menuBoubdaryA.Enabled=false;
			menuBoubdaryB.Enabled=false;
			menuBoubdaryC.Enabled=false;
			menuBoubdaryD.Enabled=false;
			menuConstantQuality.Enabled=false;
			menuAllBoundariesA.Checked=false;
			menuAllBoundariesB.Checked=false;
			menuAllBoundariesC.Checked=false;
			menuAllBoundariesD.Checked=false;
			menuShowIsoQualityLine.Checked=false;
			menuSetModelCondition.Checked=false;
			menuFinishSetting.Checked=false;
			this.Show();
		}

		public void DrawFirstMap()
		{
			menuFile.Enabled=true;
			menuBoubdaryA.Enabled=false;
			menuBoubdaryB.Enabled=false;
			menuBoubdaryC.Enabled=false;
			menuBoubdaryD.Enabled=false;
			menuConstantQuality.Enabled=false;
			singleMapFlag=false;
			multiMapFlag=true;
			firstMapFlag=false;
			secondMapFlag=false;
			thirdMapFlag=false;
			fourthMapFlag=false;
			sourceFile1of4=null;
			openFileDialog2.Filter="Text files (*.txt)|*.txt|All files (*.*)|*.*";
			openFileDialog2.ShowDialog();
			if (sourceFile1of4 != null)
			{
				firstMapFlag=true;
				this.sourceData(sourceFile1of4);
				this.Show();
			}
			else
			{
				sourceFile2of4=null;
				sourceFile3of4=null;
				sourceFile4of4=null;
			}
		}

		public void DrawSecondMap()
		{
			if (sourceFile1of4 != null)
			{
				firstMapFlag=false;
				secondMapFlag=false;
				thirdMapFlag=false;
				fourthMapFlag=false;
				sourceFile2of4=null;
				openFileDialog3.Filter="Text files (*.txt)|*.txt|All files (*.*)|*.*";
				openFileDialog3.ShowDialog();
				if (sourceFile2of4 != null)
				{
					secondMapFlag=true;
					this.sourceData(sourceFile2of4);
					this.Show();
					this.Refresh();
				}
				else
				{
					sourceFile3of4=null;
					sourceFile4of4=null;
				}
			}
		}

		public void DrawThirdMap()
		{
			if (sourceFile2of4 != null)
			{
				firstMapFlag=false;
				secondMapFlag=false;
				thirdMapFlag=false;
				fourthMapFlag=false;
				sourceFile3of4=null;
				openFileDialog4.Filter="Text files (*.txt)|*.txt|All files (*.*)|*.*";
				openFileDialog4.ShowDialog();
				if (sourceFile3of4 != null)
				{
					thirdMapFlag=true;
					this.sourceData(sourceFile3of4);
					this.Show();
					this.Refresh();
				}
				else
				{
					sourceFile4of4=null;
				}
			}
		}

		public void DrawFourthMap()
		{
			if (sourceFile3of4 != null)
			{
				firstMapFlag=false;
				secondMapFlag=false;
				thirdMapFlag=false;
				fourthMapFlag=false;
				sourceFile4of4=null;
				openFileDialog5.Filter="Text files (*.txt)|*.txt|All files (*.*)|*.*";
				openFileDialog5.ShowDialog();
				if (sourceFile4of4 != null)
				{
					fourthMapFlag=true;
					this.sourceData(sourceFile4of4);
					this.Show();
					this.Refresh();
				}
			}
		}

		private void openFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			sourceFile=this.openFileDialog1.FileName;
		}

		private void openFileDialog2_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			sourceFile1of4=this.openFileDialog2.FileName;
		}

		private void openFileDialog3_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			sourceFile2of4=this.openFileDialog3.FileName;
		}

		private void openFileDialog4_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			sourceFile3of4=this.openFileDialog4.FileName;
		}

		private void openFileDialog5_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			sourceFile4of4=this.openFileDialog5.FileName;
		}

		protected override void OnPaint(PaintEventArgs e)
		{
			base.BuildCoordinate();
			this.CheckMenuEnable();
			if (singleMapFlag)
			{
				this.BuildFlowPatternMap();
			}
			if (multiMapFlag)
			{
				this.BuildComparedMap();
			}
			if (this.menuBoundaryA1.Checked||this.menuAllBoundariesA.Checked)
			{
				this.drawingBoundary(startPointA1,endPointA1,boundaryPointA1);
			}
			if (this.menuBoundaryA2.Checked||this.menuAllBoundariesA.Checked)
			{
				this.drawingBoundary(startPointA2,endPointA2,boundaryPointA2);
			}
			if (this.menuBoundaryA3.Checked||this.menuAllBoundariesA.Checked)
			{
				this.drawingBoundary(startPointA3,endPointA3,boundaryPointA3);
			}
			if (this.menuBoundaryA4.Checked||this.menuAllBoundariesA.Checked)
			{
				this.drawingBoundary(startPointA4,endPointA4,boundaryPointA4);
			}
			if (this.menuBoundaryA5.Checked||this.menuAllBoundariesA.Checked)
			{
				this.drawingBoundary(startPointA5,endPointA5,boundaryPointA5);
			}
			if (this.menuBoundaryB1.Checked||this.menuAllBoundariesB.Checked)
			{
				this.drawingBoundary(startPointB1,endPointB1,boundaryPointB1);
			}
			if (this.menuBoundaryB2.Checked||this.menuAllBoundariesB.Checked)
			{
				this.drawingBoundary(startPointB2,endPointB2,boundaryPointB2);
			}
			if (this.menuBoundaryB3.Checked||this.menuAllBoundariesB.Checked)
			{
				this.drawingBoundary(startPointB3,endPointB3,boundaryPointB3);
			}
			if (this.menuBoundaryB4.Checked||this.menuAllBoundariesB.Checked)
			{
				this.drawingBoundary(startPointB4,endPointB4,boundaryPointB4);
			}
			if (this.menuBoundaryB5.Checked||this.menuAllBoundariesB.Checked)
			{
				this.drawingBoundary(startPointB5,endPointB5,boundaryPointB5);
			}
			if (this.menuBoundaryC1.Checked||this.menuAllBoundariesC.Checked)
			{
				this.drawingBoundary(startPointC1,endPointC1,boundaryPointC1);
			}
			if (this.menuBoundaryC2.Checked||this.menuAllBoundariesC.Checked)
			{
				this.drawingBoundary(startPointC2,endPointC2,boundaryPointC2);
			}
			if (this.menuBoundaryC3.Checked||this.menuAllBoundariesC.Checked)
			{
				this.drawingBoundary(startPointC3,endPointC3,boundaryPointC3);
			}
			if (this.menuBoundaryC4.Checked||this.menuAllBoundariesC.Checked)
			{
				this.drawingBoundary(startPointC4,endPointC4,boundaryPointC4);
			}
			if (this.menuBoundaryD1.Checked||this.menuAllBoundariesD.Checked)
			{
				this.drawingBoundary(startPointD1,endPointD1,boundaryPointD1);
			}
			if (this.menuBoundaryD2.Checked||this.menuAllBoundariesD.Checked)
			{
				this.drawingBoundary(startPointD2,endPointD2,boundaryPointD2);
			}
			if (this.menuBoundaryD3.Checked||this.menuAllBoundariesD.Checked)
			{
				this.drawingBoundary(startPointD3,endPointD3,boundaryPointD3);
			}
			if (this.menuBoundaryD4.Checked||this.menuAllBoundariesD.Checked)
			{
				this.drawingBoundary(startPointD4,endPointD4,boundaryPointD4);
			}
			if (this.menuBoundaryD5.Checked||this.menuAllBoundariesD.Checked)
			{
				this.drawingBoundary(startPointD5,endPointD5,boundaryPointD5);
			}
			if (this.menuBoundaryE1.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE1,endPointE1,boundaryPointE1);
			}
			if (this.menuBoundaryE2.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE2,endPointE2,boundaryPointE2);
			}
			if (this.menuBoundaryE3.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE3,endPointE3,boundaryPointE3);
			}
			if (this.menuBoundaryE4.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE4,endPointE4,boundaryPointE4);
			}
			/*if (this.menuBoundaryE5.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE5,endPointE5,boundaryPointE5);
			}*/
			if (this.menuBoundaryE6.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE6,endPointE6,boundaryPointE6);
			}
			if (this.menuBoundaryE7.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE7,endPointE7,boundaryPointE7);
			}
			if (this.menuBoundaryE8.Checked||this.menuAllBoundariesE.Checked)
			{
				this.drawingBoundary(startPointE8,endPointE8,boundaryPointE8);
			}
			if (this.menuBoundaryF1.Checked||this.menuAllBoundariesF.Checked)
			{
				this.drawingBoundary(startPointF1,endPointF1,boundaryPointF1);
			}
			if (this.menuBoundaryF2.Checked||this.menuAllBoundariesF.Checked)
			{
				this.drawingBoundary(startPointF2,endPointF2,boundaryPointF2);
			}
			if (this.menuBoundaryF3.Checked||this.menuAllBoundariesF.Checked)
			{
				this.drawingBoundary(startPointF3,endPointF3,boundaryPointF3);
			}
			if (this.menuBoundaryF4.Checked||this.menuAllBoundariesF.Checked)
			{
				this.drawingBoundary(startPointF4,endPointF4,boundaryPointF4);
			}
			if (this.menuBoundaryF5.Checked||this.menuAllBoundariesF.Checked)
			{
				this.drawingBoundary(startPointF5,endPointF5,boundaryPointF5);
			}
			if (this.menuBoundaryF6.Checked||this.menuAllBoundariesF.Checked)
			{
				this.drawingBoundary(startPointF6,endPointF6,boundaryPointF6);
			}
			if (this.menuShowIsoQualityLine.Checked)
			{
				this.drawingBoundary(startPointCQ,endPointCQ,boundaryPointCQ);
			}
			if (this.menuShowAllIsoQualityLine.Checked)
			{
				for (int i=0;i<Quality.Length;i++)
				{
					this.drawingBoundary(startPointCQs[i],endPointCQs[i],boundaryPointCQs[i]);
					this.QualityTitle(boundaryPointCQs[i][endPointCQs[i]],Quality[i]);
				}
			}
			if (this.menuShowAllIsoFluxLine.Checked)
			{
				for (int i=0;i<MassFlux.Length;i++)
				{
					this.drawingBoundary(startPointMFs[i],endPointMFs[i],boundaryPointMFs[i]);
					this.MassFluxTitle(boundaryPointMFs[i][startPointMFs[i]],MassFlux[i]);
				}
			}
			base.MarkSymbol();
		}

		private void BuildFlowPatternMap()
		{
			for (int i=0;i<this.flowPattern.Length;i++)
			{
				switch(flowPattern[i])
				{
					case "Dispersed Bubble":
						this.dispersedBubbleSymbol(X[i],Y[i]);
						includeDispersedBubbleSymbol=true;
						break;
					case "Confined Bubble":
						this.confinedBubbleSymbol(X[i],Y[i]);
						includeConfinedBubbleSymbol=true;
						break;
					case "Bubbly":
						this.bubblySymbol(X[i],Y[i]);
						includeBubblySymbol=true;
						break;
					case "Bubble":
						this.bubbleSymbol(X[i],Y[i]);
						includeBubbleSymbol=true;
						break;
					case "Intermittent":
						this.intermittentSymbol(X[i],Y[i]);
						includeIntermittentSymbol=true;
						break;
					case "Slug":
						this.slugSymbol(X[i],Y[i]);
						includeSlugSymbol=true;
						break;
					case "Churn":
						this.churnSymbol(X[i],Y[i]);
						includeChurnSymbol=true;
						break;
					case "Annular":
					case "Churn + Annular":
						this.annularSymbol(X[i],Y[i]);
						includeAnnularSymbol=true;
						break;
					case "Mist":
						this.mistSymbol(X[i],Y[i]);
						includeMistSymbol=true;
						break;
					case "Transition Region":
					case "Bubbly - Slug":
					case "Bubbly - Conf. Bubble":
					case "Slug - Churn":
					case "Churn - Annular":
					case "Annular - Mist":
					case "Disp. Bubble - Bubbly":
					case "Disp. Bubble - Slug":
					case "Disp. Bubble - Churn":
					case "Disp. Bubble - Annular":
						this.transitionZoneSymbol(X[i],Y[i]);
						includeTransitionZoneSymbol=true;
						break;
					default:
						break;
				}
			}
		}

		private void BuildComparedMap()
		{
			for (int i=0;i<this.flowPattern.Length;i++)
			{
				switch(flowPattern[i])
				{
					case "Transition Region":
					case "Bubbly - Slug":
					case "Bubbly - Conf. Bubble":
					case "Slug - Churn":
					case "Churn - Annular":
						//case "Annular - Mist":
					case "Disp. Bubble - Bubbly":
					case "Disp. Bubble - Slug":
					case "Disp. Bubble - Churn":
					case "Disp. Bubble - Annular":
						if (firstGroupStartNo<=i & i<=firstGroupEndNo)
						{
							this.transitionZoneSymbolA(X[i],Y[i]);
						}
						else if (secondGroupStartNo<=i & i<=secondGroupEndNo)
						{
							this.transitionZoneSymbolB(X[i],Y[i]);
						}
						else if (thirdGroupStartNo<=i & i<=thirdGroupEndNo)
						{
							this.transitionZoneSymbolC(X[i],Y[i]);
						}
						else if (fourthGroupStartNo<=i & i<=fourthGroupEndNo)
						{
							this.transitionZoneSymbolD(X[i],Y[i]);
						}
						break;
					default:
						break;
				}
			}
		}

		private void CheckMenuEnable()
		{
			if(XaxisTitle!="Gas Superficial Velocity" || YaxisTitle!="Liquid Superficial Velocity")
			{
				this.menuFile.Enabled=false;
				this.menuBoubdaryA.Enabled=false;
				this.menuBoubdaryB.Enabled=false;
				this.menuBoubdaryC.Enabled=false;
				this.menuBoubdaryD.Enabled=false;
				this.menuConstantQuality.Enabled=false;
			}
		}
		private void drawingBoundary(int startPoint,int endPoint,PointF[] boundaryPoint)
		{
			double x,y;

			Graphics boundary=this.CreateGraphics();
			Pen BoundaryPen=new Pen(Color.Black,1);
			PointF [] BoundaryPoint=new PointF[PatternBoundary.GridNumber];
			for (int i=startPoint;i<=endPoint;i++)
			{
				x=boundaryPoint[i].X;
				y=boundaryPoint[i].Y;
				BoundaryPoint[i].X=(float)(mapLocation(x,y).X);
				BoundaryPoint[i].Y=(float)(mapLocation(x,y).Y);
			}
			for (int i=startPoint;i<endPoint;i++)
			{
				boundary.DrawLine(BoundaryPen,BoundaryPoint[i],BoundaryPoint[i+1]);
			}
		}

		private void menuRefresh_Click(object sender, System.EventArgs e)
		{
			this.Refresh();
		}

		private void menuSetModelCondition_Click(object sender, System.EventArgs e)
		{
			modelCondition=new FrmConditionInput();
			modelCondition.Show();
			menuSetModelCondition.Checked=true;
			menuFinishSetting.Enabled=true;
		}

		private void menuFinishSetting_Click(object sender, System.EventArgs e)
		{
			flowPatternBoundary=new PatternBoundary(modelCondition.SetDiameter,modelCondition.SetCondition);
			menuFinishSetting.Checked=true;
			menuBoubdaryA.Enabled=true;
			menuBoubdaryB.Enabled=true;
			menuBoubdaryC.Enabled=true;
			menuBoubdaryD.Enabled=true;
			menuConstantQuality.Enabled=true;
		}
		private void menuBoundaryA1_Click(object sender, System.EventArgs e)
		{
			boundaryPointA1=flowPatternBoundary.BubblyDispersedbubbleBoundary;

			flowPatternBoundary.GetBubblyDispersedbubbleBoundary(out startPointA1,out endPointA1);
			this.drawingBoundary(startPointA1,endPointA1,boundaryPointA1);
			isBoundaryA1Valid=true;
			menuBoundaryA1.Checked=!menuBoundaryA1.Checked;
			this.Refresh();
		}

		private void menuBoundaryA2_Click(object sender, System.EventArgs e)
		{
			boundaryPointA2=flowPatternBoundary.DispersedbubbleChurnBoundary;

			flowPatternBoundary.GetDispersedbubbleChurnBoundary(out startPointA2,out endPointA2);
			this.drawingBoundary(startPointA2,endPointA2,boundaryPointA2);
			isBoundaryA2Valid=true;
			menuBoundaryA2.Checked=!menuBoundaryA2.Checked;
			this.Refresh();
		}

		private void menuBoundaryA3_Click(object sender, System.EventArgs e)
		{
			boundaryPointA3=flowPatternBoundary.IntermitentChurnBoundary;

			flowPatternBoundary.GetIntermitentChurnBoundary(out startPointA3,out endPointA3);
			this.drawingBoundary(startPointA3,endPointA3,boundaryPointA3);
			isBoundaryA3Valid=true;
			menuBoundaryA3.Checked=!menuBoundaryA3.Checked;
			this.Refresh();
		}

		private void menuBoundaryA4_Click(object sender, System.EventArgs e)
		{
			int startPoint1,endPoint1,startPoint2,endPoint2;
			PointF[] boundaryPoint1,boundaryPoint2;

			boundaryPoint1=flowPatternBoundary.ChurnAnnularBoundary1;
			boundaryPoint2=flowPatternBoundary.ChurnAnnularBoundary2;
			boundaryPointA4=flowPatternBoundary.ChurnAnnularBoundary;
			
			flowPatternBoundary.GetChurnAnnularBoundary1(out startPoint1,out endPoint1);
			flowPatternBoundary.GetChurnAnnularBoundary2(out startPoint2,out endPoint2);
			startPointA4=Math.Min(startPoint1,startPoint2);
			endPointA4=Math.Max(endPoint1,endPoint2);
			
			for (int i=startPointA4; i<=endPointA4;i++)
			{
				boundaryPointA4[i].X=Math.Max(boundaryPoint1[i].X,boundaryPoint2[i].X);
				boundaryPointA4[i].Y=Math.Max(boundaryPoint1[i].Y,boundaryPoint2[i].Y);
			}
			this.drawingBoundary(startPointA4,endPointA4,boundaryPointA4);
			isBoundaryA4Valid=true;
			menuBoundaryA4.Checked=!menuBoundaryA4.Checked;
			this.Refresh();
		}
		
		private void menuBoundaryA5_Click(object sender, System.EventArgs e)
		{
			boundaryPointA5=flowPatternBoundary.BubblySlugBoundary;

			flowPatternBoundary.GetBubblySlugBoundary(out startPointA5,out endPointA5);
			this.drawingBoundary(startPointA5,endPointA5,boundaryPointA5);
			isBoundaryA5Valid=true;
			menuBoundaryA5.Checked=!menuBoundaryA5.Checked;
			this.Refresh();
		}
		private void menuAllBoundariesA_Click(object sender, System.EventArgs e)
		{
			this.menuBoundaryA1_Click(sender,e);
			this.menuBoundaryA2_Click(sender,e);
			this.menuBoundaryA3_Click(sender,e);
			this.menuBoundaryA4_Click(sender,e);
			this.menuBoundaryA5_Click(sender,e);
			menuBoundaryA1.Checked=false;
			menuBoundaryA2.Checked=false;
			menuBoundaryA3.Checked=false;
			menuBoundaryA4.Checked=false;
			menuBoundaryA5.Checked=false;
			menuAllBoundariesA.Checked=!menuAllBoundariesA.Checked;
			this.Refresh();
		}

		private void menuBoundaryB1_Click(object sender, System.EventArgs e)
		{
			boundaryPointB1=flowPatternBoundary.ChurnAnnularBoundaryB;

			flowPatternBoundary.GetChurnAnnularBoundaryB(out startPointB1,out endPointB1);
			this.drawingBoundary(startPointB1,endPointB1,boundaryPointB1);
			isBoundaryB1Valid=true;
			menuBoundaryB1.Checked=!menuBoundaryB1.Checked;
			this.Refresh();
		}

		private void menuBoundaryB2_Click(object sender, System.EventArgs e)
		{
			boundaryPointB2=flowPatternBoundary.DispersedbubbleBubblyBoundaryB;

			flowPatternBoundary.GetDispersedbubbleBubblyBoundaryB(out startPointB2,out endPointB2);
			this.drawingBoundary(startPointB2,endPointB2,boundaryPointB2);
			isBoundaryB2Valid=true;
			menuBoundaryB2.Checked=!menuBoundaryB2.Checked;
			this.Refresh();	
		}

		private void menuBoundaryB3_Click(object sender, System.EventArgs e)
		{
			boundaryPointB3=flowPatternBoundary.DispersedbubbleChurnBoundaryB;

			flowPatternBoundary.GetDispersedbubbleChurnBoundaryB(out startPointB3,out endPointB3);
			this.drawingBoundary(startPointB3,endPointB3,boundaryPointB3);
			isBoundaryB3Valid=true;
			menuBoundaryB3.Checked=!menuBoundaryB3.Checked;
			this.Refresh();
		}

		private void menuBoundaryB4_Click(object sender, System.EventArgs e)
		{
			boundaryPointB4=flowPatternBoundary.BubblySlugBoundaryB;

			flowPatternBoundary.GetBubblySlugBoundaryB(out startPointB4,out endPointB4);
			this.drawingBoundary(startPointB4,endPointB4,boundaryPointB4);
			isBoundaryB4Valid=true;
			menuBoundaryB4.Checked=!menuBoundaryB4.Checked;
			this.Refresh();
		}

		private void menuBoundaryB5_Click(object sender, System.EventArgs e)
		{
			boundaryPointB5=flowPatternBoundary.SlugChurnBoundaryB;

			flowPatternBoundary.GetSlugChurnBoundaryB(out startPointB5,out endPointB5);
			this.drawingBoundary(startPointB5,endPointB5,boundaryPointB5);
			isBoundaryB5Valid=true;
			menuBoundaryB5.Checked=!menuBoundaryB5.Checked;
			this.Refresh();
		}

		private void menuAllBoundariesB_Click(object sender, System.EventArgs e)
		{
			this.menuBoundaryB1_Click(sender,e);
			this.menuBoundaryB3_Click(sender,e);
			this.menuBoundaryB2_Click(sender,e);
			this.menuBoundaryB4_Click(sender,e);
			this.menuBoundaryB5_Click(sender,e);
			this.menuBoundaryB3_Click(sender,e);
			this.menuBoundaryB5_Click(sender,e);
			menuBoundaryB1.Checked=false;
			menuBoundaryB2.Checked=false;
			menuBoundaryB3.Checked=false;
			menuBoundaryB4.Checked=false;
			menuBoundaryB5.Checked=false;
			menuAllBoundariesB.Checked=!menuAllBoundariesB.Checked;
			this.Refresh();
		}
		
		private void menuSetLDRatio_Click(object sender, System.EventArgs e)
		{
			inputTaitelModelLDRatio=new FrmSetTaitelModelLDRatio();
			inputTaitelModelLDRatio.Show();
			menuSetLDRatio.Checked=true;
		}

		private void menuBoundaryC1_Click(object sender, System.EventArgs e)
		{
			boundaryPointC1=flowPatternBoundary.BubblySlugBoundaryC;
				
			flowPatternBoundary.GetBubblySlugBoundaryC(out startPointC1,out endPointC1);
			this.drawingBoundary(startPointC1,endPointC1,boundaryPointC1);
			isBoundaryC1Valid=true;
			menuBoundaryC1.Checked=!menuBoundaryC1.Checked;
			this.Refresh();
		}

		private void menuBoundaryC2_Click(object sender, System.EventArgs e)
		{
			boundaryPointC2=flowPatternBoundary.SlugChurnBoundaryC;

			flowPatternBoundary.GetSlugChurnBoundaryC(out startPointC2,out endPointC2);
			this.drawingBoundary(startPointC2,endPointC2,boundaryPointC2);
			isBoundaryC2Valid=true;
			menuBoundaryC2.Checked=!menuBoundaryC2.Checked;
			this.Refresh();
		}

		private void menuBoundaryC3_Click(object sender, System.EventArgs e)
		{
			boundaryPointC3=flowPatternBoundary.SlugAnnularBoundaryC;

			flowPatternBoundary.GetSlugAnnularBoundaryC(out startPointC3,out endPointC3);
			this.drawingBoundary(startPointC3,endPointC3,boundaryPointC3);
			isBoundaryC3Valid=true;
			menuBoundaryC3.Checked=!menuBoundaryC3.Checked;
			this.Refresh();
		}

		private void menuBoundaryC4_Click(object sender, System.EventArgs e)
		{
			boundaryPointC4=flowPatternBoundary.ChurnAnnularBoundaryC;

			flowPatternBoundary.GetChurnAnnularBoundaryC(out startPointC4,out endPointC4);
			this.drawingBoundary(startPointC4,endPointC4,boundaryPointC4);
			isBoundaryC4Valid=true;
			menuBoundaryC4.Checked=!menuBoundaryC4.Checked;
			this.Refresh();
		}

		private void menuAllBoundariesC_Click(object sender, System.EventArgs e)
		{
			this.menuBoundaryC1_Click(sender,e);
			this.menuBoundaryC2_Click(sender,e);
			this.menuBoundaryC3_Click(sender,e);
			this.menuBoundaryC4_Click(sender,e);
			this.menuBoundaryC2_Click(sender,e);
			menuBoundaryC1.Checked=false;
			menuBoundaryC2.Checked=false;
			menuBoundaryC3.Checked=false;
			menuBoundaryC4.Checked=false;
			menuAllBoundariesC.Checked=!menuAllBoundariesC.Checked;
			this.Refresh();
		}

		private void menuBoundaryD1_Click(object sender, System.EventArgs e)
		{
			boundaryPointD1=flowPatternBoundary.BubblyPlugChurnBoundaryD;

			flowPatternBoundary.GetBubblyPlugChurnBoundaryD(out startPointD1,out endPointD1);
			this.drawingBoundary(startPointD1,endPointD1,boundaryPointD1);
			isBoundaryD1Valid=true;
			menuBoundaryD1.Checked=!menuBoundaryD1.Checked;
			this.Refresh();
		}

		private void menuBoundaryD2_Click(object sender, System.EventArgs e)
		{
			boundaryPointD2=flowPatternBoundary.DispersedbubbleChurnBoundaryD;

			flowPatternBoundary.GetDispersedbubbleChurnBoundaryD(out startPointD2,out endPointD2);
			this.drawingBoundary(startPointD2,endPointD2,boundaryPointD2);
			isBoundaryD2Valid=true;
			menuBoundaryD2.Checked=!menuBoundaryD2.Checked;
			this.Refresh();
		}

		private void menuBoundaryD3_Click(object sender, System.EventArgs e)
		{
			boundaryPointD3=flowPatternBoundary.FromDispersedbubbleBoundaryD;

			flowPatternBoundary.GetFromDispersedbubbleBoundaryD(out startPointD3,out endPointD3);
			this.drawingBoundary(startPointD3,endPointD3,boundaryPointD3);
			isBoundaryD3Valid=true;
			menuBoundaryD3.Checked=!menuBoundaryD3.Checked;
			this.Refresh();
		}

		private void menuBoundaryD4_Click(object sender, System.EventArgs e)
		{
			boundaryPointD4=flowPatternBoundary.PlugChurnBoundaryD;

			flowPatternBoundary.GetPlugChurnBoundaryD(out startPointD4,out endPointD4);
			this.drawingBoundary(startPointD4,endPointD4,boundaryPointD4);
			isBoundaryD4Valid=true;
			menuBoundaryD4.Checked=!menuBoundaryD4.Checked;
			this.Refresh();
		}

		private void menuBoundaryD5_Click(object sender, System.EventArgs e)
		{
			boundaryPointD5=flowPatternBoundary.FromAnnularBoundaryD;

			flowPatternBoundary.GetFromAnnularBoundaryD(out startPointD5,out endPointD5);
			this.drawingBoundary(startPointD5,endPointD5,boundaryPointD5);
			isBoundaryD5Valid=true;
			menuBoundaryD5.Checked=!menuBoundaryD5.Checked;
			this.Refresh();
		}

		private void menuAllBoundariesD_Click(object sender, System.EventArgs e)
		{
			this.menuBoundaryD5_Click(sender,e);
			this.menuBoundaryD3_Click(sender,e);
			this.menuBoundaryD2_Click(sender,e);
			this.menuBoundaryD1_Click(sender,e);
			this.menuBoundaryD4_Click(sender,e);
			this.menuBoundaryD3_Click(sender,e);
			menuBoundaryD1.Checked=false;
			menuBoundaryD2.Checked=false;
			menuBoundaryD3.Checked=false;
			menuBoundaryD4.Checked=false;
			menuBoundaryD5.Checked=false;
			menuAllBoundariesD.Checked=!menuAllBoundariesD.Checked;
			this.Refresh();
		}

		private void menuSetPlugChurnCriticalConstant_Click(object sender, System.EventArgs e)
		{
			inputMcQuillanWhalleyModelConstant=new FrmSetMcQuillanWhalleyModelConstant();
			inputMcQuillanWhalleyModelConstant.Show();
			menuSetPlugChurnCriticalConstant.Checked=true;
		}
		private void menuSetQuality_Click(object sender, System.EventArgs e)
		{
			inputData=new FrmConstantQualityLineInputData();
			inputData.Show();
			this.menuShowIsoQualityLine.Enabled=true;
		}

		private void menuShowIsoQualityLine_Click(object sender, System.EventArgs e)
		{
			boundaryPointCQ=flowPatternBoundary.ConstantQualityBoundary;
			flowPatternBoundary.GetConstantQualityBoundary(out startPointCQ,out endPointCQ,inputData.SetQuality);
			this.drawingBoundary(startPointCQ,endPointCQ,boundaryPointCQ);
			menuShowIsoQualityLine.Enabled=false;
			menuShowIsoQualityLine.Checked=true;
			this.Refresh();
		}
		private void menuIsoQualityLineClear_Click(object sender, System.EventArgs e)
		{
			this.menuShowIsoQualityLine.Checked=false;
			this.Refresh();
		}
		private void menuShowAllIsoQualityLine_Click(object sender, System.EventArgs e)
		{
			for (int i=0;i<Quality.Length;i++)
			{
				boundaryPointCQs=flowPatternBoundary.ConstantQualitiesBoundary;
				flowPatternBoundary.GetConstantQualitiesBoundary(out startPointCQs[i],out endPointCQs[i],Quality[i],i);
				this.drawingBoundary(startPointCQs[i],endPointCQs[i],boundaryPointCQs[i]);
				this.QualityTitle(boundaryPointCQs[i][endPointCQs[i]],Quality[i]);
			}
			isBoundaryCQsValid=true;
			menuShowAllIsoQualityLine.Checked=!menuShowAllIsoQualityLine.Checked;
			this.Refresh();
		}

		private void QualityTitle(PointF EndPoint,double Quality)
		{
			float x,y;
			x=EndPoint.X;
			y=EndPoint.Y;
			coordinateSystem.TranslateTransform(mapLocation(x,y).X,mapLocation(x,y).Y); //set new origin for Y coordinate title
			coordinateSystem.RotateTransform(-52); //rotate coordinateSystem system -52 degree
			coordinateSystem.DrawString("x=",smallFont,Brushes.Black,3,-8);
			coordinateSystem.DrawString(Quality.ToString(),smallFont,Brushes.Black,20,-8);
			coordinateSystem.RotateTransform(52); //rotate coordinateSystem system back
			coordinateSystem.TranslateTransform(-mapLocation(x,y).X,-mapLocation(x,y).Y); //recover the original origin
		}

		private void menuShowAllIsoFluxLine_Click(object sender, System.EventArgs e)
		{
			for (int i=0;i<MassFlux.Length;i++)
			{
				boundaryPointMFs=flowPatternBoundary.ConstantMassFluxBoundary;
				flowPatternBoundary.GetConstantMassFluxBoundary(out startPointMFs[i],out endPointMFs[i],MassFlux[i],i);
				this.drawingBoundary(startPointMFs[i],endPointMFs[i],boundaryPointMFs[i]);
				this.MassFluxTitle(boundaryPointMFs[i][startPointMFs[i]],MassFlux[i]);
			}
			isBoundaryMFsValid=true;
			menuShowAllIsoFluxLine.Checked=!menuShowAllIsoFluxLine.Checked;
			this.Refresh();	
		}

		private void MassFluxTitle(PointF StartPoint,double MassFlux)
		{
			float x,y;
			x=StartPoint.X;
			y=StartPoint.Y;
			coordinateSystem.TranslateTransform(mapLocation(x,y).X,mapLocation(x,y).Y); //set new origin for Y coordinate title
			coordinateSystem.DrawString("G=",smallFont,Brushes.Black,3,-18);
			coordinateSystem.DrawString(MassFlux.ToString(),smallFont,Brushes.Black,25,-18);
			if (MassFlux>=10 && MassFlux<100)
			{
				coordinateSystem.DrawString("kg/m s",smallFont,Brushes.Black,53-9,-18);
				coordinateSystem.DrawString("2",tinyFont,Brushes.Black,87-9,-20);
			}
			if (MassFlux>=100 && MassFlux<1000)
			{
				coordinateSystem.DrawString("kg/m s",smallFont,Brushes.Black,53,-18);
				coordinateSystem.DrawString("2",tinyFont,Brushes.Black,87,-20);
			}
			if (MassFlux>=1000 && MassFlux<10000)
			{
				coordinateSystem.DrawString("kg/m s",smallFont,Brushes.Black,53+9,-18);
				coordinateSystem.DrawString("2",tinyFont,Brushes.Black,87+9,-20);
			}
			coordinateSystem.TranslateTransform(-mapLocation(x,y).X,-mapLocation(x,y).Y); //recover the original origin
		}

		private void menuExit_Click(object sender, System.EventArgs e)
		{
			this.Hide();
		}

		private void menuBoundaryE1_Click(object sender, System.EventArgs e)
			// Bubbly-slug boundary
		{
			boundaryPointE1=flowPatternBoundary.BubblySlugBoundaryE;			
			flowPatternBoundary.GetBubblySlugBoundaryE(out startPointE1,out endPointE1);
			this.drawingBoundary(startPointE1,endPointE1,boundaryPointE1);
			isBoundaryE1Valid=true;
			menuBoundaryE1.Checked=!menuBoundaryE1.Checked;
			this.Refresh();	
		}

		private void menuBoundaryE2_Click(object sender, System.EventArgs e)
			//Dispersed bubble-bubbly boundary
		{
			boundaryPointE2=flowPatternBoundary.DispersedbubbleBubblyBoundaryE;			
			flowPatternBoundary.GetDispersedbubbleBubblyBoundaryE(out startPointE2,out endPointE2);
			this.drawingBoundary(startPointE2,endPointE2,boundaryPointE2);
			isBoundaryE2Valid=true;
			menuBoundaryE2.Checked=!menuBoundaryE2.Checked;
			this.Refresh();	
		}

		private void menuBoundaryE3_Click(object sender, System.EventArgs e)
			//Slug-churn boundary @ high Uls region (1)
		{
			boundaryPointE3=flowPatternBoundary.SlugChurnBoundaryE1;			
			flowPatternBoundary.GetSlugChurnBoundaryE1(out startPointE3,out endPointE3);
			this.drawingBoundary(startPointE3,endPointE3,boundaryPointE3);
			isBoundaryE3Valid=true;
			menuBoundaryE3.Checked=!menuBoundaryE3.Checked;
			this.Refresh();	
		}

		private void menuBoundaryE7_Click(object sender, System.EventArgs e)
			//Slug-churn boundary @ middle Uls region (2)
		{
			boundaryPointE7=flowPatternBoundary.SlugChurnBoundaryE2;			
			flowPatternBoundary.GetSlugChurnBoundaryE2(out startPointE7,out endPointE7);
			this.drawingBoundary(startPointE7,endPointE7,boundaryPointE7);
			isBoundaryE7Valid=true;
			menuBoundaryE7.Checked=!menuBoundaryE7.Checked;
			this.Refresh();	
		}

		private void menuBoundaryE8_Click(object sender, System.EventArgs e)
			//Slug-churn boundary @ low Uls region (3)
		{
			boundaryPointE8=flowPatternBoundary.SlugChurnBoundaryE3;			
			flowPatternBoundary.GetSlugChurnBoundaryE3(out startPointE8,out endPointE8);
			this.drawingBoundary(startPointE8,endPointE8,boundaryPointE8);
			isBoundaryE8Valid=true;
			menuBoundaryE8.Checked=!menuBoundaryE8.Checked;
			this.Refresh();			
		}

		private void menuBoundaryE4_Click(object sender, System.EventArgs e)
			//Churn-annular boundary (1)
		{
			boundaryPointE4=flowPatternBoundary.ChurnAnnularBoundaryE1;			
			flowPatternBoundary.GetChurnAnnularBoundaryE1(out startPointE4,out endPointE4);
			this.drawingBoundary(startPointE4,endPointE4,boundaryPointE4);
			isBoundaryE4Valid=true;
			menuBoundaryE4.Checked=!menuBoundaryE4.Checked;
			this.Refresh();		
		}

		private void menuBoundaryE6_Click(object sender, System.EventArgs e)
			//Churn-annular boundary (2)
		{
			boundaryPointE6=flowPatternBoundary.ChurnAnnularBoundaryE2;			
			flowPatternBoundary.GetChurnAnnularBoundaryE2(out startPointE6,out endPointE6);
			this.drawingBoundary(startPointE6,endPointE6,boundaryPointE6);
			isBoundaryE6Valid=true;
			menuBoundaryE6.Checked=!menuBoundaryE6.Checked;
			this.Refresh();		
		}

		private void menuBoundaryE5_Click(object sender, System.EventArgs e)
			//Dispersed bubble-churn boundary
		{
			boundaryPointE5=flowPatternBoundary.DispersedbubbleChurnBoundaryE;
			flowPatternBoundary.GetDispersedbubbleChurnBoundaryE(out startPointE5,out endPointE5);
			this.drawingBoundary(startPointE5,endPointE5,boundaryPointE5);
			isBoundaryE5Valid=true;
			menuBoundaryE5.Checked=!menuBoundaryE5.Checked;
			this.Refresh();
		}
		private void menuAllBoundariesE_Click(object sender, System.EventArgs e)
		{
			this.menuBoundaryE4_Click(sender,e);
			this.menuBoundaryE6_Click(sender,e);
			this.menuBoundaryE4_Click(sender,e);
			this.menuBoundaryE4_Click(sender,e);
			this.menuBoundaryE1_Click(sender,e);
			this.menuBoundaryE2_Click(sender,e);
			this.menuBoundaryE3_Click(sender,e);
			this.menuBoundaryE8_Click(sender,e);
			this.menuBoundaryE7_Click(sender,e);
			this.menuBoundaryE3_Click(sender,e);
			this.menuBoundaryE3_Click(sender,e);
			this.menuBoundaryE8_Click(sender,e);
			this.menuBoundaryE8_Click(sender,e);
			menuBoundaryE1.Checked=false;
			menuBoundaryE2.Checked=false;
			menuBoundaryE3.Checked=false;
			menuBoundaryE4.Checked=false;
			menuBoundaryE5.Checked=false;
			menuBoundaryE6.Checked=false;
			menuBoundaryE7.Checked=false;
			menuBoundaryE8.Checked=false;
			menuAllBoundariesE.Checked=!menuAllBoundariesE.Checked;
			this.Refresh();
		}

		private void menuBoundaryF1_Click(object sender, System.EventArgs e)
			// Bubbly-slug boundary
		{
			boundaryPointF1=flowPatternBoundary.BubblySlugBoundaryF;			
			flowPatternBoundary.GetBubblySlugBoundaryF(out startPointF1,out endPointF1);
			this.drawingBoundary(startPointF1,endPointF1,boundaryPointF1);
			isBoundaryF1Valid=true;
			menuBoundaryF1.Checked=!menuBoundaryF1.Checked;
			this.Refresh();	
		}

		private void menuBoundaryF2_Click(object sender, System.EventArgs e)
			//Dispersed bubble-bubbly boundary
		{
			boundaryPointF2=flowPatternBoundary.DispersedbubbleBubblyBoundaryF;			
			flowPatternBoundary.GetDispersedbubbleBubblyBoundaryF(out startPointF2,out endPointF2);
			this.drawingBoundary(startPointF2,endPointF2,boundaryPointF2);
			isBoundaryF2Valid=true;
			menuBoundaryF2.Checked=!menuBoundaryF2.Checked;
			this.Refresh();	
		}

		private void menuBoundaryF3_Click(object sender, System.EventArgs e)
			//Dispersed bubble-churn boundary
		{
			boundaryPointF3=flowPatternBoundary.DispersedbubbleChurnBoundaryF;
			flowPatternBoundary.GetDispersedbubbleChurnBoundaryF(out startPointF3,out endPointF3);
			this.drawingBoundary(startPointF3,endPointF3,boundaryPointF3);
			isBoundaryF3Valid=true;
			menuBoundaryF3.Checked=!menuBoundaryF3.Checked;
			this.Refresh();
		}

		private void menuBoundaryF4_Click(object sender, System.EventArgs e)
			//Slug-churn boundary @ high Uls region (1)
		{
			boundaryPointF4=flowPatternBoundary.SlugChurnBoundaryF1;			
			flowPatternBoundary.GetSlugChurnBoundaryF1(out startPointF4,out endPointF4);
			this.drawingBoundary(startPointF4,endPointF4,boundaryPointF4);
			isBoundaryF4Valid=true;
			menuBoundaryF4.Checked=!menuBoundaryF4.Checked;
			this.Refresh();	
		}

		private void menuBoundaryF5_Click(object sender, System.EventArgs e)
			//Slug-churn boundary @ middle Uls region (2)
		{
			boundaryPointF5=flowPatternBoundary.SlugChurnBoundaryF2;			
			flowPatternBoundary.GetSlugChurnBoundaryF2(out startPointF5,out endPointF5);
			this.drawingBoundary(startPointF5,endPointF5,boundaryPointF5);
			isBoundaryF5Valid=true;
			menuBoundaryF5.Checked=!menuBoundaryF5.Checked;
			this.Refresh();	
		}

		private void menuBoundaryF6_Click(object sender, System.EventArgs e)
			//Churn-annular boundary
		{
			boundaryPointF6=flowPatternBoundary.ChurnAnnularBoundaryF;			
			flowPatternBoundary.GetChurnAnnularBoundaryF(out startPointF6,out endPointF6);
			this.drawingBoundary(startPointF6,endPointF6,boundaryPointF6);
			isBoundaryF6Valid=true;
			menuBoundaryF6.Checked=!menuBoundaryF6.Checked;
			this.Refresh();			
		}

		private void menuAllBoundariesF_Click(object sender, System.EventArgs e)
		{
			this.menuBoundaryF6_Click(sender,e);
			this.menuBoundaryF3_Click(sender,e);
			this.menuBoundaryF2_Click(sender,e);
			this.menuBoundaryF1_Click(sender,e);
			this.menuBoundaryF3_Click(sender,e);
			this.menuBoundaryF5_Click(sender,e);
			this.menuBoundaryF4_Click(sender,e);
			this.menuBoundaryF5_Click(sender,e);
			menuBoundaryF1.Checked=false;
			menuBoundaryF2.Checked=false;
			menuBoundaryF3.Checked=false;
			menuBoundaryF4.Checked=false;
			menuBoundaryF5.Checked=false;
			menuBoundaryF6.Checked=false;
			menuAllBoundariesF.Checked=!menuAllBoundariesF.Checked;
			this.Refresh();
		}

	}

	public class Symbol: Coordinate
	{
		/// <summary>
		/// Drawing and locating flow pattern symbols
		/// </summary>
		
		private int symbolSize=8;
		protected bool includeDispersedBubbleSymbol,includeConfinedBubbleSymbol,includeBubblySymbol,includeBubbleSymbol,includeIntermittentSymbol;
		protected bool includeSlugSymbol,includeChurnSymbol,includeAnnularSymbol,includeMistSymbol,includeTransitionZoneSymbol;
		protected PointF mapLocation(double x,double y)
		{
			PointF center=new PointF();
			Point P=base.origin;
			switch (XaxisScale)
			{
				case ("Linear"):
					center.X=P.X+(float)(base.XaxisDivisionNo*base.XaxisUnitLength*(x-base.Xmin)/(base.Xmax-base.Xmin));
					break;
				default:
					center.X=P.X+(float)(base.XaxisUnitLength*Math.Log10(x/base.Xmin));
					break;
			}
			switch (YaxisScale)
			{
				case ("Linear"):
					center.Y=P.Y-(float)(base.YaxisDivisionNo*base.YaxisUnitLength*(y-base.Ymin)/(base.Ymax-base.Ymin));
					break;
				default:
					center.Y=P.Y-(float)(base.YaxisUnitLength*Math.Log10(y/base.Ymin));
					break;
			}
			return center;
		}

		protected void dispersedBubbleSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Brush DispersedBubbleBrush=Brushes.Blue;
			symbol.FillEllipse(DispersedBubbleBrush,mapLocation(x,y).X-symbolSize/2,mapLocation(x,y).Y-symbolSize/2,symbolSize,symbolSize);
		}

		protected void confinedBubbleSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen ConfinedBubblePen=new Pen(Color.DarkViolet,1);
			PointF [] trianglePeak=new PointF[3];
			trianglePeak[0].X=mapLocation(x,y).X-symbolSize/2;
			trianglePeak[0].Y=(float)(mapLocation(x,y).Y-Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[1].X=mapLocation(x,y).X+symbolSize/2;
			trianglePeak[1].Y=(float)(mapLocation(x,y).Y-Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[2].X=mapLocation(x,y).X;
			trianglePeak[2].Y=(float)(mapLocation(x,y).Y+symbolSize/2/Math.Cos(Math.PI/6));
			symbol.DrawLine(ConfinedBubblePen,trianglePeak[0],trianglePeak[1]);
			symbol.DrawLine(ConfinedBubblePen,trianglePeak[1],trianglePeak[2]);
			symbol.DrawLine(ConfinedBubblePen,trianglePeak[2],trianglePeak[0]);
		}

		protected void bubblySymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen BubblyPen=new Pen(Color.Red,1);
			symbol.DrawEllipse(BubblyPen,mapLocation(x,y).X-symbolSize/2,mapLocation(x,y).Y-symbolSize/2,symbolSize,symbolSize);
		}

		protected void bubbleSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen BubblePen=new Pen(Color.Red,1);
			symbol.DrawEllipse(BubblePen,mapLocation(x,y).X-symbolSize/2,mapLocation(x,y).Y-symbolSize/2,symbolSize,symbolSize);
		}

		protected void intermittentSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen IntermittentPen=new Pen(Color.Brown,1);
			PointF [] trianglePeak=new PointF[3];
			trianglePeak[0].X=mapLocation(x,y).X-symbolSize/2;
			trianglePeak[0].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[1].X=mapLocation(x,y).X+symbolSize/2;
			trianglePeak[1].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[2].X=mapLocation(x,y).X;
			trianglePeak[2].Y=(float)(mapLocation(x,y).Y-symbolSize/2/Math.Cos(Math.PI/6));
			symbol.DrawLine(IntermittentPen,trianglePeak[0],trianglePeak[1]);
			symbol.DrawLine(IntermittentPen,trianglePeak[1],trianglePeak[2]);
			symbol.DrawLine(IntermittentPen,trianglePeak[2],trianglePeak[0]);
		}

		protected void slugSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Brush SlugBrush=Brushes.Brown;
			symbol.FillRectangle(SlugBrush,mapLocation(x,y).X-symbolSize/2,mapLocation(x,y).Y-symbolSize/2,symbolSize,symbolSize);
		}

		protected void churnSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen ChurnPen=new Pen(Color.Cyan,1);
			PointF [] trianglePeak=new PointF[3];
			trianglePeak[0].X=mapLocation(x,y).X-symbolSize/2;
			trianglePeak[0].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[1].X=mapLocation(x,y).X+symbolSize/2;
			trianglePeak[1].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[2].X=mapLocation(x,y).X;
			trianglePeak[2].Y=(float)(mapLocation(x,y).Y-symbolSize/2/Math.Cos(Math.PI/6));
			symbol.DrawLine(ChurnPen,trianglePeak[0],trianglePeak[1]);
			symbol.DrawLine(ChurnPen,trianglePeak[1],trianglePeak[2]);
			symbol.DrawLine(ChurnPen,trianglePeak[2],trianglePeak[0]);
		}

		protected void annularSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen AnnularPen=new Pen(Color.Green,1);
			symbol.DrawRectangle(AnnularPen,mapLocation(x,y).X-symbolSize/2,mapLocation(x,y).Y-symbolSize/2,symbolSize,symbolSize);
		}

		protected void mistSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Brush MistBrush=Brushes.Violet;
			PointF [] trianglePeak=new PointF[3];
			trianglePeak[0].X=mapLocation(x,y).X-symbolSize/2;
			trianglePeak[0].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[1].X=mapLocation(x,y).X+symbolSize/2;
			trianglePeak[1].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[2].X=mapLocation(x,y).X;
			trianglePeak[2].Y=(float)(mapLocation(x,y).Y-symbolSize/2/Math.Cos(Math.PI/6));
			symbol.FillClosedCurve(MistBrush,trianglePeak);
		}

		protected void transitionZoneSymbol(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen TransitionZonePen=new Pen(Color.Black,1);
			PointF [] crossPeak=new PointF[4];
			crossPeak[0].X=(float)(mapLocation(x,y).X-symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[0].Y=(float)(mapLocation(x,y).Y+symbolSize/2*Math.Cos(Math.PI/4));
			crossPeak[1].X=(float)(mapLocation(x,y).X+symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[1].Y=(float)(mapLocation(x,y).Y+symbolSize/2*Math.Cos(Math.PI/4));
			crossPeak[2].X=(float)(mapLocation(x,y).X+symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[2].Y=(float)(mapLocation(x,y).Y-symbolSize/2*Math.Cos(Math.PI/4));
			crossPeak[3].X=(float)(mapLocation(x,y).X-symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[3].Y=(float)(mapLocation(x,y).Y-symbolSize/2*Math.Cos(Math.PI/4));
			symbol.DrawLine(TransitionZonePen,crossPeak[0],crossPeak[2]);
			symbol.DrawLine(TransitionZonePen,crossPeak[1],crossPeak[3]);
		}

		protected void transitionZoneSymbolA(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen TransitionZonePen=new Pen(Color.Black,1);
			PointF [] crossPeak=new PointF[4];
			crossPeak[0].X=(float)(mapLocation(x,y).X-symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[0].Y=(float)(mapLocation(x,y).Y+symbolSize/2*Math.Cos(Math.PI/4));
			crossPeak[1].X=(float)(mapLocation(x,y).X+symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[1].Y=(float)(mapLocation(x,y).Y+symbolSize/2*Math.Cos(Math.PI/4));
			crossPeak[2].X=(float)(mapLocation(x,y).X+symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[2].Y=(float)(mapLocation(x,y).Y-symbolSize/2*Math.Cos(Math.PI/4));
			crossPeak[3].X=(float)(mapLocation(x,y).X-symbolSize/2*Math.Sin(Math.PI/4));
			crossPeak[3].Y=(float)(mapLocation(x,y).Y-symbolSize/2*Math.Cos(Math.PI/4));
			symbol.DrawLine(TransitionZonePen,crossPeak[0],crossPeak[2]);
			symbol.DrawLine(TransitionZonePen,crossPeak[1],crossPeak[3]);
			/*Graphics symbol=this.CreateGraphics();
			Brush TransitionZoneBrush=Brushes.Blue;
			PointF [] trianglePeak=new PointF[3];
			trianglePeak[0].X=mapLocation(x,y).X-symbolSize/2;
			trianglePeak[0].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[1].X=mapLocation(x,y).X+symbolSize/2;
			trianglePeak[1].Y=(float)(mapLocation(x,y).Y+Math.Tan(Math.PI/6)*symbolSize/2);
			trianglePeak[2].X=mapLocation(x,y).X;
			trianglePeak[2].Y=(float)(mapLocation(x,y).Y-symbolSize/2/Math.Cos(Math.PI/6));
			symbol.FillClosedCurve(TransitionZoneBrush,trianglePeak);*/
		}

		protected void transitionZoneSymbolB(double x,double y)
		{
			/*Graphics symbol=this.CreateGraphics();
			Pen TransitionZonePen=new Pen(Color.Red,1);
			PointF [] crossPeak=new PointF[4];
			crossPeak[0].X=(float)(mapLocation(x,y).X-symbolSize/2);
			crossPeak[0].Y=(float)(mapLocation(x,y).Y);
			crossPeak[1].X=(float)(mapLocation(x,y).X);
			crossPeak[1].Y=(float)(mapLocation(x,y).Y-symbolSize/2);
			crossPeak[2].X=(float)(mapLocation(x,y).X+symbolSize/2);
			crossPeak[2].Y=(float)(mapLocation(x,y).Y);
			crossPeak[3].X=(float)(mapLocation(x,y).X);
			crossPeak[3].Y=(float)(mapLocation(x,y).Y+symbolSize/2);
			symbol.DrawLine(TransitionZonePen,crossPeak[0],crossPeak[2]);
			symbol.DrawLine(TransitionZonePen,crossPeak[1],crossPeak[3]);*/
			Graphics symbol=this.CreateGraphics();
			Pen TransitionZonePen=new Pen(Color.Red,1);
			symbol.DrawEllipse(TransitionZonePen,mapLocation(x,y).X-symbolSize/2,mapLocation(x,y).Y-symbolSize/2,symbolSize,symbolSize);
		}

		protected void transitionZoneSymbolC(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Brush TransitionZoneBrush=Brushes.Green;
			symbol.FillRectangle(TransitionZoneBrush,mapLocation(x,y).X-symbolSize/2,mapLocation(x,y).Y-symbolSize/2,symbolSize,symbolSize);
		}

		protected void transitionZoneSymbolD(double x,double y)
		{
			Graphics symbol=this.CreateGraphics();
			Pen TransitionZonePen=new Pen(Color.Blue,1);
			PointF [] crossPeak=new PointF[4];
			crossPeak[0].X=(float)(mapLocation(x,y).X-symbolSize/2);
			crossPeak[0].Y=(float)(mapLocation(x,y).Y);
			crossPeak[1].X=(float)(mapLocation(x,y).X);
			crossPeak[1].Y=(float)(mapLocation(x,y).Y-symbolSize/2);
			crossPeak[2].X=(float)(mapLocation(x,y).X+symbolSize/2);
			crossPeak[2].Y=(float)(mapLocation(x,y).Y);
			crossPeak[3].X=(float)(mapLocation(x,y).X);
			crossPeak[3].Y=(float)(mapLocation(x,y).Y+symbolSize/2);
			symbol.DrawLine(TransitionZonePen,crossPeak[0],crossPeak[2]);
			symbol.DrawLine(TransitionZonePen,crossPeak[1],crossPeak[3]);		
		}

		protected void MarkSymbol()
		{
			double [] symbolPositionX=new double[8];
			double [] symbolPositionY=new double[8];
//			double [] symbolTitlePositionX=new double[7];
//			double [] symbolTitlePositionY=new double[7];
			for (int i=0; i<=7; i++)
			{
				switch (XaxisScale)
				{
					case ("Linear"):
						symbolPositionX[i]=Xmin+0.8*(Xmax-Xmin);
						break;
					default:
						symbolPositionX[i]=0.2*Xmax;
						break;
				}
				switch (YaxisScale)
				{
					case ("Linear"):
						symbolPositionY[i]=Ymin+0.06*(i+1)*(Ymax-Ymin);
						break;
					default:
						symbolPositionY[i]=Ymin*Math.Pow(1.5,(i+1)*Math.Log10(Ymax/Ymin)/3.0);
						break;
				}
			}

			if (singleMapFlag)
			{
				switch (fluid)
				{
					case ("R134a"):
					{
						this.bubblySymbol(symbolPositionX[0],symbolPositionY[0]);
						base.coordinateSystem.DrawString("Bubbly", smallFont,Brushes.Black,mapLocation(symbolPositionX[0],symbolPositionY[0]).X+15,mapLocation(symbolPositionX[0],symbolPositionY[0]).Y-8);
						this.confinedBubbleSymbol(symbolPositionX[1],symbolPositionY[1]);
						base.coordinateSystem.DrawString("Confined Bubble", smallFont,Brushes.Black,mapLocation(symbolPositionX[1],symbolPositionY[1]).X+15,mapLocation(symbolPositionX[1],symbolPositionY[1]).Y-8);
						this.dispersedBubbleSymbol(symbolPositionX[2],symbolPositionY[2]);
						base.coordinateSystem.DrawString("Dispersed Bubble", smallFont,Brushes.Black,mapLocation(symbolPositionX[2],symbolPositionY[2]).X+15,mapLocation(symbolPositionX[2],symbolPositionY[2]).Y-8);
						this.slugSymbol(symbolPositionX[3],symbolPositionY[3]);
						base.coordinateSystem.DrawString("Slug", smallFont,Brushes.Black,mapLocation(symbolPositionX[3],symbolPositionY[3]).X+15,mapLocation(symbolPositionX[3],symbolPositionY[3]).Y-8);
						this.churnSymbol(symbolPositionX[4],symbolPositionY[4]);
						base.coordinateSystem.DrawString("Churn", smallFont,Brushes.Black,mapLocation(symbolPositionX[4],symbolPositionY[4]).X+15,mapLocation(symbolPositionX[4],symbolPositionY[4]).Y-8);
						this.annularSymbol(symbolPositionX[5],symbolPositionY[5]);
						base.coordinateSystem.DrawString("Annular", smallFont,Brushes.Black,mapLocation(symbolPositionX[5],symbolPositionY[5]).X+15,mapLocation(symbolPositionX[5],symbolPositionY[5]).Y-8);
						this.mistSymbol(symbolPositionX[6],symbolPositionY[6]);
						base.coordinateSystem.DrawString("Mist", smallFont,Brushes.Black,mapLocation(symbolPositionX[6],symbolPositionY[6]).X+16,mapLocation(symbolPositionX[6],symbolPositionY[6]).Y-8);
						this.transitionZoneSymbol(symbolPositionX[7],symbolPositionY[7]);
						base.coordinateSystem.DrawString("Transition Zone", smallFont,Brushes.Black,mapLocation(symbolPositionX[7],symbolPositionY[7]).X+15,mapLocation(symbolPositionX[7],symbolPositionY[7]).Y-8);
						break;
					}
					default:
					{
						int i=0;
						if (includeBubbleSymbol)
						{
							this.bubbleSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Bubble", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeBubblySymbol)
						{
							this.bubblySymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Bubbly", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeConfinedBubbleSymbol)
						{
							this.confinedBubbleSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Confined Bubble", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeDispersedBubbleSymbol)
						{
							this.dispersedBubbleSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Dispersed Bubble", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeIntermittentSymbol)
						{
							this.intermittentSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Intermittent", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeSlugSymbol)
						{
							this.slugSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Slug", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeChurnSymbol)
						{
							this.churnSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Churn", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeAnnularSymbol)
						{
							this.annularSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Annular", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeMistSymbol)
						{
							this.mistSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Mist", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+16,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						if (includeTransitionZoneSymbol)
						{
							this.transitionZoneSymbol(symbolPositionX[i],symbolPositionY[i]);
							base.coordinateSystem.DrawString("Transition Zone", smallFont,Brushes.Black,mapLocation(symbolPositionX[i],symbolPositionY[i]).X+15,mapLocation(symbolPositionX[i],symbolPositionY[i]).Y-8);
							i++;
						}
						break;
					}
				}

			}
			if (multiMapFlag)
			{
				if (sourceFile1of4!=null)
				{
					this.transitionZoneSymbolA(symbolPositionX[0],symbolPositionY[0]);
					if (Math.Round(this.firstGroupDiameter*100000)%10==0)
						base.coordinateSystem.DrawString(Math.Round(this.firstGroupDiameter*1000,2)+"0 mm / "+Math.Round(this.firstGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[0],symbolPositionY[0]).X+15,mapLocation(symbolPositionX[0],symbolPositionY[0]).Y-8);
					else 
						base.coordinateSystem.DrawString(Math.Round(this.firstGroupDiameter*1000,2)+" mm / "+Math.Round(this.firstGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[0],symbolPositionY[0]).X+15,mapLocation(symbolPositionX[0],symbolPositionY[0]).Y-8);
				}
				if (sourceFile2of4!=null)
				{
					this.transitionZoneSymbolB(symbolPositionX[1],symbolPositionY[1]);
					if (Math.Round(this.secondGroupDiameter*100000)%10==0)
						base.coordinateSystem.DrawString(Math.Round(this.secondGroupDiameter*1000,2)+"0 mm / "+Math.Round(this.secondGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[1],symbolPositionY[1]).X+15,mapLocation(symbolPositionX[1],symbolPositionY[1]).Y-8);
					else 
						base.coordinateSystem.DrawString(Math.Round(this.secondGroupDiameter*1000,2)+" mm / "+Math.Round(this.secondGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[1],symbolPositionY[1]).X+15,mapLocation(symbolPositionX[1],symbolPositionY[1]).Y-8);
				}
				if (sourceFile3of4!=null)
				{
					this.transitionZoneSymbolC(symbolPositionX[2],symbolPositionY[2]);
					if (Math.Round(this.thirdGroupDiameter*100000)%10==0)
						base.coordinateSystem.DrawString(Math.Round(this.thirdGroupDiameter*1000,2)+"0 mm / "+Math.Round(this.thirdGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[2],symbolPositionY[2]).X+15,mapLocation(symbolPositionX[2],symbolPositionY[2]).Y-8);
					else 
						base.coordinateSystem.DrawString(Math.Round(this.thirdGroupDiameter*1000,2)+" mm / "+Math.Round(this.thirdGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[2],symbolPositionY[2]).X+15,mapLocation(symbolPositionX[2],symbolPositionY[2]).Y-8);
				}
				if (sourceFile4of4!=null)
				{
					this.transitionZoneSymbolD(symbolPositionX[3],symbolPositionY[3]);
					if (Math.Round(this.fourthGroupDiameter*100000)%10==0)
						base.coordinateSystem.DrawString(Math.Round(this.fourthGroupDiameter*1000,2)+"0 mm / "+Math.Round(this.fourthGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[3],symbolPositionY[3]).X+15,mapLocation(symbolPositionX[3],symbolPositionY[3]).Y-8);
					else 
						base.coordinateSystem.DrawString(Math.Round(this.fourthGroupDiameter*1000,2)+" mm / "+Math.Round(this.fourthGroupPressure/100000) + " bar", smallFont,Brushes.Black,mapLocation(symbolPositionX[3],symbolPositionY[3]).X+15,mapLocation(symbolPositionX[3],symbolPositionY[3]).Y-8);
				}
			}
		}
	}
	public class Coordinate: Data // change here when put new parameter in X axis or Y axis, see method GetCoordinateVariable() (2/2)
	{
		/// <summary>
		/// Establish coordinate
		/// </summary>
		protected Graphics coordinateSystem;
		protected FrmSetCoordinate coordinateValue;
		private bool coordinateValueSetFlag=false;
		private int greatFontSize,bigFontSize,middleFontSize,smallFontSize,tinyFontSize,microFontSize;
		protected Font greatFont,bigFont,middleFont,smallFont,tinyFont,microFont;
		protected Font bigSymbolFont,middleSymbolFont,smallSymbolFont,tinySymbolFont;
		private	int mapMargin;
		protected Point origin;
		private Point endPointofXaxis,endPointofYaxis;
		private Size XaxisLength, YaxisLength;
		private StringFormat titleFormat;
		protected double XaxisUnitLength, YaxisUnitLength;
		protected double Xmin,Ymin,Xmax,Ymax;
		protected string XaxisTitle,YaxisTitle;
		protected string XaxisUnit,YaxisUnit;
		protected string XaxisScale,YaxisScale;
		protected double XaxisDivisionNo,YaxisDivisionNo;
		protected string sourceFile,sourceFile1of4,sourceFile2of4,sourceFile3of4,sourceFile4of4,savedFile;
		public void SetCoordinateValue()
		{
			if (!coordinateValueSetFlag)
			{
				coordinateValue=new FrmSetCoordinate();
			}
			coordinateValue.Show();
			coordinateValueSetFlag=true;
		}
		private void ObtainCoordinateValue()
		{
			Xmin=coordinateValue.Xmin; // m/s
			Ymin=coordinateValue.Ymin; // m/s
			Xmax=coordinateValue.Xmax; // m/s
			Ymax=coordinateValue.Ymax; // m/s
			XaxisScale=coordinateValue.XaxisScale;
			YaxisScale=coordinateValue.YaxisScale;
			XaxisTitle=coordinateValue.XaxisTitle;
			YaxisTitle=coordinateValue.YaxisTitle;
			XaxisUnit=coordinateValue.XaxisUnit;
			YaxisUnit=coordinateValue.YaxisUnit;
			XaxisDivisionNo=coordinateValue.XaxisDivisionNo;
			YaxisDivisionNo=coordinateValue.YaxisDivisionNo;
		}

		private void GetCoordinateVariable() // 
		{
			switch (XaxisTitle)
			{
				case ("Gas Superficial Velocity"):
					X=Ugs;
					break;
				case ("Liquid Superficial Velocity"):
					X=Uls;
					break;
				case ("Quality"):
					X=quality;
					break;
				case ("Mass Flow Flux"):
					X=massFlux;
					break;
				case ("Lockhart-Martinelli Parameter (Churchill's equation for friction coefficient)"):
					X=LockhartMartinelliParameter;
					break;
				case ("Lockhart-Martinelli Parameter (Blasius's equation for friction coefficient)"):
					X=MartinelliParameter;
					break;
				case ("Govier and Omer's Coordinate X (Reference Fluid: 15.5C Air-Water)"):
					X=GovierAirWaterCoordinateX;
					break;
				case ("Govier and Omer's Coordinate X (Reference Fluid: 6bar R134a)"):
					X=GovierR134aCoordinateX;
					break;
				case ("Baker's Coordinate X (Reference Fluid: 15.5C Air-Water)"):
					X=BakerAirWaterCoordinateX;
					break;
				case ("Baker's Coordinate X (Reference Fluid: 6bar R134a)"):
					X=BakerR134aCoordinateX;
					break;
				case ("Homogeneous Velocity"):
					X=homogeneousVelocity;
					break;
				case ("Gas Mass Flow Flux"):
					X=gasMassFlux;
					break;
				case ("Froude Number"):
					X=Fr;
					break;
				case ("Hewitt's Coordinate X"):
					X=HewittCoordinateX;
					break;
				case ("Superficial Velocity Ratio"):
					X=superficialVelocityRatio;
					break;
				case ("Gas Mass Flow Rate"):
					X=gasMassFlowRate;
					break;
				case ("Schicht's Coordinate X (Reference Fluid: 15.5C Air-Water)"):
					X=SchichtAirWaterCoordinateX;
					break;
				case ("Schicht's Coordinate X (Reference Fluid: 6bar R134a)"):
					X=SchichtR134aCoordinateX;
					break;
				case ("Re Number Based on Ugs"):
					X=Re_gs;
					break;
				case ("We Number Based on Ugs"):
					X=We_gs;
					break;
				case ("Modified Gas Superficial Velocity 1"):
					X=ModifiedUgs1;
					break;
				case ("Modified Gas Superficial Velocity 2"):
					X=ModifiedUgs2;
					break;
				case ("Modified Gas Superficial Velocity 3"):
					X=ModifiedUgs3;
					break;
				case ("Modified Gas Superficial Velocity 4"):
					X=ModifiedUgs4;
					break;
				case ("XWegs"):
					X=XWegs;
					break;
				case ("Frgs.Regs"):
					X=FrgsRegs;
					break;
				case ("XX"):
					X=XX;
					break;
				default:
					X=Ugs;
					break;
			}
			switch (YaxisTitle)
			{
				case ("Gas Superficial Velocity"):
					Y=Ugs;
					break;
				case ("Liquid Superficial Velocity"):
					Y=Uls;
					break;
				case ("Quality"):
					Y=quality;
					break;
				case ("Mass Flow Flux"):
					Y=massFlux;
					break;
				case ("Lockhart-Martinelli Parameter (Churchill's equation for friction coefficient)"):
					Y=LockhartMartinelliParameter;
					break;
				case ("Lockhart-Martinelli Parameter (Blasius's equation for friction coefficient)"):
					Y=MartinelliParameter;
					break;
				case ("Govier and Omer's Coordinate Y (Reference Fluid: 15.5C Air-Water)"):
					Y=GovierAirWaterCoordinateY;
					break;
				case ("Govier and Omer's Coordinate Y (Reference Fluid: 6bar R134a)"):
					Y=GovierR134aCoordinateY;
					break;
				case ("Baker's Coordinate Y (Reference Fluid: 15.5C Air-Water)"):
					Y=BakerAirWaterCoordinateY;
					break;
				case ("Baker's Coordinate Y (Reference Fluid: 6bar R134a)"):
					Y=BakerR134aCoordinateY;
					break;
				case ("Volume Flow Ratio"):
					Y=volumeFlowRatio;
					break;
				case ("Liquid Mass Flow Flux"):
					Y=liquidMassFlux;
					break;
				case ("Hewitt's Coordinate Y"):
					Y=HewittCoordinateY;
					break;
				case ("Liquid Mass Flow Rate"):
					Y=liquidMassFlowRate;
					break;
				case ("Schicht's Coordinate Y (Reference Fluid: 15.5C Air-Water)"):
					Y=SchichtAirWaterCoordinateY;
					break;
				case ("Schicht's Coordinate Y (Reference Fluid: 6bar R134a)"):
					Y=SchichtR134aCoordinateY;
					break;
				case ("Re Number Based on Uls"):
					Y=Re_ls;
					break;
				case ("We Number Based on Uls"):
					Y=We_ls;
					break;
				case ("Barnea Parameter"):
					Y=BarneaParameter;
					break;
				case ("Modified Liquid Superficial Velocity 1"):
					Y=ModifiedUls1;
					break;
				case ("Modified Liquid Superficial Velocity 2"):
					Y=ModifiedUls2;
					break;
				case ("Modified Liquid Superficial Velocity 3"):
					Y=ModifiedUls3;
					break;
				case ("Modified Liquid Superficial Velocity 4"):
					Y=ModifiedUls4;
					break;
				case ("GWels"):
					Y=GWels;
					break;
				case ("Wels"):
					Y=We_ls;
					break;
				case ("YY"):
					Y=YY;
					break;
				default:
					Y=Uls;
					break;
			}
		}
		private void InitialSetandCalculation()
		{
			coordinateSystem=this.CreateGraphics();
			greatFontSize=28;
			bigFontSize=16;
			middleFontSize=14;
			smallFontSize=12;
			tinyFontSize=9;
			microFontSize=8;
			greatFont=new Font("Arial",greatFontSize);
			bigFont=new Font("Arial",bigFontSize);
			middleFont=new Font("Arial",middleFontSize);
			smallFont=new Font("Arial",smallFontSize);
			tinyFont=new Font("Arial",tinyFontSize);
			microFont=new Font("Arial",microFontSize);
			bigSymbolFont=new Font("Symbol",bigFontSize);
			middleSymbolFont=new Font("Symbol",middleFontSize);
			smallSymbolFont=new Font("Symbol",smallFontSize);
			tinySymbolFont=new Font("Symbol",tinyFontSize);
			mapMargin=125;
			origin=new Point(mapMargin,this.Size.Height-(int)(1.35*mapMargin));
			XaxisLength=new Size(this.Size.Width-3*mapMargin,0);
			YaxisLength=new Size(0,this.Size.Height-2*mapMargin);
			endPointofXaxis=origin+XaxisLength;
			endPointofYaxis=origin-YaxisLength;
			XaxisUnitLength=XaxisLength.Width/XaxisDivisionNo;
			YaxisUnitLength=YaxisLength.Height/YaxisDivisionNo;
		}

		private void OriginPoint()
		{
		}

		private void CoordinateAxis()
		{
			Pen coordinateLinePen=new Pen(Color.Black,1);
			int bigMarkLine=8;
			int middleMarkLine=6;
			int smallMarkLine=2;
			int XmarkNo=(int)(XaxisDivisionNo);
			int YmarkNo=(int)(YaxisDivisionNo);
			PointF[] Xo=new PointF[XmarkNo+1];
			PointF[] Xt=new PointF[XmarkNo+1];
			PointF[] Yo=new PointF[YmarkNo+1];
			PointF[] Yt=new PointF[YmarkNo+1];
			PointF[] Xos=new PointF[10];
			PointF[] Xts=new PointF[10];
			PointF[] Yos=new PointF[10];
			PointF[] Yts=new PointF[10];
			double [] Xmark=new Double[XmarkNo+1];
			double [] Ymark=new Double[YmarkNo+1];
			string XMark,YMark;
			StringFormat YmarkFormat=new StringFormat();
			YmarkFormat.Alignment=StringAlignment.Far;
			StringFormat XmarkFormat=new StringFormat();
			XmarkFormat.Alignment=StringAlignment.Center;
			
			coordinateSystem.DrawLine(coordinateLinePen,origin,endPointofXaxis); //drawing X-axis
			coordinateSystem.DrawLine(coordinateLinePen,origin,endPointofYaxis); //drawing Y-axis

			for (int i=0;i<=XmarkNo;i++) //drawing X-axis mark and number
			{
				Xo[i].X=(float)(origin.X+i*XaxisUnitLength);
				Xo[i].Y=(float)(origin.Y);
				Xt[i].X=(float)(origin.X+i*XaxisUnitLength);
				Xt[i].Y=(float)(origin.Y+bigMarkLine);
				coordinateSystem.DrawLine(coordinateLinePen,Xo[i],Xt[i]);
				switch (XaxisScale)
				{
					case ("Linear"):
						Xmark[i]=Xmin+i*(Xmax-Xmin)/XaxisDivisionNo;
						break;
					default:
						Xmark[i]=Xmin*Math.Pow(10,i);
						break;
				}
				if (Xmin>=10e-5 && Xmax<=10e5 && Ymin>=10e-5 && Ymax<=10e5)
				{
					XMark=Xmark[i].ToString();
				}
				else
				{
					XMark="1.0E"+Math.Log10(Xmark[i]).ToString();
				}
				coordinateSystem.DrawString(XMark,smallFont,Brushes.Black,Xo[i].X,Xo[i].Y+10,XmarkFormat);
				if (i<XmarkNo)
				{
					for (int j=1;j<10;j++)
					{
						switch (XaxisScale)
						{
							case ("Linear"):
								Xos[j].X=(float)(Xo[i].X+j*XaxisUnitLength/10);
								if (j!=5)
									Xts[j].Y=(float)(origin.Y+smallMarkLine);
								else 
									Xts[j].Y=(float)(origin.Y+middleMarkLine);
								break;
							default:
								Xos[j].X=(float)(Xo[i].X+XaxisUnitLength*Math.Log10(j+1));
								if (j!=4)
									Xts[j].Y=(float)(origin.Y+smallMarkLine);
								else 
									Xts[j].Y=(float)(origin.Y+middleMarkLine);
								break;
						}
						Xos[j].Y=(float)(origin.Y);
						Xts[j].X=Xos[j].X;
						coordinateSystem.DrawLine(coordinateLinePen,Xos[j],Xts[j]);
					}
				}
			}
			for (int i=0;i<=YmarkNo;i++) //drawing Y-axis mark and number
			{
				Yo[i].X=(float)(origin.X);
				Yo[i].Y=(float)(origin.Y-i*YaxisUnitLength);
				Yt[i].X=(float)(origin.X-bigMarkLine);
				Yt[i].Y=(float)(origin.Y-i*YaxisUnitLength);
				coordinateSystem.DrawLine(coordinateLinePen,Yo[i],Yt[i]);
				switch (YaxisScale)
				{
					case ("Linear"):
						Ymark[i]=Ymin+i*(Ymax-Ymin)/YaxisDivisionNo;
						break;
					default:
						Ymark[i]=Ymin*Math.Pow(10,i);
						break;
				}
				if (Xmin>=10e-5 && Xmax<=10e5 && Ymin>=10e-5 && Ymax<=10e5)
				{
					YMark=Ymark[i].ToString();
				}
				else
				{
					YMark="1.0E"+Math.Log10(Ymark[i]).ToString();
				}
				coordinateSystem.DrawString(YMark,smallFont,Brushes.Black,Yo[i].X-7,Yo[i].Y-8,YmarkFormat);
				if (i<YmarkNo)
				{
					for (int j=1;j<10;j++)
					{
						Yos[j].X=(float)(origin.X);
						switch (YaxisScale)
						{
							case ("Linear"):
								Yos[j].Y=(float)(Yo[i].Y-j*YaxisUnitLength/10);
								if (j!=5)
									Yts[j].X=(float)(origin.X-smallMarkLine);
								else 
									Yts[j].X=(float)(origin.X-middleMarkLine);
								break;
							default:
								Yos[j].Y=(float)(Yo[i].Y-YaxisUnitLength*Math.Log10(j+1));
								if (j!=4)
									Yts[j].X=(float)(origin.X-smallMarkLine);
								else 
									Yts[j].X=(float)(origin.X-middleMarkLine);
								break;
						}
						Yts[j].Y=Yos[j].Y;
						coordinateSystem.DrawLine(coordinateLinePen,Yos[j],Yts[j]);
					}
				}
			}
		}

		private void CoordinateTitle()
		{
			string title="";
			titleFormat=new StringFormat();
			titleFormat.Alignment=StringAlignment.Near;

			//coordinateSystem.DrawString(XaxisUnit,smallFont,Brushes.Black,endPointofXaxis.X+10,endPointofXaxis.Y-10);
			//coordinateSystem.DrawString(YaxisUnit,smallFont,Brushes.Black,endPointofYaxis.X-20,endPointofYaxis.Y-25);
			coordinateSystem.TranslateTransform(endPointofXaxis.X+10,endPointofXaxis.Y-12); //set new origin for X coordinate unit title
			this.XCoordinateUnitSymbol();
			coordinateSystem.TranslateTransform(-(endPointofXaxis.X+10),-(endPointofXaxis.Y-12)); //recover the original origin
			titleFormat.Alignment=StringAlignment.Far;
			coordinateSystem.TranslateTransform(endPointofYaxis.X,endPointofYaxis.Y-25); //set new origin for Y coordinate unit title
			this.YCoordinateUnitSymbol();
			coordinateSystem.TranslateTransform(-endPointofYaxis.X,-(endPointofYaxis.Y-25)); //recover the original origin

			titleFormat.Alignment=StringAlignment.Center;
			//coordinateSystem.DrawString(XaxisTitle,middleFont,Brushes.Black,(origin.X+endPointofXaxis.X)/2,origin.Y+28,titleFormat);
			coordinateSystem.TranslateTransform((origin.X+endPointofXaxis.X)/2,origin.Y+28); //set new origin for X coordinate title
			this.XCoordinateSymbol();
			coordinateSystem.TranslateTransform(-(origin.X+endPointofXaxis.X)/2,-(origin.Y+28)); //recover the original origin
			coordinateSystem.TranslateTransform(origin.X-70,(origin.Y+endPointofYaxis.Y)/2); //set new origin for Y coordinate title
			coordinateSystem.RotateTransform(-90); //rotate coordinateSystem system 90 degree
			//coordinateSystem.DrawString(YaxisTitle,middleFont,Brushes.Black,0,0,titleFormat);
			this.YCoordinateSymbol();
			coordinateSystem.RotateTransform(90); //rotate coordinateSystem system back
			coordinateSystem.TranslateTransform(-(origin.X-70),-(origin.Y+endPointofYaxis.Y)/2); //recover the original origin

			if (singleMapFlag)
			{
				if (fluid=="R134a")
				{
					title="Diameter: "+Math.Round(this.diameter*1000,2)+" mm / "+"Pressure: " + Math.Round(this.averageP/100000) + " bar";
				}
				else
				{
					title=fluid+", D = "+Math.Round(this.diameter*1000,2)+" mm, "+"P = " + Math.Round(this.averageP/100000) + " bar, "+"T = "+this.averageT+" C";
				}
			}
			if (multiMapFlag)
			{
				title="Comparison Transition Boundaries";
			}
			coordinateSystem.DrawString(title,bigFont,Brushes.Black,(origin.X+endPointofXaxis.X)/2,endPointofYaxis.Y-70,titleFormat);
			coordinateSystem.DrawString("+",tinyFont,Brushes.Black,origin.X-80,endPointofYaxis.Y-45,titleFormat);  //the map boundary mark for Us
			coordinateSystem.DrawString("+",tinyFont,Brushes.Black,endPointofXaxis.X+80,origin.Y+60,titleFormat);  //the map boundary mark for Us
			coordinateSystem.DrawString("+",tinyFont,Brushes.Black,origin.X-110,endPointofYaxis.Y-45,titleFormat);  //the map boundary for others
			coordinateSystem.DrawString("+",tinyFont,Brushes.Black,endPointofXaxis.X+100,origin.Y+90,titleFormat);  //the map boundary for others
		}

		private void XCoordinateSymbol()
		{
			switch (XaxisTitle)
			{
				case ("Gas Superficial Velocity"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,12,10,titleFormat);
					break;
				case ("Liquid Superficial Velocity"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,12,10,titleFormat);
					break;
				case ("Quality"):
					coordinateSystem.DrawString("x",bigFont,Brushes.Black,0,0,titleFormat);
					break;
				case ("Mass Flow Flux"):
					coordinateSystem.DrawString("G",bigFont,Brushes.Black,0,0,titleFormat);
					break;
				case ("Lockhart-Martinelli Parameter (Churchill's equation for friction coefficient)"):
					coordinateSystem.DrawString("X",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("(Friction coefficient is based on Churchill's equation)",smallFont,Brushes.Black,0,20,titleFormat);
					break;
				case ("Lockhart-Martinelli Parameter (Blasius's equation for friction coefficient)"):
					coordinateSystem.DrawString("X",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("(Friction coefficient is based on Blasius's equation)",smallFont,Brushes.Black,0,20,titleFormat);
					break;
				case ("Govier and Omer's Coordinate X (Reference Fluid: 15.5C Air-Water)"):
					coordinateSystem.DrawString("u",middleSymbolFont,Brushes.Black,-70,0,titleFormat);
					coordinateSystem.DrawString("gref",tinyFont,Brushes.Black,-55,10,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,-60,8,titleFormat);
					coordinateSystem.DrawString("u",middleSymbolFont,Brushes.Black,-63,18,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,-55,28,titleFormat);
					coordinateSystem.DrawString("(   )",greatFont,Brushes.Black,-60,0,titleFormat);
					coordinateSystem.DrawString("1/3",tinyFont,Brushes.Black,-27,0,titleFormat);
					coordinateSystem.DrawString("u    s",middleSymbolFont,Brushes.Black,10,0,titleFormat);
					coordinateSystem.DrawString("lref     ref",tinyFont,Brushes.Black,22,10,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,17,8,titleFormat);
					coordinateSystem.DrawString("u s",middleSymbolFont,Brushes.Black,17,18,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,15,28,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,17,0,titleFormat);
					coordinateSystem.DrawString("1/4",tinyFont,Brushes.Black,60,0,titleFormat);
					coordinateSystem.DrawString("u",middleFont,Brushes.Black,73,12,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,85,22,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: air-water at 15.5 C and 1 bar)",smallFont,Brushes.Black,0,45,titleFormat);
					coordinateSystem.DrawString("o",microFont,Brushes.Black,74,43,titleFormat);
					break;
				case ("Govier and Omer's Coordinate X (Reference Fluid: 6bar R134a)"):
					coordinateSystem.DrawString("u",middleSymbolFont,Brushes.Black,-70,0,titleFormat);
					coordinateSystem.DrawString("gref",tinyFont,Brushes.Black,-55,10,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,-60,8,titleFormat);
					coordinateSystem.DrawString("u",middleSymbolFont,Brushes.Black,-63,18,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,-55,28,titleFormat);
					coordinateSystem.DrawString("(   )",greatFont,Brushes.Black,-60,0,titleFormat);
					coordinateSystem.DrawString("1/3",tinyFont,Brushes.Black,-27,0,titleFormat);
					coordinateSystem.DrawString("u    s",middleSymbolFont,Brushes.Black,10,0,titleFormat);
					coordinateSystem.DrawString("lref     ref",tinyFont,Brushes.Black,22,10,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,17,8,titleFormat);
					coordinateSystem.DrawString("u s",middleSymbolFont,Brushes.Black,17,18,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,15,28,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,17,0,titleFormat);
					coordinateSystem.DrawString("1/4",tinyFont,Brushes.Black,60,0,titleFormat);
					coordinateSystem.DrawString("u",middleFont,Brushes.Black,73,12,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,85,22,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: Saturated R134a at 6 bar)",smallFont,Brushes.Black,0,45,titleFormat);
					break;
				case ("Baker's Coordinate X (Reference Fluid: 15.5C Air-Water)"):
					coordinateSystem.DrawString("r    r",middleSymbolFont,Brushes.Black,-10,0,titleFormat);
					coordinateSystem.DrawString("gref    lref",tinyFont,Brushes.Black,2,10,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-1,8,titleFormat);
					coordinateSystem.DrawString("r r",middleSymbolFont,Brushes.Black,-1,18,titleFormat);
					coordinateSystem.DrawString("g   l",tinyFont,Brushes.Black,4,28,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-1,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,40,0,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,53,12,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,66,22,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: air-water at 15.5 C and 1 bar)",smallFont,Brushes.Black,0,45,titleFormat);
					coordinateSystem.DrawString("o",microFont,Brushes.Black,74,43,titleFormat);
					break;
				case ("Baker's Coordinate X (Reference Fluid: 6bar R134a)"):
					coordinateSystem.DrawString("r    r",middleSymbolFont,Brushes.Black,-10,0,titleFormat);
					coordinateSystem.DrawString("gref    lref",tinyFont,Brushes.Black,2,10,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-1,8,titleFormat);
					coordinateSystem.DrawString("r r",middleSymbolFont,Brushes.Black,-1,18,titleFormat);
					coordinateSystem.DrawString("g   l",tinyFont,Brushes.Black,4,28,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-1,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,40,0,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,53,12,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,66,22,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: Saturated R134a at 6 bar)",smallFont,Brushes.Black,0,45,titleFormat);
					break;
				case ("Homogeneous Velocity"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("h",tinyFont,Brushes.Black,10,10,titleFormat);
					break;
				case ("Gas Mass Flow Flux"):
					coordinateSystem.DrawString("G",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,14,10,titleFormat);
					break;
				case ("Froude Number"):
					coordinateSystem.DrawString("Fr",bigFont,Brushes.Black,0,0,titleFormat);					
					coordinateSystem.DrawString("h",tinyFont,Brushes.Black,13,10,titleFormat);
					break;
				case ("Hewitt's Coordinate X"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-15,0,titleFormat);
					coordinateSystem.DrawString("r",bigSymbolFont,Brushes.Black,10,0,titleFormat);
					coordinateSystem.DrawString("gs    g",tinyFont,Brushes.Black,5,12,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,-6,2,titleFormat);
					break;
				case ("Superficial Velocity Ratio"):
					coordinateSystem.DrawString("u  /u",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs     ls",tinyFont,Brushes.Black,10,10,titleFormat);
					break;
				case ("Gas Mass Flow Rate"):
					coordinateSystem.DrawString("m",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,10,10,titleFormat);
					break;
				case ("Schicht's Coordinate X (Reference Fluid: 15.5C Air-Water)"):
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,-100,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,-85,8,titleFormat);
					coordinateSystem.DrawString("___",smallFont,Brushes.Black,-95,6,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,-100,22,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,-85,30,titleFormat);
					coordinateSystem.DrawString("r r",middleSymbolFont,Brushes.Black,-41,-2,titleFormat);
					coordinateSystem.DrawString("g   l",tinyFont,Brushes.Black,-36,8,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-41,6,titleFormat);
					coordinateSystem.DrawString("r    r",middleSymbolFont,Brushes.Black,-50,18,titleFormat);
					coordinateSystem.DrawString("gref    lref",tinyFont,Brushes.Black,-38,30,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-41,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,13,-2,titleFormat);
					coordinateSystem.DrawString("ref",tinyFont,Brushes.Black,25,10,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,20,6,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,17,18,titleFormat);
					coordinateSystem.DrawString("m  r",middleSymbolFont,Brushes.Black,67,-2,titleFormat);
					coordinateSystem.DrawString("l    lref",tinyFont,Brushes.Black,82,10,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,86,-2,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,77,6,titleFormat);
					coordinateSystem.DrawString("m    r",middleSymbolFont,Brushes.Black,73,18,titleFormat);
					coordinateSystem.DrawString("lref     l",tinyFont,Brushes.Black,82,30,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,97,22,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,77,0,titleFormat);
					coordinateSystem.DrawString("1/3",tinyFont,Brushes.Black,120,0,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: air-water at 15.5 C and 1 bar)",smallFont,Brushes.Black,0,45,titleFormat);
					coordinateSystem.DrawString("o",microFont,Brushes.Black,74,43,titleFormat);
					break;
				case ("Schicht's Coordinate X (Reference Fluid: 6bar R134a)"):
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,-100,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,-85,8,titleFormat);
					coordinateSystem.DrawString("___",smallFont,Brushes.Black,-95,6,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,-100,22,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,-85,30,titleFormat);
					coordinateSystem.DrawString("r r",middleSymbolFont,Brushes.Black,-41,-2,titleFormat);
					coordinateSystem.DrawString("g   l",tinyFont,Brushes.Black,-36,8,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-41,6,titleFormat);
					coordinateSystem.DrawString("r    r",middleSymbolFont,Brushes.Black,-50,18,titleFormat);
					coordinateSystem.DrawString("gref    lref",tinyFont,Brushes.Black,-38,30,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-41,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,13,-2,titleFormat);
					coordinateSystem.DrawString("ref",tinyFont,Brushes.Black,25,10,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,20,6,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,17,18,titleFormat);
					coordinateSystem.DrawString("m  r",middleSymbolFont,Brushes.Black,67,-2,titleFormat);
					coordinateSystem.DrawString("l    lref",tinyFont,Brushes.Black,82,10,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,86,-2,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,77,6,titleFormat);
					coordinateSystem.DrawString("m    r",middleSymbolFont,Brushes.Black,73,18,titleFormat);
					coordinateSystem.DrawString("lref     l",tinyFont,Brushes.Black,82,30,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,97,22,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,77,0,titleFormat);
					coordinateSystem.DrawString("1/3",tinyFont,Brushes.Black,120,0,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: Saturated R134a at 6 bar)",smallFont,Brushes.Black,0,45,titleFormat);
					break;
				case ("Re Number Based on Ugs"):
					coordinateSystem.DrawString("Re",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,20,10,titleFormat);
					break;
				case ("We Number Based on Ugs"):
					coordinateSystem.DrawString("We",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,24,10,titleFormat);
					break;
				case ("Modified Gas Superficial Velocity 1"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-55,10,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,-43,20,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,7,-2,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,15,10,titleFormat);
					coordinateSystem.DrawString("_________",smallFont,Brushes.Black,8,6,titleFormat);
					coordinateSystem.DrawString("gD",middleFont,Brushes.Black,-15,22,titleFormat);
					coordinateSystem.DrawString("(r -r )",middleSymbolFont,Brushes.Black,24,20,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,28,32,titleFormat);
					coordinateSystem.DrawString("(       )",greatFont,Brushes.Black,10,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,60,0,titleFormat);
					break;
				case ("Modified Gas Superficial Velocity 2"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-67,10,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,-55,20,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,7,-2,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,15,10,titleFormat);
					coordinateSystem.DrawString("___________",smallFont,Brushes.Black,9,6,titleFormat);
					coordinateSystem.DrawString("(g",middleFont,Brushes.Black,-30,22,titleFormat);
					coordinateSystem.DrawString("s(r -r ))",middleSymbolFont,Brushes.Black,14,20,titleFormat);
					coordinateSystem.DrawString("1/2",microFont,Brushes.Black,53,23,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,20,32,titleFormat);
					coordinateSystem.DrawString("(         )",greatFont,Brushes.Black,9,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,68,0,titleFormat);
					break;
				case ("Modified Gas Superficial Velocity 3"):
					coordinateSystem.DrawString("u",middleFont,Brushes.Black,-112,0,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,-100,8,titleFormat);
					coordinateSystem.DrawString("___",smallFont,Brushes.Black,-107,6,titleFormat);
					coordinateSystem.DrawString("D",middleFont,Brushes.Black,-107,22,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,-38,-2,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,-30,10,titleFormat);
					coordinateSystem.DrawString("___________",smallFont,Brushes.Black,-36,6,titleFormat);
					coordinateSystem.DrawString("(g",middleFont,Brushes.Black,-75,22,titleFormat);
					coordinateSystem.DrawString("s(r -r ))",middleSymbolFont,Brushes.Black,-31,20,titleFormat);
					coordinateSystem.DrawString("1/2",microFont,Brushes.Black,8,23,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,-25,32,titleFormat);
					coordinateSystem.DrawString("(         )",greatFont,Brushes.Black,-36,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,23,0,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,68,-2,titleFormat);
					coordinateSystem.DrawString("________",smallFont,Brushes.Black,70,6,titleFormat);
					coordinateSystem.DrawString("g",middleFont,Brushes.Black,45,22,titleFormat);
					coordinateSystem.DrawString("(r -r )",middleSymbolFont,Brushes.Black,77,20,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,81,32,titleFormat);
					coordinateSystem.DrawString("(      )",greatFont,Brushes.Black,70,0,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,118,0,titleFormat);
					break;
				case ("Modified Gas Superficial Velocity 4"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-35,10,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,-23,20,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,7,-2,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,15,10,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,10,6,titleFormat);
					coordinateSystem.DrawString("g",middleFont,Brushes.Black,2,22,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,16,20,titleFormat);
					coordinateSystem.DrawString("(   )",greatFont,Brushes.Black,10,0,titleFormat);
					coordinateSystem.DrawString("1/4",tinyFont,Brushes.Black,40,0,titleFormat);
					break;
				case ("XWegs"):
					coordinateSystem.DrawString("X.We",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,36,10,titleFormat);
					break;
				case ("Frgs.Regs"):
					coordinateSystem.DrawString("Fr   .Re",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs         gs",smallFont,Brushes.Black,17,7,titleFormat);
					break;
				case ("XX"):
					coordinateSystem.DrawString("XX",bigFont,Brushes.Black,0,0,titleFormat);
					break;
				default:
					coordinateSystem.DrawString(XaxisTitle,middleFont,Brushes.Black,0,5,titleFormat);
					break;
			}
		}

		private void YCoordinateSymbol()
		{
			switch (YaxisTitle)
			{
				case ("Gas Superficial Velocity"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,12,10,titleFormat);
					break;
				case ("Liquid Superficial Velocity"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,12,10,titleFormat);
					break;
				case ("Quality"):
					coordinateSystem.DrawString("x",bigFont,Brushes.Black,0,0,titleFormat);
					break;
				case ("Mass Flow Flux"):
					coordinateSystem.DrawString("G",bigFont,Brushes.Black,0,0,titleFormat);
					break;
				case ("Lockhart-Martinelli Parameter (Churchill's equation for friction coefficient)"):
					coordinateSystem.DrawString("X",bigFont,Brushes.Black,0,-10,titleFormat);
					coordinateSystem.DrawString("(Friction coefficient is based on Churchill's equation)",smallFont,Brushes.Black,0,10,titleFormat);
					break;
				case ("Lockhart-Martinelli Parameter (Blasius's equation for friction coefficient)"):
					coordinateSystem.DrawString("X",bigFont,Brushes.Black,0,-10,titleFormat);
					coordinateSystem.DrawString("(Friction coefficient is based on Blasius's equation)",smallFont,Brushes.Black,0,10,titleFormat);
					break;
				case ("Govier and Omer's Coordinate Y (Reference Fluid: 15.5C Air-Water)"):
					coordinateSystem.DrawString("u    s",middleSymbolFont,Brushes.Black,-10,-30,titleFormat);
					coordinateSystem.DrawString("lref     ref",tinyFont,Brushes.Black,2,-20,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-3,-22,titleFormat);
					coordinateSystem.DrawString("u s",middleSymbolFont,Brushes.Black,-3,-12,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,-5,-2,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-3,-30,titleFormat);
					coordinateSystem.DrawString("1/4",tinyFont,Brushes.Black,40,-30,titleFormat);
					coordinateSystem.DrawString("u",middleFont,Brushes.Black,53,-18,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,65,-8,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: air-water at 15.5 C and 1 bar)",smallFont,Brushes.Black,0,15,titleFormat);
					coordinateSystem.DrawString("o",microFont,Brushes.Black,74,13,titleFormat);
					break;
				case ("Govier and Omer's Coordinate Y (Reference Fluid: 6bar R134a)"):
					coordinateSystem.DrawString("u    s",middleSymbolFont,Brushes.Black,-10,-30,titleFormat);
					coordinateSystem.DrawString("lref     ref",tinyFont,Brushes.Black,2,-20,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-3,-22,titleFormat);
					coordinateSystem.DrawString("u s",middleSymbolFont,Brushes.Black,-3,-12,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,-5,-2,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-3,-30,titleFormat);
					coordinateSystem.DrawString("1/4",tinyFont,Brushes.Black,40,-30,titleFormat);
					coordinateSystem.DrawString("u",middleFont,Brushes.Black,53,-18,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,65,-8,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: Saturated R134a at 6 bar)",smallFont,Brushes.Black,0,15,titleFormat);
					break;
				case ("Baker's Coordinate Y (Reference Fluid: 15.5C Air-Water)"):
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,-57,-45,titleFormat);
					coordinateSystem.DrawString("ref",tinyFont,Brushes.Black,-45,-31,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,-50,-37,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,-53,-27,titleFormat);
					coordinateSystem.DrawString("m  r",middleSymbolFont,Brushes.Black,-3,-45,titleFormat);
					coordinateSystem.DrawString("l    lref",tinyFont,Brushes.Black,12,-31,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,16,-45,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,7,-37,titleFormat);
					coordinateSystem.DrawString("m    r",middleSymbolFont,Brushes.Black,3,-27,titleFormat);
					coordinateSystem.DrawString("lref     l",tinyFont,Brushes.Black,12,-13,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,27,-21,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,7,-45,titleFormat);
					coordinateSystem.DrawString("1/3",tinyFont,Brushes.Black,50,-45,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,63,-33,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,76,-23,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: air-water at 15.5 C and 1 bar)",smallFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("o",microFont,Brushes.Black,74,-2,titleFormat);
					break;
				case ("Baker's Coordinate Y (Reference Fluid: 6bar R134a)"):
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,-57,-45,titleFormat);
					coordinateSystem.DrawString("ref",tinyFont,Brushes.Black,-45,-31,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,-50,-37,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,-53,-27,titleFormat);
					coordinateSystem.DrawString("m  r",middleSymbolFont,Brushes.Black,-3,-45,titleFormat);
					coordinateSystem.DrawString("l    lref",tinyFont,Brushes.Black,12,-31,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,16,-45,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,7,-37,titleFormat);
					coordinateSystem.DrawString("m    r",middleSymbolFont,Brushes.Black,3,-27,titleFormat);
					coordinateSystem.DrawString("lref     l",tinyFont,Brushes.Black,12,-13,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,27,-21,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,7,-45,titleFormat);
					coordinateSystem.DrawString("1/3",tinyFont,Brushes.Black,50,-45,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,63,-33,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,76,-23,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: Saturated R134a at 6 bar)",smallFont,Brushes.Black,0,0,titleFormat);
					break;
				case ("Volume Flow Ratio"):
					coordinateSystem.DrawString("b",bigSymbolFont,Brushes.Black,0,0,titleFormat);
					break;
				case ("Liquid Mass Flow Flux"):
					coordinateSystem.DrawString("G",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,14,10,titleFormat);
					break;
				case ("Hewitt's Coordinate Y"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-15,0,titleFormat);
					coordinateSystem.DrawString("r",bigSymbolFont,Brushes.Black,10,0,titleFormat);
					coordinateSystem.DrawString("ls    l",tinyFont,Brushes.Black,5,12,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,-6,2,titleFormat);
					break;
				case ("Liquid Mass Flow Rate"):
					coordinateSystem.DrawString("m",bigFont,Brushes.Black,0,-10,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,10,0,titleFormat);
					break;
				case ("Schicht's Coordinate Y (Reference Fluid: 15.5C Air-Water)"):
					coordinateSystem.DrawString("r    r",middleSymbolFont,Brushes.Black,-10,-30,titleFormat);
					coordinateSystem.DrawString("gref    lref",tinyFont,Brushes.Black,2,-20,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-1,-22,titleFormat);
					coordinateSystem.DrawString("r r",middleSymbolFont,Brushes.Black,-1,-12,titleFormat);
					coordinateSystem.DrawString("g   l",tinyFont,Brushes.Black,4,-2,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-1,-30,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,40,-30,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,53,-18,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,67,-8,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: air-water at 15.5 C and 1 bar)",smallFont,Brushes.Black,0,15,titleFormat);
					coordinateSystem.DrawString("o",microFont,Brushes.Black,74,13,titleFormat);
					break;
				case ("Schicht's Coordinate Y (Reference Fluid: 6bar R134a)"):
					coordinateSystem.DrawString("r    r",middleSymbolFont,Brushes.Black,-10,-30,titleFormat);
					coordinateSystem.DrawString("gref    lref",tinyFont,Brushes.Black,2,-20,titleFormat);
					coordinateSystem.DrawString("_______",smallFont,Brushes.Black,-1,-22,titleFormat);
					coordinateSystem.DrawString("r r",middleSymbolFont,Brushes.Black,-1,-12,titleFormat);
					coordinateSystem.DrawString("g   l",tinyFont,Brushes.Black,4,-2,titleFormat);
					coordinateSystem.DrawString("(     )",greatFont,Brushes.Black,-1,-30,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,40,-30,titleFormat);
					coordinateSystem.DrawString("G",middleFont,Brushes.Black,53,-18,titleFormat);
					coordinateSystem.DrawString("gs",tinyFont,Brushes.Black,67,-8,titleFormat);
					coordinateSystem.DrawString("(Reference fluid: Saturated R134a at 6 bar)",smallFont,Brushes.Black,0,15,titleFormat);
					break;
				case ("Re Number Based on Uls"):
					coordinateSystem.DrawString("Re",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,20,10,titleFormat);
					break;
				case ("Re Number Based on Um"):
					coordinateSystem.DrawString("Re",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("m",tinyFont,Brushes.Black,20,10,titleFormat);
					break;
				case ("We Number Based on Uls"):
					coordinateSystem.DrawString("We",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,24,10,titleFormat);
					break;
				case ("Barnea Parameter"):
					coordinateSystem.DrawString("(r -r )       b",middleSymbolFont,Brushes.Black,-10,-30,titleFormat);
					coordinateSystem.DrawString("gsin",middleFont,Brushes.Black,10,-30,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,-28,-18,titleFormat);
					coordinateSystem.DrawString("___________",smallFont,Brushes.Black,-10,-22,titleFormat);
					coordinateSystem.DrawString("D",middleSymbolFont,Brushes.Black,-15,-5,titleFormat);
					coordinateSystem.DrawString("p",middleFont,Brushes.Black,-3,-5,titleFormat);
					coordinateSystem.DrawString("g",tinyFont,Brushes.Black,5,7,titleFormat);
					break;
				case ("Modified Liquid Superficial Velocity 1"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-55,-10,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,-43,0,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,7,-22,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,15,-10,titleFormat);
					coordinateSystem.DrawString("_________",smallFont,Brushes.Black,8,-14,titleFormat);
					coordinateSystem.DrawString("gD",middleFont,Brushes.Black,-15,2,titleFormat);
					coordinateSystem.DrawString("(r -r )",middleSymbolFont,Brushes.Black,24,0,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,28,12,titleFormat);
					coordinateSystem.DrawString("(       )",greatFont,Brushes.Black,10,-20,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,60,-20,titleFormat);
					break;
				case ("Modified Liquid Superficial Velocity 2"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-67,-10,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,-55,0,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,7,-22,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,15,-10,titleFormat);
					coordinateSystem.DrawString("___________",smallFont,Brushes.Black,9,-14,titleFormat);
					coordinateSystem.DrawString("(g",middleFont,Brushes.Black,-30,2,titleFormat);
					coordinateSystem.DrawString("s(r -r ))",middleSymbolFont,Brushes.Black,14,0,titleFormat);
					coordinateSystem.DrawString("1/2",microFont,Brushes.Black,53,3,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,20,12,titleFormat);
					coordinateSystem.DrawString("(         )",greatFont,Brushes.Black,9,-20,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,68,-20,titleFormat);
					break;
				case ("Modified Liquid Superficial Velocity 3"):
					coordinateSystem.DrawString("u",middleFont,Brushes.Black,-112,-20,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,-100,-12,titleFormat);
					coordinateSystem.DrawString("___",smallFont,Brushes.Black,-107,-14,titleFormat);
					coordinateSystem.DrawString("D",middleFont,Brushes.Black,-107,2,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,-38,-22,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,-30,-10,titleFormat);
					coordinateSystem.DrawString("___________",smallFont,Brushes.Black,-36,-14,titleFormat);
					coordinateSystem.DrawString("(g",middleFont,Brushes.Black,-75,2,titleFormat);
					coordinateSystem.DrawString("s(r -r ))",middleSymbolFont,Brushes.Black,-31,0,titleFormat);
					coordinateSystem.DrawString("1/2",microFont,Brushes.Black,8,3,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,-25,12,titleFormat);
					coordinateSystem.DrawString("(         )",greatFont,Brushes.Black,-36,-20,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,23,-20,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,68,-22,titleFormat);
					coordinateSystem.DrawString("________",smallFont,Brushes.Black,70,-14,titleFormat);
					coordinateSystem.DrawString("g",middleFont,Brushes.Black,45,2,titleFormat);
					coordinateSystem.DrawString("(r -r )",middleSymbolFont,Brushes.Black,77,0,titleFormat);
					coordinateSystem.DrawString("l       g",tinyFont,Brushes.Black,81,12,titleFormat);
					coordinateSystem.DrawString("(      )",greatFont,Brushes.Black,70,-20,titleFormat);
					coordinateSystem.DrawString("1/2",tinyFont,Brushes.Black,118,-20,titleFormat);
					break;
				case ("Modified Liquid Superficial Velocity 4"):
					coordinateSystem.DrawString("u",bigFont,Brushes.Black,-35,-10,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,-23,0,titleFormat);
					coordinateSystem.DrawString("r",middleSymbolFont,Brushes.Black,7,-22,titleFormat);
					coordinateSystem.DrawString("l",tinyFont,Brushes.Black,15,-10,titleFormat);
					coordinateSystem.DrawString("____",smallFont,Brushes.Black,10,-14,titleFormat);
					coordinateSystem.DrawString("g",middleFont,Brushes.Black,2,2,titleFormat);
					coordinateSystem.DrawString("s",middleSymbolFont,Brushes.Black,16,0,titleFormat);
					coordinateSystem.DrawString("(   )",greatFont,Brushes.Black,10,-20,titleFormat);
					coordinateSystem.DrawString("1/4",tinyFont,Brushes.Black,40,-20,titleFormat);
					break;
				case ("GWels"):
					coordinateSystem.DrawString("G.We",bigFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("ls",tinyFont,Brushes.Black,36,10,titleFormat);
					break;
				case ("Wels"):
					coordinateSystem.DrawString("We",bigFont,Brushes.Black,0,-7,titleFormat);
					coordinateSystem.DrawString("ls",smallFont,Brushes.Black,24,0,titleFormat);
					break;
				case ("YY"):
					coordinateSystem.DrawString("YY",bigFont,Brushes.Black,0,0,titleFormat);
					break;
				default:
					coordinateSystem.DrawString(YaxisTitle,middleFont,Brushes.Black,0,-10,titleFormat);
					break;
			}
		}

		private void XCoordinateUnitSymbol()
		{
			switch (XaxisUnit)
			{
				case ("(kg/m2s)"):
					coordinateSystem.DrawString("(kg/m",smallFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,40,-4,titleFormat);
					coordinateSystem.DrawString("s)",smallFont,Brushes.Black,47,0,titleFormat);
					break;
				case ("(kg/ms2)"):
					coordinateSystem.DrawString("(kg/ms )",smallFont,Brushes.Black,0,0,titleFormat);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,46,-4,titleFormat);
					break;
				default:
					coordinateSystem.DrawString(XaxisUnit,smallFont,Brushes.Black,0,0,titleFormat);
					break;
			}
		}
		private void YCoordinateUnitSymbol()
		{
			switch (YaxisUnit)
			{
				case ("(kg/m2s)"):
					coordinateSystem.DrawString("(kg/m",smallFont,Brushes.Black,-60,0);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,-20,-4);
					coordinateSystem.DrawString("s)",smallFont,Brushes.Black,-13,0);
					break;
				case ("(kg/ms2)"):
					coordinateSystem.DrawString("(kg/ms )",smallFont,Brushes.Black,-60,0);
					coordinateSystem.DrawString("2",tinyFont,Brushes.Black,-14,-4);
					break;
				default:
					coordinateSystem.DrawString(YaxisUnit,smallFont,Brushes.Black,0,0,titleFormat);
					break;
			}
		}

		protected void BuildCoordinate()
		{
			this.ObtainCoordinateValue();
			this.GetCoordinateVariable();
			this.InitialSetandCalculation();
			this.OriginPoint();
			this.CoordinateAxis();
			this.CoordinateTitle();
		}
	}

	public class Data: System.Windows.Forms.Form // change here when put new parameter in X axis or Y axis (1/2).
	{
		private const int dataRow=1000; // It need so much row when comparing 4 groups data
		private const int dataColumn=12;
		private const double g=9.8065;
		private int startNo=0;
		private int endOfLastGroupDataNo=0;
		private string[] originalData=new string[dataRow];
		private string[,] data=new string[dataRow,dataColumn];
		private R134aProperty R134a, satR134a;
		private R134a6barProperty refR134a;
		private AirWater1bar15CProperty airWater15C;
		private AirWater1bar25CProperty airWater1bar25C;
		protected string fluid;
		protected string[] flowPattern=new string[dataRow];
		protected double[] massFlowRate=new double[dataRow];
		protected double[] massFlux=new double[dataRow];
		protected double[] heatFlux=new double[dataRow];
		protected double[] quality=new double[dataRow];
		protected double[] Ugs=new double[dataRow];
		protected double[] Uls=new double[dataRow];
		protected double[] LockhartMartinelliParameter=new double[dataRow];
		protected double[] MartinelliParameter=new double[dataRow];
		protected double[] GovierAirWaterCoordinateX=new double[dataRow];
		protected double[] GovierAirWaterCoordinateY=new double[dataRow];
		protected double[] GovierR134aCoordinateX=new double[dataRow];
		protected double[] GovierR134aCoordinateY=new double[dataRow];
		protected double[] BakerAirWaterCoordinateX=new double[dataRow];
		protected double[] BakerAirWaterCoordinateY=new double[dataRow];
		protected double[] BakerR134aCoordinateX=new double[dataRow];
		protected double[] BakerR134aCoordinateY=new double[dataRow];
		protected double[] SchichtAirWaterCoordinateX=new double[dataRow];
		protected double[] SchichtAirWaterCoordinateY=new double[dataRow];
		protected double[] SchichtR134aCoordinateX=new double[dataRow];
		protected double[] SchichtR134aCoordinateY=new double[dataRow];
		protected double[] homogeneousVelocity=new double[dataRow];
		protected double[] volumeFlowRatio=new double[dataRow];
		protected double[] gasMassFlux=new double[dataRow];
		protected double[] liquidMassFlux=new double[dataRow];
		protected double[] Fr=new double[dataRow];
		protected double[] Fr_gs=new double[dataRow];
		protected double[] Fr_ls=new double[dataRow];
		protected double[] HewittCoordinateX=new double[dataRow];
		protected double[] HewittCoordinateY=new double[dataRow];
		protected double[] superficialVelocityRatio=new double[dataRow];
		protected double[] gasMassFlowRate=new double[dataRow];
		protected double[] liquidMassFlowRate=new double[dataRow];
		protected double[] Re_gs=new double[dataRow];
		protected double[] Re_ls=new double[dataRow];
		protected double[] We_gs=new double[dataRow];
		protected double[] We_ls=new double[dataRow];
		protected double[] ModifiedUgs1=new double[dataRow];
		protected double[] ModifiedUgs2=new double[dataRow];
		protected double[] ModifiedUgs3=new double[dataRow];
		protected double[] ModifiedUgs4=new double[dataRow];
		protected double[] ModifiedUls1=new double[dataRow];
		protected double[] ModifiedUls2=new double[dataRow];
		protected double[] ModifiedUls3=new double[dataRow];
		protected double[] ModifiedUls4=new double[dataRow];
		protected double[] XWegs=new double[dataRow];
		protected double[] GWels=new double[dataRow];
		protected double[] FrgsRegs=new double[dataRow];
		protected double[] FrlsRels=new double[dataRow];
		protected double[] XX1=new double[dataRow];
		protected double[] YY1=new double[dataRow];
		protected double[] XX2=new double[dataRow];
		protected double[] YY2=new double[dataRow];
		protected double[] XX=new double[dataRow];
		protected double[] YY=new double[dataRow];
		protected double[] BarneaParameter=new double[dataRow];
		protected double[] X=new double[dataRow];
		protected double[] Y=new double[dataRow];
		protected double diameter,averageT,averageP;
		private double liquidDensity, gasDensity, liquidViscosity, gasViscosity, surfaceTension;
		private double Rels,Regs,Al,Ag,Bl,Bg,Roughness=0,fl,fg,DPls,DPgs,fl0,fg0,DPls0,DPgs0;
		private double LamdaAirWater,AitaAirWater,LamdaR134a,AitaR134a;
		private double ModifiedCoefficient1X,ModifiedCoefficient2X,ModifiedCoefficient3X,ModifiedCoefficient4X;
		private double ModifiedCoefficient1Y,ModifiedCoefficient2Y,ModifiedCoefficient3Y,ModifiedCoefficient4Y;
		protected int firstGroupStartNo,firstGroupEndNo;
		protected int secondGroupStartNo,secondGroupEndNo;
		protected int thirdGroupStartNo,thirdGroupEndNo;
		protected int fourthGroupStartNo,fourthGroupEndNo;
		protected bool singleMapFlag,multiMapFlag,firstMapFlag,secondMapFlag,thirdMapFlag,fourthMapFlag;
		protected double firstGroupDiameter=0;
		protected double firstGroupPressure=0;
		protected double secondGroupDiameter=0;
		protected double secondGroupPressure=0;
		protected double thirdGroupDiameter=0;
		protected double thirdGroupPressure=0;
		protected double fourthGroupDiameter=0;
		protected double fourthGroupPressure=0;
		protected PatternBoundary flowPatternBoundary;
		protected bool setCoordinateFlag;
		protected FrmSetCoordinate coordinate;
		private void GetDataFromTxtFile (string fileName)
		{
			FileStream fileIn;
			StreamReader fileStringIn;
			try
			{
				fileIn = new FileStream(fileName,FileMode.Open);
				fileStringIn=new StreamReader(fileIn);
				fileStringIn.ReadLine();
				fileStringIn.ReadLine();
				int i=0;
				if (singleMapFlag)
				{
					for (int j=0;j<originalData.Length;j++)
					{
						originalData[j]=null;
						massFlux[j]=0;
						heatFlux[j]=0;
						quality[j]=0;
						Ugs[j]=0; //(m/s)
						Uls[j]=0; //(m/s)
						LockhartMartinelliParameter[j]=0;
						flowPattern[j]=null;
					}
				}
				if (multiMapFlag & firstMapFlag)
				{
					i=0;
					for (int j=0;j<originalData.Length;j++)
					{
						originalData[j]=null;
						massFlux[j]=0;
						heatFlux[j]=0;
						quality[j]=0;
						Ugs[j]=0; //(m/s)
						Uls[j]=0; //(m/s)
						LockhartMartinelliParameter[j]=0;
						flowPattern[j]=null;
					}
				}
				else if (multiMapFlag)
				{
					i=endOfLastGroupDataNo;
				}
				do
				{
					originalData[i]=fileStringIn.ReadLine();
					if (originalData[i]!=null)
					{
						for(int j=0;j<dataColumn;j++)
						{
							data[i,j]=(originalData[i].Split('\t'))[j];
						}
					}
					i++;
				}while (originalData[i-1]!=null);
				fileStringIn.Close();
			}
			catch(FileNotFoundException exc)
			{
				Console.WriteLine(exc.Message);
				return;
			}
			catch
			{
				Console.WriteLine("Cannot open file.");
				return;
			}
		}

		private void GetFluidParametersAndDataNumber()
		{
			diameter=0;
			averageT=0;
			averageP=0;
			int n=0, dataNo=0;
			if (multiMapFlag & firstMapFlag)
			{
				n=0;
				startNo=0;
			}
			else if (multiMapFlag)
			{
				n=endOfLastGroupDataNo;
				startNo=endOfLastGroupDataNo;
			}
			while (originalData[n]!=null)
			{
				diameter=diameter+double.Parse(data[n,0]); //(m)
				averageT=averageT+double.Parse(data[n,1]); //(C)
				averageP=averageP+100000*double.Parse(data[n,2]); //(bar-a)
				massFlowRate[n]=double.Parse(data[n,3]); //(kg/hr)
				massFlux[n]=double.Parse(data[n,4]); //(kg/m2s)
				heatFlux[n]=double.Parse(data[n,5]); //(kW/m2)
				quality[n]=double.Parse(data[n,7]);
				Ugs[n]=double.Parse(data[n,8]); //(m/s)
				Uls[n]=double.Parse(data[n,9]); //(m/s)
				flowPattern[n]=data[n,10];
				n++;
				dataNo++;
			}
			endOfLastGroupDataNo=n;
			diameter=diameter/dataNo;
			averageT=averageT/dataNo;
			averageP=averageP/dataNo;
			fluid=data[0,10];//for esisting data from other researchers
			if (fluid!="Air-Water"&&fluid!="Steam-Water")
			{
				fluid="R134a";
			}

			// deduce fluid parameters from the earlier experimental data;
			if (fluid=="Air-Water")
			{
				// deduce air-water parameters at 1bar 25C for the earlier experimental data;
				if (Math.Abs(averageT-25)<0.2 && Math.Abs(averageP-100000.0)<1)
				{
					airWater1bar25C=new AirWater1bar25CProperty();
					liquidDensity=airWater1bar25C.LiquidDensity;
					gasDensity=airWater1bar25C.VapourDensity;
					liquidViscosity=airWater1bar25C.LiquidViscosity;
					gasViscosity=airWater1bar25C.VapourViscosity;
					surfaceTension=airWater1bar25C.SurfaceTension;
					for(int i=0; i<dataNo; i++)
					{
						quality[i]=Ugs[i]*gasDensity/(Ugs[i]*gasDensity+Uls[i]*liquidDensity);
						massFlux[i]=Ugs[i]*gasDensity+Uls[i]*liquidDensity;
						massFlowRate[i]=3600*massFlux[i]*Math.PI*Math.Pow(diameter,2.0)/4.0;
					}
				}
			}
				// deduce R134a parameters obtained from the current experiments;
			else
			{
				R134a=new R134aProperty(273.15,averageP);
				satR134a=new R134aProperty(R134a.SaturatedTemperature,averageP);
				liquidDensity=satR134a.LiquidDensity;
				gasDensity=satR134a.VapourDensity;
				liquidViscosity=satR134a.SaturatedLiquidViscosity;
				gasViscosity=satR134a.SaturatedVapourViscosity;
				surfaceTension=satR134a.SurfaceTension;
			}
			// deduce coordinate parameters;
			airWater15C= new AirWater1bar15CProperty();
			refR134a=new R134a6barProperty();
			LamdaAirWater=Math.Sqrt((gasDensity*liquidDensity)/(airWater15C.VapourDensity*airWater15C.LiquidDensity));
			AitaAirWater=airWater15C.SurfaceTension/surfaceTension*Math.Pow((liquidViscosity/airWater15C.LiquidViscosity)*Math.Pow(airWater15C.LiquidDensity/liquidDensity,2),1.0/3.0);
			LamdaR134a=Math.Sqrt((gasDensity*liquidDensity)/(refR134a.VapourDensity*refR134a.LiquidDensity));
			AitaR134a=refR134a.SurfaceTension/surfaceTension*Math.Pow((liquidViscosity/refR134a.LiquidViscosity)*Math.Pow(refR134a.LiquidDensity/liquidDensity,2),1.0/3.0);
			ModifiedCoefficient1X=Math.Sqrt(gasDensity/(g*diameter*(liquidDensity-gasDensity)));
			ModifiedCoefficient1Y=Math.Sqrt(liquidDensity/(g*diameter*(liquidDensity-gasDensity)));
			ModifiedCoefficient2X=Math.Sqrt(gasDensity/Math.Sqrt(g*surfaceTension*(liquidDensity-gasDensity)));
			ModifiedCoefficient2Y=Math.Sqrt(liquidDensity/Math.Sqrt(g*surfaceTension*(liquidDensity-gasDensity)));
			ModifiedCoefficient3X=ModifiedCoefficient2X*Math.Sqrt(surfaceTension/(g*(liquidDensity-gasDensity)))/diameter;
			ModifiedCoefficient3Y=ModifiedCoefficient2Y*Math.Sqrt(surfaceTension/(g*(liquidDensity-gasDensity)))/diameter;							  
			ModifiedCoefficient4X=Math.Pow(gasDensity/(g*surfaceTension),0.25);
			ModifiedCoefficient4Y=Math.Pow(liquidDensity/(g*surfaceTension),0.25);
			for (int i=startNo; i<endOfLastGroupDataNo; i++)
			{
				Re_ls[i]=Uls[i]*liquidDensity*diameter/liquidViscosity;
				Re_gs[i]=Ugs[i]*gasDensity*diameter/gasViscosity;
				Rels=Re_ls[i];
				Regs=Re_gs[i];
			{
				Al=1/(Math.Pow(7/Rels,0.9)+0.27*Roughness/diameter);
				Al=Math.Pow(2.457*Math.Log(Al),16);
				Bl=Math.Pow(37530/Rels,16);
				Ag=1/(Math.Pow(7/Regs,0.9)+0.27*Roughness/diameter);
				Ag=Math.Pow(2.457*Math.Log(Ag),16);
				Bg=Math.Pow(37530/Regs,16);
				fl=Math.Pow(8/Rels,12)+1/Math.Pow(Al+Bl,3.0/2.0);
				fl=8*Math.Pow(fl,1.0/12.0);
				fg=Math.Pow(8/Regs,12)+1/Math.Pow(Ag+Bg,3.0/2.0);
				fg=8*Math.Pow(fg,1.0/12.0);
				DPls=0.5*fl*liquidDensity*Uls[i]*Uls[i]/diameter;
				DPgs=0.5*fg*gasDensity*Ugs[i]*Ugs[i]/diameter;
				LockhartMartinelliParameter[i]=Math.Sqrt(DPls/DPgs);	//Churchill equation
			}
			{
				if (Rels<=1000) fl0=64.0/Rels;
				else if (Rels>=2000 && Rels<=100000) fl0=0.314/Math.Pow(Rels,0.25);
				else if (Rels>1000 && Rels<2000) fl0=64.0/1000.0+(Rels-1000.0)*(0.314/Math.Pow(2000.0,0.25)-64.0/1000.0)/(2000.0-1000.0);
				else fl0=0.186/Math.Pow(Rels,0.20);
				if (Regs<=1000) fg0=64.0/Regs;
				else if (Regs>=2000 && Regs<=100000) fg0=0.314/Math.Pow(Regs,0.25);
				else if (Regs>1000 && Regs<2000) fg0=64.0/1000.0+(Regs-1000.0)*(0.314/Math.Pow(2000.0,0.25)-64.0/1000.0)/(2000.0-1000.0);
				else fg0=0.186/Math.Pow(Regs,0.20);
				DPls0=0.5*fl0*liquidDensity*Uls[i]*Uls[i]/diameter;
				DPgs0=0.5*fg0*gasDensity*Ugs[i]*Ugs[i]/diameter;
				MartinelliParameter[i]=Math.Sqrt(DPls0/DPgs0);			//Blasuis equation
			}
				GovierAirWaterCoordinateX[i]=Ugs[i]*Math.Pow(gasDensity/airWater15C.VapourDensity,1.0/3.0)*Math.Pow(liquidDensity*airWater15C.SurfaceTension/(airWater15C.LiquidDensity*surfaceTension),0.25);
				GovierAirWaterCoordinateY[i]=Uls[i]*Math.Pow(liquidDensity*airWater15C.SurfaceTension/(airWater15C.LiquidDensity*surfaceTension),0.25);
				GovierR134aCoordinateX[i]=Ugs[i]*Math.Pow(gasDensity/refR134a.VapourDensity,1.0/3.0)*Math.Pow(liquidDensity*refR134a.SurfaceTension/(refR134a.LiquidDensity*surfaceTension),0.25);
				GovierR134aCoordinateY[i]=Uls[i]*Math.Pow(liquidDensity*refR134a.SurfaceTension/(refR134a.LiquidDensity*surfaceTension),0.25);
				homogeneousVelocity[i]=Ugs[i]+Uls[i];
				volumeFlowRatio[i]=quality[i]*liquidDensity/(quality[i]*liquidDensity+(1-quality[i])*gasDensity);
				gasMassFlux[i]=Ugs[i]*gasDensity;
				liquidMassFlux[i]=Uls[i]*liquidDensity;
				Fr[i]=(Ugs[i]+Uls[i])/Math.Sqrt(g*diameter);
				HewittCoordinateX[i]=Ugs[i]*Ugs[i]*gasDensity;
				HewittCoordinateY[i]=Uls[i]*Uls[i]*liquidDensity;
				superficialVelocityRatio[i]=Ugs[i]/Uls[i];
				gasMassFlowRate[i]=quality[i]*massFlowRate[i]/3600;
				liquidMassFlowRate[i]=(1-quality[i])*massFlowRate[i]/3600;
				BakerAirWaterCoordinateX[i]=gasMassFlux[i]/LamdaAirWater;
				BakerAirWaterCoordinateY[i]=liquidMassFlux[i]*AitaAirWater;
				BakerR134aCoordinateX[i]=gasMassFlux[i]/LamdaR134a;
				BakerR134aCoordinateY[i]=liquidMassFlux[i]*AitaR134a;
				SchichtAirWaterCoordinateX[i]=liquidMassFlux[i]/(gasMassFlux[i])*LamdaAirWater*AitaAirWater;
				SchichtAirWaterCoordinateY[i]=gasMassFlux[i]/LamdaAirWater;
				SchichtR134aCoordinateX[i]=liquidMassFlux[i]/(gasMassFlux[i])*LamdaR134a*AitaR134a;
				SchichtR134aCoordinateY[i]=gasMassFlux[i]/LamdaR134a;
				BarneaParameter[i]=g*(liquidDensity-gasDensity)/DPgs;
				We_ls[i]=liquidDensity*Uls[i]*Uls[i]*diameter/surfaceTension;
				We_gs[i]=gasDensity*Ugs[i]*Ugs[i]*diameter/surfaceTension;
				ModifiedUgs1[i]=Ugs[i]*ModifiedCoefficient1X;
				ModifiedUls1[i]=Uls[i]*ModifiedCoefficient1Y;
				ModifiedUgs2[i]=Ugs[i]*ModifiedCoefficient2X;
				ModifiedUls2[i]=Uls[i]*ModifiedCoefficient2Y;
				ModifiedUgs3[i]=Ugs[i]*ModifiedCoefficient3X;
				ModifiedUls3[i]=Uls[i]*ModifiedCoefficient3Y;
				ModifiedUgs4[i]=Ugs[i]*ModifiedCoefficient4X;
				ModifiedUls4[i]=Uls[i]*ModifiedCoefficient4Y;
				XWegs[i]=MartinelliParameter[i]*We_gs[i];		//Blasuis equation
				GWels[i]=massFlux[i]*We_ls[i];
				Fr_gs[i]=Ugs[i]/Math.Sqrt(g*diameter);
				Fr_ls[i]=Uls[i]/Math.Sqrt(g*diameter);
				FrgsRegs[i]=Fr_gs[i]*Re_gs[i];
				FrlsRels[i]=Fr_ls[i]*Re_ls[i];
				XX1[i]=We_gs[i];
				YY1[i]=We_ls[i];
				//XX1[i]=Fr_gs[i];
				//YY1[i]=Fr_ls[i];
				//XX2[i]=MartinelliParameter[i];
				//YY2[i]=massFlux[i];
				//XX2[i]=HewittCoordinateX[i];
				//YY2[i]=HewittCoordinateY[i];
				//XX2[i]=ModifiedUgs1[i];
				//YY2[i]=ModifiedUgs1[i];
				XX2[i]=Re_gs[i];
				YY2[i]=Re_ls[i];
				XX[i]=XX1[i]*XX2[i];
				YY[i]=YY1[i]*YY2[i];
			}

			if (multiMapFlag & firstMapFlag)
			{
				firstGroupDiameter=diameter;
				firstGroupPressure=averageP;
				firstGroupStartNo=startNo;
				firstGroupEndNo=endOfLastGroupDataNo;
			}
			if (multiMapFlag & secondMapFlag)
			{
				secondGroupDiameter=diameter;
				secondGroupPressure=averageP;
				secondGroupStartNo=startNo+1;
				secondGroupEndNo=endOfLastGroupDataNo;
			}
			if (multiMapFlag & thirdMapFlag)
			{
				thirdGroupDiameter=diameter;
				thirdGroupPressure=averageP;
				thirdGroupStartNo=startNo+1;
				thirdGroupEndNo=endOfLastGroupDataNo;
			}
			if (multiMapFlag & fourthMapFlag)
			{
				fourthGroupDiameter=diameter;
				fourthGroupPressure=averageP;
				fourthGroupStartNo=startNo+1;
				fourthGroupEndNo=endOfLastGroupDataNo;
			}
		}

		private void InitializeComponent()
		{
			// 
			// Data
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 273);
			this.Name = "Data";

		}
	
		protected void sourceData(string fileName)
		{
			this.GetDataFromTxtFile(fileName);
			this.GetFluidParametersAndDataNumber();
			if (fluid=="Air-Water")
			{
				// deduce air-water parameters at 1bar 25C for the earlier experimental data;
				if (Math.Abs(averageT-25)<0.2 && Math.Abs(averageP-100000.0)<1)
				{
					flowPatternBoundary=new PatternBoundary(diameter,"AirWater1bar25C");
				}
			}
			if (fluid=="R134a")
			{
				flowPatternBoundary=new PatternBoundary(averageP,diameter);
			}
		}
	}

}
