using System;
using System.IO;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace SBU.HTRRL.FlowPattern.DataAnalysis
{
	/// <summary>
	/// Summary description for FrmGetFlowPatternData.
	/// </summary>
	public class FrmGetFlowPatternData : System.Windows.Forms.Form
	{
		private System.Windows.Forms.OpenFileDialog openFileDialog1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.OpenFileDialog openFileDialog2;
		private string DataResource;
		private string DataResult="";
		private double d,t,p,m,X,Ug,Ul;
		private double massFlux,heatFlux,thermalLoss;
		private string patternFileName;
		private System.Windows.Forms.Button cmdGetData;
		private System.Windows.Forms.Label labP;
		private System.Windows.Forms.TextBox txtP;
		private System.Windows.Forms.Label labT;
		private System.Windows.Forms.TextBox txtT;
		private System.Windows.Forms.TextBox txtUl;
		private System.Windows.Forms.Label labUl;
		private System.Windows.Forms.TextBox txtUg;
		private System.Windows.Forms.Label labUg;
		private System.Windows.Forms.TextBox txtX;
		private System.Windows.Forms.Label labX;
		private System.Windows.Forms.Label labFlowPattern;
		private System.Windows.Forms.TextBox txtFlowPattern;
		private System.Windows.Forms.Button cmdSaveData;
		private System.Windows.Forms.Label labF;
		private System.Windows.Forms.TextBox txtF;
		private System.Windows.Forms.Label labPatternFileName;
		private System.Windows.Forms.TextBox txtPatternFileName;
		private System.Windows.Forms.Button cmdExit;
		private System.Windows.Forms.Label labState;
		private System.Windows.Forms.TextBox txtPoint3State;
		private string flowPattern, Point3State;


		public FrmGetFlowPatternData()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.openFileDialog1 = new System.Windows.Forms.OpenFileDialog();
			this.cmdGetData = new System.Windows.Forms.Button();
			this.labP = new System.Windows.Forms.Label();
			this.txtP = new System.Windows.Forms.TextBox();
			this.labT = new System.Windows.Forms.Label();
			this.txtT = new System.Windows.Forms.TextBox();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.txtPoint3State = new System.Windows.Forms.TextBox();
			this.labState = new System.Windows.Forms.Label();
			this.txtUl = new System.Windows.Forms.TextBox();
			this.labUl = new System.Windows.Forms.Label();
			this.txtUg = new System.Windows.Forms.TextBox();
			this.labUg = new System.Windows.Forms.Label();
			this.txtX = new System.Windows.Forms.TextBox();
			this.labX = new System.Windows.Forms.Label();
			this.labFlowPattern = new System.Windows.Forms.Label();
			this.txtFlowPattern = new System.Windows.Forms.TextBox();
			this.cmdSaveData = new System.Windows.Forms.Button();
			this.openFileDialog2 = new System.Windows.Forms.OpenFileDialog();
			this.labF = new System.Windows.Forms.Label();
			this.txtF = new System.Windows.Forms.TextBox();
			this.labPatternFileName = new System.Windows.Forms.Label();
			this.txtPatternFileName = new System.Windows.Forms.TextBox();
			this.cmdExit = new System.Windows.Forms.Button();
			this.groupBox1.SuspendLayout();
			this.SuspendLayout();
			// 
			// openFileDialog1
			// 
			this.openFileDialog1.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog1_FileOk);
			// 
			// cmdGetData
			// 
			this.cmdGetData.Location = new System.Drawing.Point(16, 256);
			this.cmdGetData.Name = "cmdGetData";
			this.cmdGetData.Size = new System.Drawing.Size(72, 24);
			this.cmdGetData.TabIndex = 7;
			this.cmdGetData.Text = "Get Data";
			this.cmdGetData.Click += new System.EventHandler(this.cmdGetData_Click);
			// 
			// labP
			// 
			this.labP.Location = new System.Drawing.Point(128, 12);
			this.labP.Name = "labP";
			this.labP.Size = new System.Drawing.Size(56, 16);
			this.labP.TabIndex = 11;
			this.labP.Text = "P (bar-a)";
			// 
			// txtP
			// 
			this.txtP.Location = new System.Drawing.Point(188, 8);
			this.txtP.Name = "txtP";
			this.txtP.Size = new System.Drawing.Size(48, 20);
			this.txtP.TabIndex = 10;
			this.txtP.Text = "";
			// 
			// labT
			// 
			this.labT.Location = new System.Drawing.Point(16, 12);
			this.labT.Name = "labT";
			this.labT.Size = new System.Drawing.Size(40, 16);
			this.labT.TabIndex = 9;
			this.labT.Text = "T (C)";
			// 
			// txtT
			// 
			this.txtT.Location = new System.Drawing.Point(68, 8);
			this.txtT.Name = "txtT";
			this.txtT.Size = new System.Drawing.Size(52, 20);
			this.txtT.TabIndex = 8;
			this.txtT.Text = "";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.txtPoint3State,
																					this.labState,
																					this.txtUl,
																					this.labUl,
																					this.txtUg,
																					this.labUg,
																					this.txtX,
																					this.labX});
			this.groupBox1.Location = new System.Drawing.Point(16, 120);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(232, 128);
			this.groupBox1.TabIndex = 12;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Calculate Result";
			// 
			// txtPoint3State
			// 
			this.txtPoint3State.AcceptsTab = true;
			this.txtPoint3State.BackColor = System.Drawing.Color.White;
			this.txtPoint3State.Location = new System.Drawing.Point(104, 32);
			this.txtPoint3State.Name = "txtPoint3State";
			this.txtPoint3State.Size = new System.Drawing.Size(96, 20);
			this.txtPoint3State.TabIndex = 7;
			this.txtPoint3State.Text = "";
			// 
			// labState
			// 
			this.labState.Location = new System.Drawing.Point(16, 32);
			this.labState.Name = "labState";
			this.labState.Size = new System.Drawing.Size(72, 16);
			this.labState.TabIndex = 6;
			this.labState.Text = "Point3 State";
			// 
			// txtUl
			// 
			this.txtUl.Location = new System.Drawing.Point(160, 96);
			this.txtUl.Name = "txtUl";
			this.txtUl.Size = new System.Drawing.Size(56, 20);
			this.txtUl.TabIndex = 5;
			this.txtUl.Text = "";
			// 
			// labUl
			// 
			this.labUl.Location = new System.Drawing.Point(128, 96);
			this.labUl.Name = "labUl";
			this.labUl.Size = new System.Drawing.Size(28, 20);
			this.labUl.TabIndex = 4;
			this.labUl.Text = "Uls";
			// 
			// txtUg
			// 
			this.txtUg.Location = new System.Drawing.Point(48, 96);
			this.txtUg.Name = "txtUg";
			this.txtUg.Size = new System.Drawing.Size(56, 20);
			this.txtUg.TabIndex = 3;
			this.txtUg.Text = "";
			// 
			// labUg
			// 
			this.labUg.Location = new System.Drawing.Point(16, 96);
			this.labUg.Name = "labUg";
			this.labUg.Size = new System.Drawing.Size(28, 20);
			this.labUg.TabIndex = 2;
			this.labUg.Text = "Ugs";
			// 
			// txtX
			// 
			this.txtX.Location = new System.Drawing.Point(48, 64);
			this.txtX.Name = "txtX";
			this.txtX.Size = new System.Drawing.Size(56, 20);
			this.txtX.TabIndex = 1;
			this.txtX.Text = "";
			// 
			// labX
			// 
			this.labX.Location = new System.Drawing.Point(16, 64);
			this.labX.Name = "labX";
			this.labX.Size = new System.Drawing.Size(24, 20);
			this.labX.TabIndex = 0;
			this.labX.Text = "x";
			// 
			// labFlowPattern
			// 
			this.labFlowPattern.Location = new System.Drawing.Point(16, 96);
			this.labFlowPattern.Name = "labFlowPattern";
			this.labFlowPattern.Size = new System.Drawing.Size(68, 16);
			this.labFlowPattern.TabIndex = 14;
			this.labFlowPattern.Text = "Flow Pattern";
			// 
			// txtFlowPattern
			// 
			this.txtFlowPattern.Location = new System.Drawing.Point(88, 92);
			this.txtFlowPattern.Name = "txtFlowPattern";
			this.txtFlowPattern.Size = new System.Drawing.Size(96, 20);
			this.txtFlowPattern.TabIndex = 13;
			this.txtFlowPattern.Text = "";
			// 
			// cmdSaveData
			// 
			this.cmdSaveData.Location = new System.Drawing.Point(104, 256);
			this.cmdSaveData.Name = "cmdSaveData";
			this.cmdSaveData.Size = new System.Drawing.Size(72, 24);
			this.cmdSaveData.TabIndex = 15;
			this.cmdSaveData.Text = "Save Data";
			this.cmdSaveData.Click += new System.EventHandler(this.cmdSaveData_Click);
			// 
			// openFileDialog2
			// 
			this.openFileDialog2.FileOk += new System.ComponentModel.CancelEventHandler(this.openFileDialog2_FileOk);
			// 
			// labF
			// 
			this.labF.Location = new System.Drawing.Point(16, 40);
			this.labF.Name = "labF";
			this.labF.Size = new System.Drawing.Size(48, 16);
			this.labF.TabIndex = 17;
			this.labF.Text = "F (kg/hr)";
			// 
			// txtF
			// 
			this.txtF.Location = new System.Drawing.Point(68, 36);
			this.txtF.Name = "txtF";
			this.txtF.Size = new System.Drawing.Size(52, 20);
			this.txtF.TabIndex = 16;
			this.txtF.Text = "";
			// 
			// labPatternFileName
			// 
			this.labPatternFileName.Location = new System.Drawing.Point(16, 68);
			this.labPatternFileName.Name = "labPatternFileName";
			this.labPatternFileName.Size = new System.Drawing.Size(68, 16);
			this.labPatternFileName.TabIndex = 19;
			this.labPatternFileName.Text = "Pattern File";
			// 
			// txtPatternFileName
			// 
			this.txtPatternFileName.Location = new System.Drawing.Point(88, 64);
			this.txtPatternFileName.Name = "txtPatternFileName";
			this.txtPatternFileName.Size = new System.Drawing.Size(96, 20);
			this.txtPatternFileName.TabIndex = 18;
			this.txtPatternFileName.Text = "";
			// 
			// cmdExit
			// 
			this.cmdExit.Location = new System.Drawing.Point(192, 256);
			this.cmdExit.Name = "cmdExit";
			this.cmdExit.Size = new System.Drawing.Size(72, 24);
			this.cmdExit.TabIndex = 20;
			this.cmdExit.Text = "Exit";
			this.cmdExit.Click += new System.EventHandler(this.cmdExit_Click);
			// 
			// FrmGetFlowPatternData
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(312, 293);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdExit,
																		  this.labPatternFileName,
																		  this.txtPatternFileName,
																		  this.labF,
																		  this.txtF,
																		  this.cmdSaveData,
																		  this.labFlowPattern,
																		  this.txtFlowPattern,
																		  this.groupBox1,
																		  this.labP,
																		  this.txtP,
																		  this.labT,
																		  this.txtT,
																		  this.cmdGetData});
			this.Name = "FrmGetFlowPatternData";
			this.Text = "Flow Pattern Data";
			this.Load += new System.EventHandler(this.FrmGetFlowPatternData_Load);
			this.groupBox1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void openFileDialog1_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			string[] DataResourceFold=new string[6];
			int j=0;
			char[] DataResourceNo=new char[16];
			DataResource=this.openFileDialog1.FileName;
			DataResourceFold=DataResource.Split('\\');
			for (int i=0; i<DataResourceFold.Length;i++)
				if (DataResourceFold[i]!="")
					j++;
			DataResourceNo=DataResourceFold[j-1].ToCharArray();
			DataResourceNo[11]=(char)((int)DataResourceNo[11]+1);
			this.openFileDialog1.FileName=DataResourceFold[j-1].Remove(11,5) + DataResourceNo[11].ToString();
		}

		private void cmdGetData_Click(object sender, System.EventArgs e)
		{
			openFileDialog1.Filter="Text files (*.txt)|*.txt|All files (*.*)|*.*";
			openFileDialog1.ShowDialog();
			TargetData Parameters=new TargetData(DataResource);
			d=Parameters.D;
			t=Parameters.T;
			p=Parameters.P;
			patternFileName=Parameters.PatternFileName.Trim();
			flowPattern=Parameters.FlowPattern.Trim();
			m=Parameters.M;
			massFlux=Parameters.getMassFlux();
			heatFlux=Parameters.getHeatFlux();
			X=Parameters.getOutletQuality();
			Ug=Parameters.getOutletVapourVelocity();
			Ul=Parameters.getOutletLiquidVelocity();
			Point3State=Parameters.getInletFluidState();
			thermalLoss=Parameters.ThermalLoss2;
			txtT.Text=(Math.Round((t-273.15),2)).ToString();
			txtP.Text=(Math.Round((p/100000),2)).ToString();
			txtPatternFileName.Text=patternFileName;
			txtFlowPattern.Text=flowPattern;
			txtF.Text=(Math.Round((m*3600),2)).ToString();
			txtPoint3State.Text=Point3State;
			txtPoint3State.BackColor=Color.White;
			if (Point3State!="liquid")
			{
				txtPoint3State.BackColor=Color.Red;
			}
			txtX.Text=(Math.Round(X,3)).ToString();
			txtUg.Text=(Math.Round(Ug,2)).ToString();
			txtUl.Text=(Math.Round(Ul,2)).ToString();

			cmdSaveData.Enabled=true;
		}

		private void cmdSaveData_Click(object sender, System.EventArgs e)
		{
			string title;
			FileStream resultFile;
			StreamReader fileStringIn;
			StreamWriter fileStringOut;

			if (DataResult=="")
			{
				openFileDialog2.Filter="Text files (*.txt)|*.txt|All files (*.*)|*.*";
				openFileDialog2.ShowDialog();
			}

			try
			{
				resultFile = new FileStream(DataResult,FileMode.Open);
				fileStringIn=new StreamReader(resultFile);
				title=fileStringIn.ReadLine();
				fileStringIn.Close();
				if (title==null)
				{
					resultFile = new FileStream(DataResult,FileMode.Append);
					fileStringOut=new StreamWriter(resultFile);
					fileStringOut.Write("D"+"\t");
					fileStringOut.Write("T"+"\t");
					fileStringOut.Write("P"+"\t");
					fileStringOut.Write("M"+"\t");
					fileStringOut.Write("MF"+"\t");
					fileStringOut.Write("HF"+"\t");
					fileStringOut.Write("Loss"+"\t");
					fileStringOut.Write("X"+"\t");
					fileStringOut.Write("Ugs"+"\t");
					fileStringOut.Write("Uls"+"\t");
					fileStringOut.Write("Flow Pattern"+"\t\t");
					fileStringOut.Write("Pattern File"+"");
					fileStringOut.WriteLine();
					fileStringOut.Write("(m)"+"\t");
					fileStringOut.Write("(C)"+"\t");
					fileStringOut.Write("(bar-a)"+"\t");
					fileStringOut.Write("(kg/hr)"+"\t");
					fileStringOut.Write("kg/m2.s"+"\t");
					fileStringOut.Write("(kW/m2)"+"\t");
					fileStringOut.Write("(W)"+"\t");
					fileStringOut.Write(""+"\t");
					fileStringOut.Write("(m/s)"+"\t");
					fileStringOut.Write("(m/s)"+"\t");
					fileStringOut.Write(""+"\t\t");
					fileStringOut.Write(""+"");
					fileStringOut.WriteLine();
					fileStringOut.Close();
				}

				resultFile = new FileStream(DataResult,FileMode.Append);
				fileStringOut=new StreamWriter(resultFile);

				fileStringOut.Write(d.ToString()+"\t");
				fileStringOut.Write((Math.Round((t-273.15),2)).ToString()+"\t");
				fileStringOut.Write((Math.Round((p/100000),2)).ToString()+"\t");
				fileStringOut.Write((Math.Round((m*3600),2)).ToString()+"\t");
				fileStringOut.Write((Math.Round((massFlux),2)).ToString()+"\t");
				fileStringOut.Write((Math.Round((heatFlux/1000),2)).ToString()+"\t");
				fileStringOut.Write((Math.Round(thermalLoss,2)).ToString()+"\t");
				fileStringOut.Write((Math.Round(X,3)).ToString()+"\t");
				fileStringOut.Write((Math.Round(Ug,2)).ToString()+"\t");
				fileStringOut.Write((Math.Round(Ul,2)).ToString()+"\t");

				if (flowPattern.Length<8)
					fileStringOut.Write(flowPattern+"\t\t\t");
				else if (flowPattern.Length>=8 && flowPattern.Length<16)
					fileStringOut.Write(flowPattern+"\t\t");
				else if (flowPattern.Length>=16 && flowPattern.Length<24)
					fileStringOut.Write(flowPattern+"\t");

				fileStringOut.Write(patternFileName+"");
				fileStringOut.WriteLine();
				fileStringOut.Close();
				cmdSaveData.Enabled=false;
			}
			catch(FileNotFoundException exc)
			{
				Console.WriteLine(exc.Message);
				return;
			}
			catch
			{
				Console.WriteLine("Cannot open file.");
				return;
			}
			cmdGetData_Click(sender, e);
		}

		private void openFileDialog2_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			DataResult=this.openFileDialog2.FileName;
		}

		private void FrmGetFlowPatternData_Load(object sender, System.EventArgs e)
		{
			cmdSaveData.Enabled=false;
		}

		private void cmdExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

	}

}
