using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace  SBU.HTRRL.FlowPattern.DataAnalysis
{
	/// <summary>
	/// Summary description for FrmR134a.
	/// </summary>
	public class FrmUncertaintyAnalysis : System.Windows.Forms.Form
	{
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private double P,D,Ugs,Uls,Ta,T8_subcooling;
		private double Tsat,Tw,K_T8toT3,K_T3toT4,K,T8,T3,T4,T0,m,x,Q_loss,Q;
		private string state;
		private double Ts,Ps,Rol,Rov,Hl,Hv,Hfg,Mul,Muv,St;
		private double Ts_dP,Rol_dP,Rov_dP,Hl_dP,Hv_dP,Hfg_dP,Mul_dP,Muv_dP,St_dP;
		private double Ps_dT,Rol_dT,Rov_dT,Hl_dT,Hv_dT,Hfg_dT,Mul_dT,Muv_dT,St_dT;
		private double U_P3,U_P4,U_P0,U_P,U_D,U_m,U_Q;
		private double E_P3,E_P4,E_P0,E_P,E_T3,E_T4,E_T0,E_TT,E_D,E_m,E_Q;
		private double E_Ts,E_Ps,E_Rol,E_Rov,E_Hl,E_Hv,E_Hfg,E_Mul,E_Muv,E_St;
		private double U_Ts,U_Ps,U_Rol,U_Rov,U_Hl,U_Hv,U_Hfg,U_Mul,U_Muv,U_St;
		private double E_AverageWallTemperatureDifference,U_K,U_Qloss,E_Qloss;
		private double E_Hmixture,E_x,E_Ugs,E_Uls;
		private R134aProperty R134aParameter,R134a_Saturated,R134a_Point3,R134a_Point4,R134a_Point0,R134a_ObservationPoint;
		private R134aPropertyUncertainty R134aUncertainty,R134aUncertainty_Point3,R134aUncertainty_Point4,R134aUncertainty_Point0,R134aUncertainty_ObservationPoint;

		private System.ComponentModel.Container components = null;
		private System.Windows.Forms.GroupBox grpOutput;
		private System.Windows.Forms.Label labSurfaceTension;
		private System.Windows.Forms.TextBox txtSurfaceTension;
		private System.Windows.Forms.Label labVapourViscosity;
		private System.Windows.Forms.Label labLiquidViscosity;
		private System.Windows.Forms.Label labLiquidEnthalpy;
		private System.Windows.Forms.TextBox txtLiquidEnthalpy;
		private System.Windows.Forms.Label labVapourDensity;
		private System.Windows.Forms.TextBox txtVapourDensity;
		private System.Windows.Forms.Label labLiquidDensity;
		private System.Windows.Forms.TextBox txtLiquidDensity;
		private System.Windows.Forms.Label labState;
		private System.Windows.Forms.TextBox txtState;
		private System.Windows.Forms.Label labPs;
		private System.Windows.Forms.Label labTs;
		private System.Windows.Forms.Button cmdExit;
		private System.Windows.Forms.GroupBox grpOriginalData;
		private System.Windows.Forms.TextBox txtPressure;
		private System.Windows.Forms.Label labT;
		private System.Windows.Forms.Label labP;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.TextBox txtSurfaceTensionUncertainty;
		private System.Windows.Forms.TextBox txtVapourEnthalpyUncertainty;
		private System.Windows.Forms.TextBox txtLiquidEnthalpyUncertainty;
		private System.Windows.Forms.TextBox txtVapourDensityUncertainty;
		private System.Windows.Forms.TextBox txtLiquidDensityUncertainty;
		private System.Windows.Forms.TextBox txtSurfaceTensionError;
		private System.Windows.Forms.TextBox txtVapourEnthalpyError;
		private System.Windows.Forms.TextBox txtLiquidEnthalpyError;
		private System.Windows.Forms.TextBox txtVapourDensityError;
		private System.Windows.Forms.TextBox txtLiquidDensityError;
		private System.Windows.Forms.TextBox txtSurfaceTension_DP;
		private System.Windows.Forms.TextBox txtVapourEnthalpy_DP;
		private System.Windows.Forms.TextBox txtLiquidEnthalpy_DP;
		private System.Windows.Forms.TextBox txtVapourDensity_DP;
		private System.Windows.Forms.TextBox txtLiquidDensity_DP;
		private System.Windows.Forms.TextBox txtSurfaceTension_DT;
		private System.Windows.Forms.TextBox txtVapourEnthalpy_DT;
		private System.Windows.Forms.TextBox txtLiquidEnthalpy_DT;
		private System.Windows.Forms.TextBox txtVapourDensity_DT;
		private System.Windows.Forms.TextBox txtLiquidDensity_DT;
		private System.Windows.Forms.TextBox txtSaturatedVapourViscosityUncertainty;
		private System.Windows.Forms.TextBox txtSaturatedLiquidViscosityUncertainty;
		private System.Windows.Forms.TextBox txtSaturatedVapourViscosityError;
		private System.Windows.Forms.TextBox txtSaturatedLiquidViscosityError;
		private System.Windows.Forms.TextBox txtSaturatedVapourViscosity_DP;
		private System.Windows.Forms.TextBox txtSaturatedLiquidViscosity_DP;
		private System.Windows.Forms.TextBox txtSaturatedVapourViscosity_DT;
		private System.Windows.Forms.TextBox txtSaturatedLiquidViscosity_DT;
		private System.Windows.Forms.TextBox txtSaturatedVapourViscosity;
		private System.Windows.Forms.TextBox txtSaturatedLiquidViscosity;
		private System.Windows.Forms.TextBox txtSaturatedPressureUncertainty;
		private System.Windows.Forms.TextBox txtSaturatedTemperatureUncertainty;
		private System.Windows.Forms.TextBox txtSaturatedTemperature;
		private System.Windows.Forms.TextBox txtSaturatedPressure;
		private System.Windows.Forms.TextBox txtSaturatedPressureError;
		private System.Windows.Forms.TextBox txtSaturatedTemperatureError;
		private System.Windows.Forms.TextBox txtSaturatedTemperature_DP;
		private System.Windows.Forms.TextBox txtSaturatedPressure_DT;
		private System.Windows.Forms.Label labVapourEnthalpy;
		private System.Windows.Forms.TextBox txtVapourEnthalpy;
		private System.Windows.Forms.TextBox txtLatentHeatUncertainty;
		private System.Windows.Forms.TextBox txtLatentHeatError;
		private System.Windows.Forms.TextBox txtLatentHeat_DP;
		private System.Windows.Forms.TextBox txtLatentHeat_DT;
		private System.Windows.Forms.Label labLatentHeat;
		private System.Windows.Forms.TextBox txtLatentHeat;
		private System.Windows.Forms.TextBox txtP3Uncertainty;
		private System.Windows.Forms.TextBox txtP4Uncertainty;
		private System.Windows.Forms.TextBox txtP0Uncertainty;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.TextBox txtPressureUncertainty;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.TextBox txtP3Error;
		private System.Windows.Forms.Label label13;
		private System.Windows.Forms.TextBox txtP4Error;
		private System.Windows.Forms.TextBox txtP0Error;
		private System.Windows.Forms.TextBox txtPressureError;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.TextBox txtT3Uncertainty;
		private System.Windows.Forms.TextBox txtT4Uncertainty;
		private System.Windows.Forms.TextBox txtT0Uncertainty;
		private System.Windows.Forms.Label label18;
		private System.Windows.Forms.Label label19;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.GroupBox groupBox1;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label20;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Label label22;
		private System.Windows.Forms.Label label23;
		private System.Windows.Forms.Label label24;
		private System.Windows.Forms.GroupBox groupBox2;
		private System.Windows.Forms.Label label27;
		private System.Windows.Forms.Label label28;
		private System.Windows.Forms.Label label29;
		private System.Windows.Forms.Label label30;
		private System.Windows.Forms.Label label31;
		private System.Windows.Forms.Label label32;
		private System.Windows.Forms.Label label25;
		private System.Windows.Forms.Label label26;
		private System.Windows.Forms.TextBox txtGasSuperficialVelocity;
		private System.Windows.Forms.TextBox txtLiquidSuperficialVelocity;
		private System.Windows.Forms.TextBox txtT8SubcoolingDegree;
		private System.Windows.Forms.TextBox txtWellTemperature;
		private System.Windows.Forms.TextBox txtAmbientTemperature;
		private System.Windows.Forms.TextBox txtThermallossCoefficient_T8toT3;
		private System.Windows.Forms.TextBox txtThermallossCoefficient_T3toT4;
		private System.Windows.Forms.TextBox txtThermallossCoefficient_T3toT;
		private System.Windows.Forms.Button cmdComfirm;
		private System.Windows.Forms.Label label33;
		private System.Windows.Forms.TextBox txtSatTemperature;
		private System.Windows.Forms.TextBox txtTemperature_T8;
		private System.Windows.Forms.TextBox txtTemperature_T3;
		private System.Windows.Forms.TextBox txtTemperature_T4;
		private System.Windows.Forms.TextBox txtTemperature_T0;
		private System.Windows.Forms.TextBox txtThermalloss;
		private System.Windows.Forms.TextBox txtPower;
		private System.Windows.Forms.TextBox txtQuality;
		private System.Windows.Forms.TextBox txtFlowrate;
		private System.Windows.Forms.ComboBox comboBoxPosition;
		private System.Windows.Forms.ComboBox comboBoxDiameter;
		private System.Windows.Forms.Label label34;
		private System.Windows.Forms.Label label35;
		private System.Windows.Forms.TextBox txtP;
		private System.Windows.Forms.TextBox txtT;
		private System.Windows.Forms.Label label36;
		private System.Windows.Forms.TextBox txtDiameterUncertainty;
		private System.Windows.Forms.Label label37;
		private System.Windows.Forms.TextBox txtFlowrateUncertainty;
		private System.Windows.Forms.TextBox txtFlowrateError;
		private System.Windows.Forms.Label label38;
		private System.Windows.Forms.TextBox txtPowerUncertainty;
		private System.Windows.Forms.TextBox txtPowerError;
		private System.Windows.Forms.Label label39;
		private System.Windows.Forms.Button cmdChange;
		private System.Windows.Forms.TextBox txtTTUncertainty;
		private System.Windows.Forms.GroupBox groupBox3;
		private System.Windows.Forms.TextBox txtAlarm;
		private System.Windows.Forms.TextBox txtDiameterError;
		private System.Windows.Forms.GroupBox groupBox4;
		private System.Windows.Forms.Label label40;
		private System.Windows.Forms.Label label42;
		private System.Windows.Forms.Label label47;
		private System.Windows.Forms.Label label52;
		private System.Windows.Forms.Label label41;
		private System.Windows.Forms.TextBox txtUlsUncertainty;
		private System.Windows.Forms.TextBox txtThermallossUncertainty;
		private System.Windows.Forms.TextBox txtQualityUncertainty;
		private System.Windows.Forms.TextBox txtUgsUncertainty;
		private System.Windows.Forms.TextBox txtThermallossCoefficientUncertainty;
		private System.Windows.Forms.Button cmdCalculate;
		private System.Windows.Forms.Label labSensor;

		public FrmUncertaintyAnalysis()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.grpOutput = new System.Windows.Forms.GroupBox();
			this.label35 = new System.Windows.Forms.Label();
			this.txtT = new System.Windows.Forms.TextBox();
			this.txtP = new System.Windows.Forms.TextBox();
			this.label34 = new System.Windows.Forms.Label();
			this.txtLatentHeatUncertainty = new System.Windows.Forms.TextBox();
			this.txtLatentHeatError = new System.Windows.Forms.TextBox();
			this.txtLatentHeat_DP = new System.Windows.Forms.TextBox();
			this.txtLatentHeat_DT = new System.Windows.Forms.TextBox();
			this.labLatentHeat = new System.Windows.Forms.Label();
			this.txtLatentHeat = new System.Windows.Forms.TextBox();
			this.txtSaturatedPressureUncertainty = new System.Windows.Forms.TextBox();
			this.txtSaturatedTemperatureUncertainty = new System.Windows.Forms.TextBox();
			this.txtSaturatedVapourViscosityUncertainty = new System.Windows.Forms.TextBox();
			this.label7 = new System.Windows.Forms.Label();
			this.txtSurfaceTensionUncertainty = new System.Windows.Forms.TextBox();
			this.txtSaturatedLiquidViscosityUncertainty = new System.Windows.Forms.TextBox();
			this.txtVapourEnthalpyUncertainty = new System.Windows.Forms.TextBox();
			this.txtLiquidEnthalpyUncertainty = new System.Windows.Forms.TextBox();
			this.txtVapourDensityUncertainty = new System.Windows.Forms.TextBox();
			this.txtLiquidDensityUncertainty = new System.Windows.Forms.TextBox();
			this.txtSaturatedTemperature = new System.Windows.Forms.TextBox();
			this.txtSaturatedPressure = new System.Windows.Forms.TextBox();
			this.txtSaturatedPressureError = new System.Windows.Forms.TextBox();
			this.txtSaturatedTemperatureError = new System.Windows.Forms.TextBox();
			this.txtSaturatedTemperature_DP = new System.Windows.Forms.TextBox();
			this.txtSaturatedPressure_DT = new System.Windows.Forms.TextBox();
			this.txtSaturatedVapourViscosityError = new System.Windows.Forms.TextBox();
			this.label6 = new System.Windows.Forms.Label();
			this.txtSurfaceTensionError = new System.Windows.Forms.TextBox();
			this.txtSaturatedLiquidViscosityError = new System.Windows.Forms.TextBox();
			this.txtVapourEnthalpyError = new System.Windows.Forms.TextBox();
			this.txtLiquidEnthalpyError = new System.Windows.Forms.TextBox();
			this.txtVapourDensityError = new System.Windows.Forms.TextBox();
			this.txtLiquidDensityError = new System.Windows.Forms.TextBox();
			this.txtSaturatedVapourViscosity_DP = new System.Windows.Forms.TextBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtSurfaceTension_DP = new System.Windows.Forms.TextBox();
			this.txtSaturatedLiquidViscosity_DP = new System.Windows.Forms.TextBox();
			this.txtVapourEnthalpy_DP = new System.Windows.Forms.TextBox();
			this.txtLiquidEnthalpy_DP = new System.Windows.Forms.TextBox();
			this.txtVapourDensity_DP = new System.Windows.Forms.TextBox();
			this.txtLiquidDensity_DP = new System.Windows.Forms.TextBox();
			this.txtSaturatedVapourViscosity_DT = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.txtSurfaceTension_DT = new System.Windows.Forms.TextBox();
			this.txtSaturatedLiquidViscosity_DT = new System.Windows.Forms.TextBox();
			this.txtVapourEnthalpy_DT = new System.Windows.Forms.TextBox();
			this.txtLiquidEnthalpy_DT = new System.Windows.Forms.TextBox();
			this.txtVapourDensity_DT = new System.Windows.Forms.TextBox();
			this.txtLiquidDensity_DT = new System.Windows.Forms.TextBox();
			this.txtSaturatedVapourViscosity = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.labSurfaceTension = new System.Windows.Forms.Label();
			this.txtSurfaceTension = new System.Windows.Forms.TextBox();
			this.labVapourViscosity = new System.Windows.Forms.Label();
			this.labLiquidViscosity = new System.Windows.Forms.Label();
			this.txtSaturatedLiquidViscosity = new System.Windows.Forms.TextBox();
			this.labVapourEnthalpy = new System.Windows.Forms.Label();
			this.txtVapourEnthalpy = new System.Windows.Forms.TextBox();
			this.labLiquidEnthalpy = new System.Windows.Forms.Label();
			this.txtLiquidEnthalpy = new System.Windows.Forms.TextBox();
			this.labVapourDensity = new System.Windows.Forms.Label();
			this.txtVapourDensity = new System.Windows.Forms.TextBox();
			this.labLiquidDensity = new System.Windows.Forms.Label();
			this.txtLiquidDensity = new System.Windows.Forms.TextBox();
			this.labState = new System.Windows.Forms.Label();
			this.txtState = new System.Windows.Forms.TextBox();
			this.labPs = new System.Windows.Forms.Label();
			this.labTs = new System.Windows.Forms.Label();
			this.labSensor = new System.Windows.Forms.Label();
			this.comboBoxPosition = new System.Windows.Forms.ComboBox();
			this.cmdExit = new System.Windows.Forms.Button();
			this.grpOriginalData = new System.Windows.Forms.GroupBox();
			this.cmdComfirm = new System.Windows.Forms.Button();
			this.txtT8SubcoolingDegree = new System.Windows.Forms.TextBox();
			this.label31 = new System.Windows.Forms.Label();
			this.txtAmbientTemperature = new System.Windows.Forms.TextBox();
			this.label23 = new System.Windows.Forms.Label();
			this.txtLiquidSuperficialVelocity = new System.Windows.Forms.TextBox();
			this.label16 = new System.Windows.Forms.Label();
			this.txtGasSuperficialVelocity = new System.Windows.Forms.TextBox();
			this.label15 = new System.Windows.Forms.Label();
			this.comboBoxDiameter = new System.Windows.Forms.ComboBox();
			this.label18 = new System.Windows.Forms.Label();
			this.txtPressure = new System.Windows.Forms.TextBox();
			this.labP = new System.Windows.Forms.Label();
			this.label26 = new System.Windows.Forms.Label();
			this.label25 = new System.Windows.Forms.Label();
			this.txtWellTemperature = new System.Windows.Forms.TextBox();
			this.label32 = new System.Windows.Forms.Label();
			this.txtThermallossCoefficient_T3toT = new System.Windows.Forms.TextBox();
			this.txtThermallossCoefficient_T3toT4 = new System.Windows.Forms.TextBox();
			this.txtThermallossCoefficient_T8toT3 = new System.Windows.Forms.TextBox();
			this.label24 = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.txtTTUncertainty = new System.Windows.Forms.TextBox();
			this.txtPressureError = new System.Windows.Forms.TextBox();
			this.txtP0Error = new System.Windows.Forms.TextBox();
			this.txtP4Error = new System.Windows.Forms.TextBox();
			this.txtP3Error = new System.Windows.Forms.TextBox();
			this.label13 = new System.Windows.Forms.Label();
			this.txtPressureUncertainty = new System.Windows.Forms.TextBox();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.txtT0Uncertainty = new System.Windows.Forms.TextBox();
			this.label10 = new System.Windows.Forms.Label();
			this.txtT4Uncertainty = new System.Windows.Forms.TextBox();
			this.txtP0Uncertainty = new System.Windows.Forms.TextBox();
			this.txtP4Uncertainty = new System.Windows.Forms.TextBox();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.txtP3Uncertainty = new System.Windows.Forms.TextBox();
			this.label4 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.txtT3Uncertainty = new System.Windows.Forms.TextBox();
			this.labT = new System.Windows.Forms.Label();
			this.txtTemperature_T8 = new System.Windows.Forms.TextBox();
			this.label19 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.groupBox1 = new System.Windows.Forms.GroupBox();
			this.cmdChange = new System.Windows.Forms.Button();
			this.txtPowerUncertainty = new System.Windows.Forms.TextBox();
			this.txtPowerError = new System.Windows.Forms.TextBox();
			this.label39 = new System.Windows.Forms.Label();
			this.txtFlowrateUncertainty = new System.Windows.Forms.TextBox();
			this.txtFlowrateError = new System.Windows.Forms.TextBox();
			this.label38 = new System.Windows.Forms.Label();
			this.label37 = new System.Windows.Forms.Label();
			this.txtDiameterUncertainty = new System.Windows.Forms.TextBox();
			this.txtDiameterError = new System.Windows.Forms.TextBox();
			this.label36 = new System.Windows.Forms.Label();
			this.label20 = new System.Windows.Forms.Label();
			this.txtTemperature_T3 = new System.Windows.Forms.TextBox();
			this.label21 = new System.Windows.Forms.Label();
			this.txtTemperature_T4 = new System.Windows.Forms.TextBox();
			this.label22 = new System.Windows.Forms.Label();
			this.txtTemperature_T0 = new System.Windows.Forms.TextBox();
			this.groupBox2 = new System.Windows.Forms.GroupBox();
			this.txtThermalloss = new System.Windows.Forms.TextBox();
			this.label30 = new System.Windows.Forms.Label();
			this.txtPower = new System.Windows.Forms.TextBox();
			this.label29 = new System.Windows.Forms.Label();
			this.txtQuality = new System.Windows.Forms.TextBox();
			this.label28 = new System.Windows.Forms.Label();
			this.txtFlowrate = new System.Windows.Forms.TextBox();
			this.label27 = new System.Windows.Forms.Label();
			this.label33 = new System.Windows.Forms.Label();
			this.txtSatTemperature = new System.Windows.Forms.TextBox();
			this.groupBox3 = new System.Windows.Forms.GroupBox();
			this.txtAlarm = new System.Windows.Forms.TextBox();
			this.groupBox4 = new System.Windows.Forms.GroupBox();
			this.label41 = new System.Windows.Forms.Label();
			this.txtUlsUncertainty = new System.Windows.Forms.TextBox();
			this.txtThermallossUncertainty = new System.Windows.Forms.TextBox();
			this.label40 = new System.Windows.Forms.Label();
			this.txtQualityUncertainty = new System.Windows.Forms.TextBox();
			this.label42 = new System.Windows.Forms.Label();
			this.txtUgsUncertainty = new System.Windows.Forms.TextBox();
			this.label47 = new System.Windows.Forms.Label();
			this.txtThermallossCoefficientUncertainty = new System.Windows.Forms.TextBox();
			this.label52 = new System.Windows.Forms.Label();
			this.cmdCalculate = new System.Windows.Forms.Button();
			this.grpOutput.SuspendLayout();
			this.grpOriginalData.SuspendLayout();
			this.groupBox1.SuspendLayout();
			this.groupBox2.SuspendLayout();
			this.groupBox3.SuspendLayout();
			this.groupBox4.SuspendLayout();
			this.SuspendLayout();
			// 
			// grpOutput
			// 
			this.grpOutput.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.label35,
																					this.txtT,
																					this.txtP,
																					this.label34,
																					this.txtLatentHeatUncertainty,
																					this.txtLatentHeatError,
																					this.txtLatentHeat_DP,
																					this.txtLatentHeat_DT,
																					this.labLatentHeat,
																					this.txtLatentHeat,
																					this.txtSaturatedPressureUncertainty,
																					this.txtSaturatedTemperatureUncertainty,
																					this.txtSaturatedVapourViscosityUncertainty,
																					this.label7,
																					this.txtSurfaceTensionUncertainty,
																					this.txtSaturatedLiquidViscosityUncertainty,
																					this.txtVapourEnthalpyUncertainty,
																					this.txtLiquidEnthalpyUncertainty,
																					this.txtVapourDensityUncertainty,
																					this.txtLiquidDensityUncertainty,
																					this.txtSaturatedTemperature,
																					this.txtSaturatedPressure,
																					this.txtSaturatedPressureError,
																					this.txtSaturatedTemperatureError,
																					this.txtSaturatedTemperature_DP,
																					this.txtSaturatedPressure_DT,
																					this.txtSaturatedVapourViscosityError,
																					this.label6,
																					this.txtSurfaceTensionError,
																					this.txtSaturatedLiquidViscosityError,
																					this.txtVapourEnthalpyError,
																					this.txtLiquidEnthalpyError,
																					this.txtVapourDensityError,
																					this.txtLiquidDensityError,
																					this.txtSaturatedVapourViscosity_DP,
																					this.label3,
																					this.txtSurfaceTension_DP,
																					this.txtSaturatedLiquidViscosity_DP,
																					this.txtVapourEnthalpy_DP,
																					this.txtLiquidEnthalpy_DP,
																					this.txtVapourDensity_DP,
																					this.txtLiquidDensity_DP,
																					this.txtSaturatedVapourViscosity_DT,
																					this.label2,
																					this.txtSurfaceTension_DT,
																					this.txtSaturatedLiquidViscosity_DT,
																					this.txtVapourEnthalpy_DT,
																					this.txtLiquidEnthalpy_DT,
																					this.txtVapourDensity_DT,
																					this.txtLiquidDensity_DT,
																					this.txtSaturatedVapourViscosity,
																					this.label1,
																					this.labSurfaceTension,
																					this.txtSurfaceTension,
																					this.labVapourViscosity,
																					this.labLiquidViscosity,
																					this.txtSaturatedLiquidViscosity,
																					this.labVapourEnthalpy,
																					this.txtVapourEnthalpy,
																					this.labLiquidEnthalpy,
																					this.txtLiquidEnthalpy,
																					this.labVapourDensity,
																					this.txtVapourDensity,
																					this.labLiquidDensity,
																					this.txtLiquidDensity,
																					this.labState,
																					this.txtState,
																					this.labPs,
																					this.labTs,
																					this.labSensor,
																					this.comboBoxPosition});
			this.grpOutput.Location = new System.Drawing.Point(352, 160);
			this.grpOutput.Name = "grpOutput";
			this.grpOutput.Size = new System.Drawing.Size(408, 320);
			this.grpOutput.TabIndex = 5;
			this.grpOutput.TabStop = false;
			this.grpOutput.Text = "Parameters";
			// 
			// label35
			// 
			this.label35.Location = new System.Drawing.Point(304, 296);
			this.label35.Name = "label35";
			this.label35.Size = new System.Drawing.Size(40, 16);
			this.label35.TabIndex = 76;
			this.label35.Text = "T (C)";
			// 
			// txtT
			// 
			this.txtT.Location = new System.Drawing.Point(352, 288);
			this.txtT.Name = "txtT";
			this.txtT.Size = new System.Drawing.Size(40, 20);
			this.txtT.TabIndex = 75;
			this.txtT.Text = "";
			// 
			// txtP
			// 
			this.txtP.Location = new System.Drawing.Point(256, 288);
			this.txtP.Name = "txtP";
			this.txtP.Size = new System.Drawing.Size(40, 20);
			this.txtP.TabIndex = 73;
			this.txtP.Text = "";
			// 
			// label34
			// 
			this.label34.Location = new System.Drawing.Point(216, 296);
			this.label34.Name = "label34";
			this.label34.Size = new System.Drawing.Size(40, 16);
			this.label34.TabIndex = 74;
			this.label34.Text = "P (bar)";
			// 
			// txtLatentHeatUncertainty
			// 
			this.txtLatentHeatUncertainty.Location = new System.Drawing.Point(352, 192);
			this.txtLatentHeatUncertainty.Name = "txtLatentHeatUncertainty";
			this.txtLatentHeatUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtLatentHeatUncertainty.TabIndex = 72;
			this.txtLatentHeatUncertainty.Text = "";
			// 
			// txtLatentHeatError
			// 
			this.txtLatentHeatError.Location = new System.Drawing.Point(304, 192);
			this.txtLatentHeatError.Name = "txtLatentHeatError";
			this.txtLatentHeatError.Size = new System.Drawing.Size(40, 20);
			this.txtLatentHeatError.TabIndex = 71;
			this.txtLatentHeatError.Text = "";
			// 
			// txtLatentHeat_DP
			// 
			this.txtLatentHeat_DP.Location = new System.Drawing.Point(208, 192);
			this.txtLatentHeat_DP.Name = "txtLatentHeat_DP";
			this.txtLatentHeat_DP.Size = new System.Drawing.Size(40, 20);
			this.txtLatentHeat_DP.TabIndex = 70;
			this.txtLatentHeat_DP.Text = "";
			// 
			// txtLatentHeat_DT
			// 
			this.txtLatentHeat_DT.Location = new System.Drawing.Point(256, 192);
			this.txtLatentHeat_DT.Name = "txtLatentHeat_DT";
			this.txtLatentHeat_DT.Size = new System.Drawing.Size(40, 20);
			this.txtLatentHeat_DT.TabIndex = 69;
			this.txtLatentHeat_DT.Text = "";
			// 
			// labLatentHeat
			// 
			this.labLatentHeat.Location = new System.Drawing.Point(16, 192);
			this.labLatentHeat.Name = "labLatentHeat";
			this.labLatentHeat.Size = new System.Drawing.Size(128, 16);
			this.labLatentHeat.TabIndex = 68;
			this.labLatentHeat.Text = "Latent Heat (kJ/kg)";
			// 
			// txtLatentHeat
			// 
			this.txtLatentHeat.Location = new System.Drawing.Point(152, 192);
			this.txtLatentHeat.Name = "txtLatentHeat";
			this.txtLatentHeat.Size = new System.Drawing.Size(50, 20);
			this.txtLatentHeat.TabIndex = 67;
			this.txtLatentHeat.Text = "";
			// 
			// txtSaturatedPressureUncertainty
			// 
			this.txtSaturatedPressureUncertainty.Location = new System.Drawing.Point(352, 48);
			this.txtSaturatedPressureUncertainty.Name = "txtSaturatedPressureUncertainty";
			this.txtSaturatedPressureUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedPressureUncertainty.TabIndex = 66;
			this.txtSaturatedPressureUncertainty.Text = "";
			// 
			// txtSaturatedTemperatureUncertainty
			// 
			this.txtSaturatedTemperatureUncertainty.Location = new System.Drawing.Point(352, 72);
			this.txtSaturatedTemperatureUncertainty.Name = "txtSaturatedTemperatureUncertainty";
			this.txtSaturatedTemperatureUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedTemperatureUncertainty.TabIndex = 65;
			this.txtSaturatedTemperatureUncertainty.Text = "";
			// 
			// txtSaturatedVapourViscosityUncertainty
			// 
			this.txtSaturatedVapourViscosityUncertainty.Location = new System.Drawing.Point(352, 240);
			this.txtSaturatedVapourViscosityUncertainty.Name = "txtSaturatedVapourViscosityUncertainty";
			this.txtSaturatedVapourViscosityUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedVapourViscosityUncertainty.TabIndex = 62;
			this.txtSaturatedVapourViscosityUncertainty.Text = "";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(352, 16);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(40, 24);
			this.label7.TabIndex = 64;
			this.label7.Text = "U(%)";
			this.label7.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtSurfaceTensionUncertainty
			// 
			this.txtSurfaceTensionUncertainty.Location = new System.Drawing.Point(352, 264);
			this.txtSurfaceTensionUncertainty.Name = "txtSurfaceTensionUncertainty";
			this.txtSurfaceTensionUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtSurfaceTensionUncertainty.TabIndex = 63;
			this.txtSurfaceTensionUncertainty.Text = "";
			// 
			// txtSaturatedLiquidViscosityUncertainty
			// 
			this.txtSaturatedLiquidViscosityUncertainty.Location = new System.Drawing.Point(352, 216);
			this.txtSaturatedLiquidViscosityUncertainty.Name = "txtSaturatedLiquidViscosityUncertainty";
			this.txtSaturatedLiquidViscosityUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedLiquidViscosityUncertainty.TabIndex = 61;
			this.txtSaturatedLiquidViscosityUncertainty.Text = "";
			// 
			// txtVapourEnthalpyUncertainty
			// 
			this.txtVapourEnthalpyUncertainty.Location = new System.Drawing.Point(352, 168);
			this.txtVapourEnthalpyUncertainty.Name = "txtVapourEnthalpyUncertainty";
			this.txtVapourEnthalpyUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtVapourEnthalpyUncertainty.TabIndex = 60;
			this.txtVapourEnthalpyUncertainty.Text = "";
			// 
			// txtLiquidEnthalpyUncertainty
			// 
			this.txtLiquidEnthalpyUncertainty.Location = new System.Drawing.Point(352, 144);
			this.txtLiquidEnthalpyUncertainty.Name = "txtLiquidEnthalpyUncertainty";
			this.txtLiquidEnthalpyUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidEnthalpyUncertainty.TabIndex = 59;
			this.txtLiquidEnthalpyUncertainty.Text = "";
			// 
			// txtVapourDensityUncertainty
			// 
			this.txtVapourDensityUncertainty.Location = new System.Drawing.Point(352, 120);
			this.txtVapourDensityUncertainty.Name = "txtVapourDensityUncertainty";
			this.txtVapourDensityUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtVapourDensityUncertainty.TabIndex = 58;
			this.txtVapourDensityUncertainty.Text = "";
			// 
			// txtLiquidDensityUncertainty
			// 
			this.txtLiquidDensityUncertainty.Location = new System.Drawing.Point(352, 96);
			this.txtLiquidDensityUncertainty.Name = "txtLiquidDensityUncertainty";
			this.txtLiquidDensityUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidDensityUncertainty.TabIndex = 57;
			this.txtLiquidDensityUncertainty.Text = "";
			// 
			// txtSaturatedTemperature
			// 
			this.txtSaturatedTemperature.Location = new System.Drawing.Point(152, 72);
			this.txtSaturatedTemperature.Name = "txtSaturatedTemperature";
			this.txtSaturatedTemperature.Size = new System.Drawing.Size(50, 20);
			this.txtSaturatedTemperature.TabIndex = 5;
			this.txtSaturatedTemperature.Text = "";
			// 
			// txtSaturatedPressure
			// 
			this.txtSaturatedPressure.Location = new System.Drawing.Point(152, 48);
			this.txtSaturatedPressure.Name = "txtSaturatedPressure";
			this.txtSaturatedPressure.Size = new System.Drawing.Size(50, 20);
			this.txtSaturatedPressure.TabIndex = 7;
			this.txtSaturatedPressure.Text = "";
			// 
			// txtSaturatedPressureError
			// 
			this.txtSaturatedPressureError.Location = new System.Drawing.Point(304, 48);
			this.txtSaturatedPressureError.Name = "txtSaturatedPressureError";
			this.txtSaturatedPressureError.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedPressureError.TabIndex = 55;
			this.txtSaturatedPressureError.Text = "";
			// 
			// txtSaturatedTemperatureError
			// 
			this.txtSaturatedTemperatureError.Location = new System.Drawing.Point(304, 72);
			this.txtSaturatedTemperatureError.Name = "txtSaturatedTemperatureError";
			this.txtSaturatedTemperatureError.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedTemperatureError.TabIndex = 54;
			this.txtSaturatedTemperatureError.Text = "";
			// 
			// txtSaturatedTemperature_DP
			// 
			this.txtSaturatedTemperature_DP.Location = new System.Drawing.Point(208, 72);
			this.txtSaturatedTemperature_DP.Name = "txtSaturatedTemperature_DP";
			this.txtSaturatedTemperature_DP.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedTemperature_DP.TabIndex = 52;
			this.txtSaturatedTemperature_DP.Text = "";
			// 
			// txtSaturatedPressure_DT
			// 
			this.txtSaturatedPressure_DT.Location = new System.Drawing.Point(256, 48);
			this.txtSaturatedPressure_DT.Name = "txtSaturatedPressure_DT";
			this.txtSaturatedPressure_DT.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedPressure_DT.TabIndex = 51;
			this.txtSaturatedPressure_DT.Text = "";
			// 
			// txtSaturatedVapourViscosityError
			// 
			this.txtSaturatedVapourViscosityError.Location = new System.Drawing.Point(304, 240);
			this.txtSaturatedVapourViscosityError.Name = "txtSaturatedVapourViscosityError";
			this.txtSaturatedVapourViscosityError.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedVapourViscosityError.TabIndex = 47;
			this.txtSaturatedVapourViscosityError.Text = "";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(304, 16);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(40, 24);
			this.label6.TabIndex = 49;
			this.label6.Text = "dY";
			this.label6.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtSurfaceTensionError
			// 
			this.txtSurfaceTensionError.Location = new System.Drawing.Point(304, 264);
			this.txtSurfaceTensionError.Name = "txtSurfaceTensionError";
			this.txtSurfaceTensionError.Size = new System.Drawing.Size(40, 20);
			this.txtSurfaceTensionError.TabIndex = 48;
			this.txtSurfaceTensionError.Text = "";
			// 
			// txtSaturatedLiquidViscosityError
			// 
			this.txtSaturatedLiquidViscosityError.Location = new System.Drawing.Point(304, 216);
			this.txtSaturatedLiquidViscosityError.Name = "txtSaturatedLiquidViscosityError";
			this.txtSaturatedLiquidViscosityError.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedLiquidViscosityError.TabIndex = 46;
			this.txtSaturatedLiquidViscosityError.Text = "";
			// 
			// txtVapourEnthalpyError
			// 
			this.txtVapourEnthalpyError.Location = new System.Drawing.Point(304, 168);
			this.txtVapourEnthalpyError.Name = "txtVapourEnthalpyError";
			this.txtVapourEnthalpyError.Size = new System.Drawing.Size(40, 20);
			this.txtVapourEnthalpyError.TabIndex = 45;
			this.txtVapourEnthalpyError.Text = "";
			// 
			// txtLiquidEnthalpyError
			// 
			this.txtLiquidEnthalpyError.Location = new System.Drawing.Point(304, 144);
			this.txtLiquidEnthalpyError.Name = "txtLiquidEnthalpyError";
			this.txtLiquidEnthalpyError.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidEnthalpyError.TabIndex = 44;
			this.txtLiquidEnthalpyError.Text = "";
			// 
			// txtVapourDensityError
			// 
			this.txtVapourDensityError.Location = new System.Drawing.Point(304, 120);
			this.txtVapourDensityError.Name = "txtVapourDensityError";
			this.txtVapourDensityError.Size = new System.Drawing.Size(40, 20);
			this.txtVapourDensityError.TabIndex = 43;
			this.txtVapourDensityError.Text = "";
			// 
			// txtLiquidDensityError
			// 
			this.txtLiquidDensityError.Location = new System.Drawing.Point(304, 96);
			this.txtLiquidDensityError.Name = "txtLiquidDensityError";
			this.txtLiquidDensityError.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidDensityError.TabIndex = 42;
			this.txtLiquidDensityError.Text = "";
			// 
			// txtSaturatedVapourViscosity_DP
			// 
			this.txtSaturatedVapourViscosity_DP.Location = new System.Drawing.Point(208, 240);
			this.txtSaturatedVapourViscosity_DP.Name = "txtSaturatedVapourViscosity_DP";
			this.txtSaturatedVapourViscosity_DP.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedVapourViscosity_DP.TabIndex = 39;
			this.txtSaturatedVapourViscosity_DP.Text = "";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(208, 16);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 24);
			this.label3.TabIndex = 41;
			this.label3.Text = "dY/dP(/bar)";
			this.label3.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtSurfaceTension_DP
			// 
			this.txtSurfaceTension_DP.Location = new System.Drawing.Point(208, 264);
			this.txtSurfaceTension_DP.Name = "txtSurfaceTension_DP";
			this.txtSurfaceTension_DP.Size = new System.Drawing.Size(40, 20);
			this.txtSurfaceTension_DP.TabIndex = 40;
			this.txtSurfaceTension_DP.Text = "";
			// 
			// txtSaturatedLiquidViscosity_DP
			// 
			this.txtSaturatedLiquidViscosity_DP.Location = new System.Drawing.Point(208, 216);
			this.txtSaturatedLiquidViscosity_DP.Name = "txtSaturatedLiquidViscosity_DP";
			this.txtSaturatedLiquidViscosity_DP.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedLiquidViscosity_DP.TabIndex = 38;
			this.txtSaturatedLiquidViscosity_DP.Text = "";
			// 
			// txtVapourEnthalpy_DP
			// 
			this.txtVapourEnthalpy_DP.Location = new System.Drawing.Point(208, 168);
			this.txtVapourEnthalpy_DP.Name = "txtVapourEnthalpy_DP";
			this.txtVapourEnthalpy_DP.Size = new System.Drawing.Size(40, 20);
			this.txtVapourEnthalpy_DP.TabIndex = 37;
			this.txtVapourEnthalpy_DP.Text = "";
			// 
			// txtLiquidEnthalpy_DP
			// 
			this.txtLiquidEnthalpy_DP.Location = new System.Drawing.Point(208, 144);
			this.txtLiquidEnthalpy_DP.Name = "txtLiquidEnthalpy_DP";
			this.txtLiquidEnthalpy_DP.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidEnthalpy_DP.TabIndex = 36;
			this.txtLiquidEnthalpy_DP.Text = "";
			// 
			// txtVapourDensity_DP
			// 
			this.txtVapourDensity_DP.Location = new System.Drawing.Point(208, 120);
			this.txtVapourDensity_DP.Name = "txtVapourDensity_DP";
			this.txtVapourDensity_DP.Size = new System.Drawing.Size(40, 20);
			this.txtVapourDensity_DP.TabIndex = 35;
			this.txtVapourDensity_DP.Text = "";
			// 
			// txtLiquidDensity_DP
			// 
			this.txtLiquidDensity_DP.Location = new System.Drawing.Point(208, 96);
			this.txtLiquidDensity_DP.Name = "txtLiquidDensity_DP";
			this.txtLiquidDensity_DP.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidDensity_DP.TabIndex = 34;
			this.txtLiquidDensity_DP.Text = "";
			// 
			// txtSaturatedVapourViscosity_DT
			// 
			this.txtSaturatedVapourViscosity_DT.Location = new System.Drawing.Point(256, 240);
			this.txtSaturatedVapourViscosity_DT.Name = "txtSaturatedVapourViscosity_DT";
			this.txtSaturatedVapourViscosity_DT.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedVapourViscosity_DT.TabIndex = 31;
			this.txtSaturatedVapourViscosity_DT.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(256, 16);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(40, 24);
			this.label2.TabIndex = 33;
			this.label2.Text = "dY/dT(/K)";
			this.label2.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// txtSurfaceTension_DT
			// 
			this.txtSurfaceTension_DT.Location = new System.Drawing.Point(256, 264);
			this.txtSurfaceTension_DT.Name = "txtSurfaceTension_DT";
			this.txtSurfaceTension_DT.Size = new System.Drawing.Size(40, 20);
			this.txtSurfaceTension_DT.TabIndex = 32;
			this.txtSurfaceTension_DT.Text = "";
			// 
			// txtSaturatedLiquidViscosity_DT
			// 
			this.txtSaturatedLiquidViscosity_DT.Location = new System.Drawing.Point(256, 216);
			this.txtSaturatedLiquidViscosity_DT.Name = "txtSaturatedLiquidViscosity_DT";
			this.txtSaturatedLiquidViscosity_DT.Size = new System.Drawing.Size(40, 20);
			this.txtSaturatedLiquidViscosity_DT.TabIndex = 30;
			this.txtSaturatedLiquidViscosity_DT.Text = "";
			// 
			// txtVapourEnthalpy_DT
			// 
			this.txtVapourEnthalpy_DT.Location = new System.Drawing.Point(256, 168);
			this.txtVapourEnthalpy_DT.Name = "txtVapourEnthalpy_DT";
			this.txtVapourEnthalpy_DT.Size = new System.Drawing.Size(40, 20);
			this.txtVapourEnthalpy_DT.TabIndex = 29;
			this.txtVapourEnthalpy_DT.Text = "";
			// 
			// txtLiquidEnthalpy_DT
			// 
			this.txtLiquidEnthalpy_DT.Location = new System.Drawing.Point(256, 144);
			this.txtLiquidEnthalpy_DT.Name = "txtLiquidEnthalpy_DT";
			this.txtLiquidEnthalpy_DT.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidEnthalpy_DT.TabIndex = 28;
			this.txtLiquidEnthalpy_DT.Text = "";
			// 
			// txtVapourDensity_DT
			// 
			this.txtVapourDensity_DT.Location = new System.Drawing.Point(256, 120);
			this.txtVapourDensity_DT.Name = "txtVapourDensity_DT";
			this.txtVapourDensity_DT.Size = new System.Drawing.Size(40, 20);
			this.txtVapourDensity_DT.TabIndex = 27;
			this.txtVapourDensity_DT.Text = "";
			// 
			// txtLiquidDensity_DT
			// 
			this.txtLiquidDensity_DT.Location = new System.Drawing.Point(256, 96);
			this.txtLiquidDensity_DT.Name = "txtLiquidDensity_DT";
			this.txtLiquidDensity_DT.Size = new System.Drawing.Size(40, 20);
			this.txtLiquidDensity_DT.TabIndex = 26;
			this.txtLiquidDensity_DT.Text = "";
			// 
			// txtSaturatedVapourViscosity
			// 
			this.txtSaturatedVapourViscosity.Location = new System.Drawing.Point(152, 240);
			this.txtSaturatedVapourViscosity.Name = "txtSaturatedVapourViscosity";
			this.txtSaturatedVapourViscosity.Size = new System.Drawing.Size(50, 20);
			this.txtSaturatedVapourViscosity.TabIndex = 21;
			this.txtSaturatedVapourViscosity.Text = "";
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(168, 24);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(16, 16);
			this.label1.TabIndex = 25;
			this.label1.Text = "Y";
			// 
			// labSurfaceTension
			// 
			this.labSurfaceTension.Location = new System.Drawing.Point(16, 272);
			this.labSurfaceTension.Name = "labSurfaceTension";
			this.labSurfaceTension.Size = new System.Drawing.Size(136, 16);
			this.labSurfaceTension.TabIndex = 24;
			this.labSurfaceTension.Text = "Surface Tension (mPa.s)";
			// 
			// txtSurfaceTension
			// 
			this.txtSurfaceTension.Location = new System.Drawing.Point(152, 264);
			this.txtSurfaceTension.Name = "txtSurfaceTension";
			this.txtSurfaceTension.Size = new System.Drawing.Size(50, 20);
			this.txtSurfaceTension.TabIndex = 23;
			this.txtSurfaceTension.Text = "";
			// 
			// labVapourViscosity
			// 
			this.labVapourViscosity.Location = new System.Drawing.Point(16, 240);
			this.labVapourViscosity.Name = "labVapourViscosity";
			this.labVapourViscosity.Size = new System.Drawing.Size(120, 32);
			this.labVapourViscosity.TabIndex = 22;
			this.labVapourViscosity.Text = "Sat. Vapour Viscosity (micro-Pa.s)";
			// 
			// labLiquidViscosity
			// 
			this.labLiquidViscosity.Location = new System.Drawing.Point(16, 208);
			this.labLiquidViscosity.Name = "labLiquidViscosity";
			this.labLiquidViscosity.Size = new System.Drawing.Size(112, 32);
			this.labLiquidViscosity.TabIndex = 20;
			this.labLiquidViscosity.Text = "Sat. Liquid Viscosity (micro-Pa.s)";
			// 
			// txtSaturatedLiquidViscosity
			// 
			this.txtSaturatedLiquidViscosity.Location = new System.Drawing.Point(152, 216);
			this.txtSaturatedLiquidViscosity.Name = "txtSaturatedLiquidViscosity";
			this.txtSaturatedLiquidViscosity.Size = new System.Drawing.Size(50, 20);
			this.txtSaturatedLiquidViscosity.TabIndex = 19;
			this.txtSaturatedLiquidViscosity.Text = "";
			// 
			// labVapourEnthalpy
			// 
			this.labVapourEnthalpy.Location = new System.Drawing.Point(16, 168);
			this.labVapourEnthalpy.Name = "labVapourEnthalpy";
			this.labVapourEnthalpy.Size = new System.Drawing.Size(128, 16);
			this.labVapourEnthalpy.TabIndex = 18;
			this.labVapourEnthalpy.Text = "Vapour Enthalpy (kJ/kg)";
			// 
			// txtVapourEnthalpy
			// 
			this.txtVapourEnthalpy.Location = new System.Drawing.Point(152, 168);
			this.txtVapourEnthalpy.Name = "txtVapourEnthalpy";
			this.txtVapourEnthalpy.Size = new System.Drawing.Size(50, 20);
			this.txtVapourEnthalpy.TabIndex = 17;
			this.txtVapourEnthalpy.Text = "";
			// 
			// labLiquidEnthalpy
			// 
			this.labLiquidEnthalpy.Location = new System.Drawing.Point(16, 144);
			this.labLiquidEnthalpy.Name = "labLiquidEnthalpy";
			this.labLiquidEnthalpy.Size = new System.Drawing.Size(120, 16);
			this.labLiquidEnthalpy.TabIndex = 16;
			this.labLiquidEnthalpy.Text = "Liquid Enthalpy (kJ/kg)";
			// 
			// txtLiquidEnthalpy
			// 
			this.txtLiquidEnthalpy.Location = new System.Drawing.Point(152, 144);
			this.txtLiquidEnthalpy.Name = "txtLiquidEnthalpy";
			this.txtLiquidEnthalpy.Size = new System.Drawing.Size(50, 20);
			this.txtLiquidEnthalpy.TabIndex = 15;
			this.txtLiquidEnthalpy.Text = "";
			// 
			// labVapourDensity
			// 
			this.labVapourDensity.Location = new System.Drawing.Point(16, 120);
			this.labVapourDensity.Name = "labVapourDensity";
			this.labVapourDensity.Size = new System.Drawing.Size(128, 16);
			this.labVapourDensity.TabIndex = 14;
			this.labVapourDensity.Text = "Vapour Density (kg/m3)";
			// 
			// txtVapourDensity
			// 
			this.txtVapourDensity.Location = new System.Drawing.Point(152, 120);
			this.txtVapourDensity.Name = "txtVapourDensity";
			this.txtVapourDensity.Size = new System.Drawing.Size(50, 20);
			this.txtVapourDensity.TabIndex = 13;
			this.txtVapourDensity.Text = "";
			// 
			// labLiquidDensity
			// 
			this.labLiquidDensity.Location = new System.Drawing.Point(16, 96);
			this.labLiquidDensity.Name = "labLiquidDensity";
			this.labLiquidDensity.Size = new System.Drawing.Size(120, 16);
			this.labLiquidDensity.TabIndex = 12;
			this.labLiquidDensity.Text = "Liquid Density (kg/m3)";
			// 
			// txtLiquidDensity
			// 
			this.txtLiquidDensity.Location = new System.Drawing.Point(152, 96);
			this.txtLiquidDensity.Name = "txtLiquidDensity";
			this.txtLiquidDensity.Size = new System.Drawing.Size(50, 20);
			this.txtLiquidDensity.TabIndex = 11;
			this.txtLiquidDensity.Text = "";
			// 
			// labState
			// 
			this.labState.Location = new System.Drawing.Point(16, 296);
			this.labState.Name = "labState";
			this.labState.Size = new System.Drawing.Size(64, 16);
			this.labState.TabIndex = 10;
			this.labState.Text = "Condition";
			// 
			// txtState
			// 
			this.txtState.Location = new System.Drawing.Point(152, 288);
			this.txtState.Name = "txtState";
			this.txtState.Size = new System.Drawing.Size(56, 20);
			this.txtState.TabIndex = 9;
			this.txtState.Text = "";
			// 
			// labPs
			// 
			this.labPs.Location = new System.Drawing.Point(16, 48);
			this.labPs.Name = "labPs";
			this.labPs.Size = new System.Drawing.Size(136, 16);
			this.labPs.TabIndex = 8;
			this.labPs.Text = "Saturated Pressure (bar)";
			// 
			// labTs
			// 
			this.labTs.Location = new System.Drawing.Point(16, 72);
			this.labTs.Name = "labTs";
			this.labTs.Size = new System.Drawing.Size(144, 16);
			this.labTs.TabIndex = 6;
			this.labTs.Text = "Saturated Temperature (C)";
			// 
			// labSensor
			// 
			this.labSensor.Location = new System.Drawing.Point(16, 24);
			this.labSensor.Name = "labSensor";
			this.labSensor.Size = new System.Drawing.Size(48, 16);
			this.labSensor.TabIndex = 18;
			this.labSensor.Text = "Position";
			// 
			// comboBoxPosition
			// 
			this.comboBoxPosition.Enabled = false;
			this.comboBoxPosition.Items.AddRange(new object[] {
																  "Point 3",
																  "Point 4",
																  "Point 0"});
			this.comboBoxPosition.Location = new System.Drawing.Point(64, 24);
			this.comboBoxPosition.Name = "comboBoxPosition";
			this.comboBoxPosition.Size = new System.Drawing.Size(88, 21);
			this.comboBoxPosition.TabIndex = 19;
			this.comboBoxPosition.SelectedIndexChanged += new System.EventHandler(this.comboBoxPosition_SelectedIndexChanged);
			// 
			// cmdExit
			// 
			this.cmdExit.Location = new System.Drawing.Point(696, 496);
			this.cmdExit.Name = "cmdExit";
			this.cmdExit.Size = new System.Drawing.Size(64, 24);
			this.cmdExit.TabIndex = 6;
			this.cmdExit.Text = "Exit";
			this.cmdExit.Click += new System.EventHandler(this.cmdExit_Click);
			// 
			// grpOriginalData
			// 
			this.grpOriginalData.Controls.AddRange(new System.Windows.Forms.Control[] {
																						  this.cmdComfirm,
																						  this.txtT8SubcoolingDegree,
																						  this.label31,
																						  this.txtAmbientTemperature,
																						  this.label23,
																						  this.txtLiquidSuperficialVelocity,
																						  this.label16,
																						  this.txtGasSuperficialVelocity,
																						  this.label15,
																						  this.comboBoxDiameter,
																						  this.label18,
																						  this.txtPressure,
																						  this.labP});
			this.grpOriginalData.Location = new System.Drawing.Point(16, 8);
			this.grpOriginalData.Name = "grpOriginalData";
			this.grpOriginalData.Size = new System.Drawing.Size(320, 128);
			this.grpOriginalData.TabIndex = 7;
			this.grpOriginalData.TabStop = false;
			this.grpOriginalData.Text = "Original Data";
			// 
			// cmdComfirm
			// 
			this.cmdComfirm.Location = new System.Drawing.Point(248, 96);
			this.cmdComfirm.Name = "cmdComfirm";
			this.cmdComfirm.Size = new System.Drawing.Size(56, 24);
			this.cmdComfirm.TabIndex = 67;
			this.cmdComfirm.Text = "Comfirm";
			this.cmdComfirm.Click += new System.EventHandler(this.cmdComfirm_Click);
			// 
			// txtT8SubcoolingDegree
			// 
			this.txtT8SubcoolingDegree.Location = new System.Drawing.Point(256, 48);
			this.txtT8SubcoolingDegree.Name = "txtT8SubcoolingDegree";
			this.txtT8SubcoolingDegree.Size = new System.Drawing.Size(48, 20);
			this.txtT8SubcoolingDegree.TabIndex = 61;
			this.txtT8SubcoolingDegree.Text = "";
			// 
			// label31
			// 
			this.label31.Location = new System.Drawing.Point(160, 48);
			this.label31.Name = "label31";
			this.label31.Size = new System.Drawing.Size(104, 16);
			this.label31.TabIndex = 62;
			this.label31.Text = "T8_subcooling (C)";
			// 
			// txtAmbientTemperature
			// 
			this.txtAmbientTemperature.Location = new System.Drawing.Point(256, 24);
			this.txtAmbientTemperature.Name = "txtAmbientTemperature";
			this.txtAmbientTemperature.Size = new System.Drawing.Size(48, 20);
			this.txtAmbientTemperature.TabIndex = 53;
			this.txtAmbientTemperature.Text = "";
			// 
			// label23
			// 
			this.label23.Location = new System.Drawing.Point(160, 24);
			this.label23.Name = "label23";
			this.label23.Size = new System.Drawing.Size(88, 16);
			this.label23.TabIndex = 54;
			this.label23.Text = "T_ambient (C)";
			// 
			// txtLiquidSuperficialVelocity
			// 
			this.txtLiquidSuperficialVelocity.Location = new System.Drawing.Point(96, 96);
			this.txtLiquidSuperficialVelocity.Name = "txtLiquidSuperficialVelocity";
			this.txtLiquidSuperficialVelocity.Size = new System.Drawing.Size(56, 20);
			this.txtLiquidSuperficialVelocity.TabIndex = 45;
			this.txtLiquidSuperficialVelocity.Text = "";
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(16, 96);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(56, 16);
			this.label16.TabIndex = 46;
			this.label16.Text = "Uls (m/s)";
			// 
			// txtGasSuperficialVelocity
			// 
			this.txtGasSuperficialVelocity.Location = new System.Drawing.Point(96, 72);
			this.txtGasSuperficialVelocity.Name = "txtGasSuperficialVelocity";
			this.txtGasSuperficialVelocity.Size = new System.Drawing.Size(56, 20);
			this.txtGasSuperficialVelocity.TabIndex = 43;
			this.txtGasSuperficialVelocity.Text = "";
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(16, 72);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(56, 16);
			this.label15.TabIndex = 44;
			this.label15.Text = "Ugs(m/s)";
			// 
			// comboBoxDiameter
			// 
			this.comboBoxDiameter.Items.AddRange(new object[] {
																  "1.10",
																  "2.01",
																  "2.88",
																  "4.26"});
			this.comboBoxDiameter.Location = new System.Drawing.Point(96, 24);
			this.comboBoxDiameter.Name = "comboBoxDiameter";
			this.comboBoxDiameter.Size = new System.Drawing.Size(56, 21);
			this.comboBoxDiameter.TabIndex = 42;
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(16, 24);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(80, 16);
			this.label18.TabIndex = 41;
			this.label18.Text = "Diameter (mm)";
			// 
			// txtPressure
			// 
			this.txtPressure.Location = new System.Drawing.Point(96, 48);
			this.txtPressure.Name = "txtPressure";
			this.txtPressure.Size = new System.Drawing.Size(56, 20);
			this.txtPressure.TabIndex = 6;
			this.txtPressure.Text = "";
			// 
			// labP
			// 
			this.labP.Location = new System.Drawing.Point(16, 48);
			this.labP.Name = "labP";
			this.labP.Size = new System.Drawing.Size(56, 16);
			this.labP.TabIndex = 7;
			this.labP.Text = "P (bar-a)";
			// 
			// label26
			// 
			this.label26.Location = new System.Drawing.Point(16, 112);
			this.label26.Name = "label26";
			this.label26.Size = new System.Drawing.Size(48, 24);
			this.label26.TabIndex = 66;
			this.label26.Text = "K_T3toT (W/K)";
			// 
			// label25
			// 
			this.label25.Location = new System.Drawing.Point(16, 88);
			this.label25.Name = "label25";
			this.label25.Size = new System.Drawing.Size(56, 24);
			this.label25.TabIndex = 65;
			this.label25.Text = "K_T3toT4 (W/K)";
			// 
			// txtWellTemperature
			// 
			this.txtWellTemperature.Location = new System.Drawing.Point(72, 48);
			this.txtWellTemperature.Name = "txtWellTemperature";
			this.txtWellTemperature.Size = new System.Drawing.Size(40, 20);
			this.txtWellTemperature.TabIndex = 63;
			this.txtWellTemperature.Text = "";
			// 
			// label32
			// 
			this.label32.Location = new System.Drawing.Point(16, 48);
			this.label32.Name = "label32";
			this.label32.Size = new System.Drawing.Size(56, 16);
			this.label32.TabIndex = 64;
			this.label32.Text = "T_well (C)";
			// 
			// txtThermallossCoefficient_T3toT
			// 
			this.txtThermallossCoefficient_T3toT.Location = new System.Drawing.Point(72, 120);
			this.txtThermallossCoefficient_T3toT.Name = "txtThermallossCoefficient_T3toT";
			this.txtThermallossCoefficient_T3toT.Size = new System.Drawing.Size(40, 20);
			this.txtThermallossCoefficient_T3toT.TabIndex = 59;
			this.txtThermallossCoefficient_T3toT.Text = "";
			// 
			// txtThermallossCoefficient_T3toT4
			// 
			this.txtThermallossCoefficient_T3toT4.Location = new System.Drawing.Point(72, 96);
			this.txtThermallossCoefficient_T3toT4.Name = "txtThermallossCoefficient_T3toT4";
			this.txtThermallossCoefficient_T3toT4.Size = new System.Drawing.Size(40, 20);
			this.txtThermallossCoefficient_T3toT4.TabIndex = 57;
			this.txtThermallossCoefficient_T3toT4.Text = "";
			// 
			// txtThermallossCoefficient_T8toT3
			// 
			this.txtThermallossCoefficient_T8toT3.Location = new System.Drawing.Point(72, 72);
			this.txtThermallossCoefficient_T8toT3.Name = "txtThermallossCoefficient_T8toT3";
			this.txtThermallossCoefficient_T8toT3.Size = new System.Drawing.Size(40, 20);
			this.txtThermallossCoefficient_T8toT3.TabIndex = 55;
			this.txtThermallossCoefficient_T8toT3.Text = "";
			// 
			// label24
			// 
			this.label24.Location = new System.Drawing.Point(16, 64);
			this.label24.Name = "label24";
			this.label24.Size = new System.Drawing.Size(56, 24);
			this.label24.TabIndex = 56;
			this.label24.Text = "K_T8toT3 (W/K)";
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(152, 112);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(32, 16);
			this.label17.TabIndex = 40;
			this.label17.Text = "U_TT";
			// 
			// txtTTUncertainty
			// 
			this.txtTTUncertainty.Location = new System.Drawing.Point(192, 112);
			this.txtTTUncertainty.Name = "txtTTUncertainty";
			this.txtTTUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtTTUncertainty.TabIndex = 39;
			this.txtTTUncertainty.Text = "";
			// 
			// txtPressureError
			// 
			this.txtPressureError.Location = new System.Drawing.Point(104, 112);
			this.txtPressureError.Name = "txtPressureError";
			this.txtPressureError.Size = new System.Drawing.Size(40, 20);
			this.txtPressureError.TabIndex = 37;
			this.txtPressureError.Text = "";
			// 
			// txtP0Error
			// 
			this.txtP0Error.Location = new System.Drawing.Point(104, 88);
			this.txtP0Error.Name = "txtP0Error";
			this.txtP0Error.Size = new System.Drawing.Size(40, 20);
			this.txtP0Error.TabIndex = 35;
			this.txtP0Error.Text = "";
			// 
			// txtP4Error
			// 
			this.txtP4Error.Location = new System.Drawing.Point(104, 64);
			this.txtP4Error.Name = "txtP4Error";
			this.txtP4Error.Size = new System.Drawing.Size(40, 20);
			this.txtP4Error.TabIndex = 33;
			this.txtP4Error.Text = "";
			// 
			// txtP3Error
			// 
			this.txtP3Error.Location = new System.Drawing.Point(104, 40);
			this.txtP3Error.Name = "txtP3Error";
			this.txtP3Error.Size = new System.Drawing.Size(40, 20);
			this.txtP3Error.TabIndex = 31;
			this.txtP3Error.Text = "";
			// 
			// label13
			// 
			this.label13.Location = new System.Drawing.Point(112, 16);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(32, 16);
			this.label13.TabIndex = 32;
			this.label13.Text = "(bar)";
			// 
			// txtPressureUncertainty
			// 
			this.txtPressureUncertainty.Location = new System.Drawing.Point(56, 112);
			this.txtPressureUncertainty.Name = "txtPressureUncertainty";
			this.txtPressureUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtPressureUncertainty.TabIndex = 29;
			this.txtPressureUncertainty.Text = "";
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(16, 112);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(32, 16);
			this.label12.TabIndex = 30;
			this.label12.Text = "U_P";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(152, 88);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(32, 16);
			this.label11.TabIndex = 28;
			this.label11.Text = "U_T0";
			// 
			// txtT0Uncertainty
			// 
			this.txtT0Uncertainty.Location = new System.Drawing.Point(192, 88);
			this.txtT0Uncertainty.Name = "txtT0Uncertainty";
			this.txtT0Uncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtT0Uncertainty.TabIndex = 27;
			this.txtT0Uncertainty.Text = "";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(152, 64);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(32, 16);
			this.label10.TabIndex = 26;
			this.label10.Text = "U_T4";
			// 
			// txtT4Uncertainty
			// 
			this.txtT4Uncertainty.Location = new System.Drawing.Point(192, 64);
			this.txtT4Uncertainty.Name = "txtT4Uncertainty";
			this.txtT4Uncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtT4Uncertainty.TabIndex = 25;
			this.txtT4Uncertainty.Text = "";
			// 
			// txtP0Uncertainty
			// 
			this.txtP0Uncertainty.Location = new System.Drawing.Point(56, 88);
			this.txtP0Uncertainty.Name = "txtP0Uncertainty";
			this.txtP0Uncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtP0Uncertainty.TabIndex = 22;
			this.txtP0Uncertainty.Text = "";
			// 
			// txtP4Uncertainty
			// 
			this.txtP4Uncertainty.Location = new System.Drawing.Point(56, 64);
			this.txtP4Uncertainty.Name = "txtP4Uncertainty";
			this.txtP4Uncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtP4Uncertainty.TabIndex = 20;
			this.txtP4Uncertainty.Text = "";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(16, 88);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(32, 16);
			this.label9.TabIndex = 24;
			this.label9.Text = "U_P0";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(16, 64);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(32, 16);
			this.label8.TabIndex = 23;
			this.label8.Text = "U_P4";
			// 
			// txtP3Uncertainty
			// 
			this.txtP3Uncertainty.Location = new System.Drawing.Point(56, 40);
			this.txtP3Uncertainty.Name = "txtP3Uncertainty";
			this.txtP3Uncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtP3Uncertainty.TabIndex = 16;
			this.txtP3Uncertainty.Text = "";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(16, 40);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(32, 16);
			this.label4.TabIndex = 17;
			this.label4.Text = "U_P3";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(152, 40);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(32, 16);
			this.label5.TabIndex = 15;
			this.label5.Text = "U_T3";
			// 
			// txtT3Uncertainty
			// 
			this.txtT3Uncertainty.Location = new System.Drawing.Point(192, 40);
			this.txtT3Uncertainty.Name = "txtT3Uncertainty";
			this.txtT3Uncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtT3Uncertainty.TabIndex = 14;
			this.txtT3Uncertainty.Text = "";
			// 
			// labT
			// 
			this.labT.Location = new System.Drawing.Point(120, 24);
			this.labT.Name = "labT";
			this.labT.Size = new System.Drawing.Size(40, 16);
			this.labT.TabIndex = 5;
			this.labT.Text = "T8 (C)";
			// 
			// txtTemperature_T8
			// 
			this.txtTemperature_T8.Location = new System.Drawing.Point(160, 24);
			this.txtTemperature_T8.Name = "txtTemperature_T8";
			this.txtTemperature_T8.Size = new System.Drawing.Size(40, 20);
			this.txtTemperature_T8.TabIndex = 4;
			this.txtTemperature_T8.Text = "";
			// 
			// label19
			// 
			this.label19.Location = new System.Drawing.Point(64, 16);
			this.label19.Name = "label19";
			this.label19.Size = new System.Drawing.Size(24, 16);
			this.label19.TabIndex = 43;
			this.label19.Text = "(%)";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(200, 16);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(32, 16);
			this.label14.TabIndex = 44;
			this.label14.Text = "(K)";
			// 
			// groupBox1
			// 
			this.groupBox1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.cmdChange,
																					this.txtPowerUncertainty,
																					this.txtPowerError,
																					this.label39,
																					this.txtFlowrateUncertainty,
																					this.txtFlowrateError,
																					this.label38,
																					this.label37,
																					this.txtDiameterUncertainty,
																					this.txtDiameterError,
																					this.label36,
																					this.label14,
																					this.txtP0Error,
																					this.label19,
																					this.txtTTUncertainty,
																					this.txtP3Error,
																					this.txtPressureUncertainty,
																					this.label10,
																					this.txtT0Uncertainty,
																					this.label12,
																					this.txtP4Uncertainty,
																					this.txtP3Uncertainty,
																					this.txtP4Error,
																					this.txtT3Uncertainty,
																					this.txtP0Uncertainty,
																					this.label5,
																					this.txtT4Uncertainty,
																					this.label13,
																					this.label11,
																					this.txtPressureError,
																					this.label8,
																					this.label4,
																					this.label9,
																					this.label17});
			this.groupBox1.Location = new System.Drawing.Point(352, 8);
			this.groupBox1.Name = "groupBox1";
			this.groupBox1.Size = new System.Drawing.Size(408, 144);
			this.groupBox1.TabIndex = 8;
			this.groupBox1.TabStop = false;
			this.groupBox1.Text = "Uncertainty of Original Data";
			// 
			// cmdChange
			// 
			this.cmdChange.Location = new System.Drawing.Point(296, 112);
			this.cmdChange.Name = "cmdChange";
			this.cmdChange.Size = new System.Drawing.Size(96, 24);
			this.cmdChange.TabIndex = 68;
			this.cmdChange.Text = "Confirm/Change";
			this.cmdChange.Click += new System.EventHandler(this.cmdChange_Click);
			// 
			// txtPowerUncertainty
			// 
			this.txtPowerUncertainty.Location = new System.Drawing.Point(352, 88);
			this.txtPowerUncertainty.Name = "txtPowerUncertainty";
			this.txtPowerUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtPowerUncertainty.TabIndex = 54;
			this.txtPowerUncertainty.Text = "";
			// 
			// txtPowerError
			// 
			this.txtPowerError.Location = new System.Drawing.Point(304, 88);
			this.txtPowerError.Name = "txtPowerError";
			this.txtPowerError.Size = new System.Drawing.Size(40, 20);
			this.txtPowerError.TabIndex = 52;
			this.txtPowerError.Text = "";
			// 
			// label39
			// 
			this.label39.Location = new System.Drawing.Point(240, 88);
			this.label39.Name = "label39";
			this.label39.Size = new System.Drawing.Size(64, 16);
			this.label39.TabIndex = 53;
			this.label39.Text = "U_Q (W)";
			// 
			// txtFlowrateUncertainty
			// 
			this.txtFlowrateUncertainty.Location = new System.Drawing.Point(352, 64);
			this.txtFlowrateUncertainty.Name = "txtFlowrateUncertainty";
			this.txtFlowrateUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtFlowrateUncertainty.TabIndex = 51;
			this.txtFlowrateUncertainty.Text = "";
			// 
			// txtFlowrateError
			// 
			this.txtFlowrateError.Location = new System.Drawing.Point(304, 64);
			this.txtFlowrateError.Name = "txtFlowrateError";
			this.txtFlowrateError.Size = new System.Drawing.Size(40, 20);
			this.txtFlowrateError.TabIndex = 49;
			this.txtFlowrateError.Text = "";
			// 
			// label38
			// 
			this.label38.Location = new System.Drawing.Point(240, 64);
			this.label38.Name = "label38";
			this.label38.Size = new System.Drawing.Size(64, 16);
			this.label38.TabIndex = 50;
			this.label38.Text = "U_m (kg/h)";
			// 
			// label37
			// 
			this.label37.Location = new System.Drawing.Point(360, 16);
			this.label37.Name = "label37";
			this.label37.Size = new System.Drawing.Size(24, 16);
			this.label37.TabIndex = 48;
			this.label37.Text = "(%)";
			// 
			// txtDiameterUncertainty
			// 
			this.txtDiameterUncertainty.Location = new System.Drawing.Point(352, 40);
			this.txtDiameterUncertainty.Name = "txtDiameterUncertainty";
			this.txtDiameterUncertainty.Size = new System.Drawing.Size(40, 20);
			this.txtDiameterUncertainty.TabIndex = 47;
			this.txtDiameterUncertainty.Text = "";
			// 
			// txtDiameterError
			// 
			this.txtDiameterError.Location = new System.Drawing.Point(304, 40);
			this.txtDiameterError.Name = "txtDiameterError";
			this.txtDiameterError.Size = new System.Drawing.Size(40, 20);
			this.txtDiameterError.TabIndex = 45;
			this.txtDiameterError.Text = "";
			// 
			// label36
			// 
			this.label36.Location = new System.Drawing.Point(240, 40);
			this.label36.Name = "label36";
			this.label36.Size = new System.Drawing.Size(56, 16);
			this.label36.TabIndex = 46;
			this.label36.Text = "U_D (mm)";
			// 
			// label20
			// 
			this.label20.Location = new System.Drawing.Point(120, 48);
			this.label20.Name = "label20";
			this.label20.Size = new System.Drawing.Size(40, 16);
			this.label20.TabIndex = 48;
			this.label20.Text = "T3 (C)";
			// 
			// txtTemperature_T3
			// 
			this.txtTemperature_T3.Location = new System.Drawing.Point(160, 48);
			this.txtTemperature_T3.Name = "txtTemperature_T3";
			this.txtTemperature_T3.Size = new System.Drawing.Size(40, 20);
			this.txtTemperature_T3.TabIndex = 47;
			this.txtTemperature_T3.Text = "";
			// 
			// label21
			// 
			this.label21.Location = new System.Drawing.Point(120, 72);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(40, 16);
			this.label21.TabIndex = 50;
			this.label21.Text = "T4 (C)";
			// 
			// txtTemperature_T4
			// 
			this.txtTemperature_T4.Location = new System.Drawing.Point(160, 72);
			this.txtTemperature_T4.Name = "txtTemperature_T4";
			this.txtTemperature_T4.Size = new System.Drawing.Size(40, 20);
			this.txtTemperature_T4.TabIndex = 49;
			this.txtTemperature_T4.Text = "";
			// 
			// label22
			// 
			this.label22.Location = new System.Drawing.Point(120, 96);
			this.label22.Name = "label22";
			this.label22.Size = new System.Drawing.Size(40, 16);
			this.label22.TabIndex = 52;
			this.label22.Text = "T0 (C)";
			// 
			// txtTemperature_T0
			// 
			this.txtTemperature_T0.Location = new System.Drawing.Point(160, 96);
			this.txtTemperature_T0.Name = "txtTemperature_T0";
			this.txtTemperature_T0.Size = new System.Drawing.Size(40, 20);
			this.txtTemperature_T0.TabIndex = 51;
			this.txtTemperature_T0.Text = "";
			// 
			// groupBox2
			// 
			this.groupBox2.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.txtThermalloss,
																					this.label30,
																					this.txtPower,
																					this.label29,
																					this.txtQuality,
																					this.label28,
																					this.txtFlowrate,
																					this.label27,
																					this.txtTemperature_T8,
																					this.label20,
																					this.txtTemperature_T4,
																					this.label21,
																					this.labT,
																					this.txtTemperature_T3,
																					this.txtTemperature_T0,
																					this.label22,
																					this.label32,
																					this.label33,
																					this.txtSatTemperature,
																					this.txtWellTemperature,
																					this.txtThermallossCoefficient_T3toT,
																					this.txtThermallossCoefficient_T3toT4,
																					this.txtThermallossCoefficient_T8toT3,
																					this.label24,
																					this.label26,
																					this.label25});
			this.groupBox2.Location = new System.Drawing.Point(16, 144);
			this.groupBox2.Name = "groupBox2";
			this.groupBox2.Size = new System.Drawing.Size(320, 152);
			this.groupBox2.TabIndex = 9;
			this.groupBox2.TabStop = false;
			this.groupBox2.Text = "Deduced Data";
			// 
			// txtThermalloss
			// 
			this.txtThermalloss.Location = new System.Drawing.Point(264, 72);
			this.txtThermalloss.Name = "txtThermalloss";
			this.txtThermalloss.Size = new System.Drawing.Size(40, 20);
			this.txtThermalloss.TabIndex = 59;
			this.txtThermalloss.Text = "";
			// 
			// label30
			// 
			this.label30.Location = new System.Drawing.Point(208, 72);
			this.label30.Name = "label30";
			this.label30.Size = new System.Drawing.Size(64, 16);
			this.label30.TabIndex = 60;
			this.label30.Text = "Q_loss (W)";
			// 
			// txtPower
			// 
			this.txtPower.Location = new System.Drawing.Point(264, 96);
			this.txtPower.Name = "txtPower";
			this.txtPower.Size = new System.Drawing.Size(40, 20);
			this.txtPower.TabIndex = 57;
			this.txtPower.Text = "";
			// 
			// label29
			// 
			this.label29.Location = new System.Drawing.Point(208, 96);
			this.label29.Name = "label29";
			this.label29.Size = new System.Drawing.Size(40, 16);
			this.label29.TabIndex = 58;
			this.label29.Text = "Q (W)";
			// 
			// txtQuality
			// 
			this.txtQuality.Location = new System.Drawing.Point(264, 48);
			this.txtQuality.Name = "txtQuality";
			this.txtQuality.Size = new System.Drawing.Size(40, 20);
			this.txtQuality.TabIndex = 55;
			this.txtQuality.Text = "";
			// 
			// label28
			// 
			this.label28.Location = new System.Drawing.Point(208, 48);
			this.label28.Name = "label28";
			this.label28.Size = new System.Drawing.Size(40, 16);
			this.label28.TabIndex = 56;
			this.label28.Text = "x (%)";
			// 
			// txtFlowrate
			// 
			this.txtFlowrate.Location = new System.Drawing.Point(264, 24);
			this.txtFlowrate.Name = "txtFlowrate";
			this.txtFlowrate.Size = new System.Drawing.Size(40, 20);
			this.txtFlowrate.TabIndex = 53;
			this.txtFlowrate.Text = "";
			// 
			// label27
			// 
			this.label27.Location = new System.Drawing.Point(208, 24);
			this.label27.Name = "label27";
			this.label27.Size = new System.Drawing.Size(48, 16);
			this.label27.TabIndex = 54;
			this.label27.Text = "m (kg/h)";
			// 
			// label33
			// 
			this.label33.Location = new System.Drawing.Point(16, 24);
			this.label33.Name = "label33";
			this.label33.Size = new System.Drawing.Size(48, 16);
			this.label33.TabIndex = 69;
			this.label33.Text = "Ts (C)";
			// 
			// txtSatTemperature
			// 
			this.txtSatTemperature.Location = new System.Drawing.Point(72, 24);
			this.txtSatTemperature.Name = "txtSatTemperature";
			this.txtSatTemperature.Size = new System.Drawing.Size(40, 20);
			this.txtSatTemperature.TabIndex = 68;
			this.txtSatTemperature.Text = "";
			// 
			// groupBox3
			// 
			this.groupBox3.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.txtAlarm});
			this.groupBox3.Location = new System.Drawing.Point(16, 464);
			this.groupBox3.Name = "groupBox3";
			this.groupBox3.Size = new System.Drawing.Size(320, 56);
			this.groupBox3.TabIndex = 10;
			this.groupBox3.TabStop = false;
			this.groupBox3.Text = "Alarm";
			// 
			// txtAlarm
			// 
			this.txtAlarm.Location = new System.Drawing.Point(16, 16);
			this.txtAlarm.Multiline = true;
			this.txtAlarm.Name = "txtAlarm";
			this.txtAlarm.Size = new System.Drawing.Size(288, 24);
			this.txtAlarm.TabIndex = 60;
			this.txtAlarm.Text = "";
			// 
			// groupBox4
			// 
			this.groupBox4.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.txtUlsUncertainty,
																					this.txtThermallossUncertainty,
																					this.txtQualityUncertainty,
																					this.txtUgsUncertainty,
																					this.txtThermallossCoefficientUncertainty,
																					this.label41,
																					this.label40,
																					this.label42,
																					this.label47,
																					this.label52});
			this.groupBox4.Location = new System.Drawing.Point(16, 304);
			this.groupBox4.Name = "groupBox4";
			this.groupBox4.Size = new System.Drawing.Size(320, 152);
			this.groupBox4.TabIndex = 11;
			this.groupBox4.TabStop = false;
			this.groupBox4.Text = "Uncertainty of Deduced Data";
			// 
			// label41
			// 
			this.label41.Location = new System.Drawing.Point(16, 120);
			this.label41.Name = "label41";
			this.label41.Size = new System.Drawing.Size(232, 16);
			this.label41.TabIndex = 67;
			this.label41.Text = "Uncertainty of liquid superficial velocity (m/s)";
			// 
			// txtUlsUncertainty
			// 
			this.txtUlsUncertainty.Location = new System.Drawing.Point(248, 120);
			this.txtUlsUncertainty.Name = "txtUlsUncertainty";
			this.txtUlsUncertainty.Size = new System.Drawing.Size(56, 20);
			this.txtUlsUncertainty.TabIndex = 66;
			this.txtUlsUncertainty.Text = "";
			// 
			// txtThermallossUncertainty
			// 
			this.txtThermallossUncertainty.Location = new System.Drawing.Point(248, 48);
			this.txtThermallossUncertainty.Name = "txtThermallossUncertainty";
			this.txtThermallossUncertainty.Size = new System.Drawing.Size(56, 20);
			this.txtThermallossUncertainty.TabIndex = 59;
			this.txtThermallossUncertainty.Text = "";
			// 
			// label40
			// 
			this.label40.Location = new System.Drawing.Point(16, 48);
			this.label40.Name = "label40";
			this.label40.Size = new System.Drawing.Size(232, 16);
			this.label40.TabIndex = 60;
			this.label40.Text = "Uncertainty of thermalloss (W)";
			// 
			// txtQualityUncertainty
			// 
			this.txtQualityUncertainty.Location = new System.Drawing.Point(248, 72);
			this.txtQualityUncertainty.Name = "txtQualityUncertainty";
			this.txtQualityUncertainty.Size = new System.Drawing.Size(56, 20);
			this.txtQualityUncertainty.TabIndex = 55;
			this.txtQualityUncertainty.Text = "";
			// 
			// label42
			// 
			this.label42.Location = new System.Drawing.Point(16, 72);
			this.label42.Name = "label42";
			this.label42.Size = new System.Drawing.Size(232, 16);
			this.label42.TabIndex = 56;
			this.label42.Text = "Uncertainty of quality (%)";
			// 
			// txtUgsUncertainty
			// 
			this.txtUgsUncertainty.Location = new System.Drawing.Point(248, 96);
			this.txtUgsUncertainty.Name = "txtUgsUncertainty";
			this.txtUgsUncertainty.Size = new System.Drawing.Size(56, 20);
			this.txtUgsUncertainty.TabIndex = 51;
			this.txtUgsUncertainty.Text = "";
			// 
			// label47
			// 
			this.label47.Location = new System.Drawing.Point(16, 96);
			this.label47.Name = "label47";
			this.label47.Size = new System.Drawing.Size(240, 16);
			this.label47.TabIndex = 52;
			this.label47.Text = "Uncertainty of vapour superficial velocity (m/s)";
			// 
			// txtThermallossCoefficientUncertainty
			// 
			this.txtThermallossCoefficientUncertainty.Location = new System.Drawing.Point(248, 24);
			this.txtThermallossCoefficientUncertainty.Name = "txtThermallossCoefficientUncertainty";
			this.txtThermallossCoefficientUncertainty.Size = new System.Drawing.Size(56, 20);
			this.txtThermallossCoefficientUncertainty.TabIndex = 57;
			this.txtThermallossCoefficientUncertainty.Text = "";
			// 
			// label52
			// 
			this.label52.Location = new System.Drawing.Point(16, 24);
			this.label52.Name = "label52";
			this.label52.Size = new System.Drawing.Size(232, 16);
			this.label52.TabIndex = 65;
			this.label52.Text = "Uncertainty of thermalloss Coefficient (%)";
			// 
			// cmdCalculate
			// 
			this.cmdCalculate.Location = new System.Drawing.Point(616, 496);
			this.cmdCalculate.Name = "cmdCalculate";
			this.cmdCalculate.Size = new System.Drawing.Size(64, 24);
			this.cmdCalculate.TabIndex = 12;
			this.cmdCalculate.Text = "Calculate";
			this.cmdCalculate.Click += new System.EventHandler(this.cmdCalculate_Click);
			// 
			// FrmUncertaintyAnalysis
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(776, 533);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdCalculate,
																		  this.groupBox4,
																		  this.groupBox3,
																		  this.groupBox2,
																		  this.groupBox1,
																		  this.grpOriginalData,
																		  this.cmdExit,
																		  this.grpOutput});
			this.Name = "FrmUncertaintyAnalysis";
			this.StartPosition = System.Windows.Forms.FormStartPosition.Manual;
			this.Text = "Uncertainty Analysis";
			this.Load += new System.EventHandler(this.FrmUncertaintyAnalysis_Load);
			this.grpOutput.ResumeLayout(false);
			this.grpOriginalData.ResumeLayout(false);
			this.groupBox1.ResumeLayout(false);
			this.groupBox2.ResumeLayout(false);
			this.groupBox3.ResumeLayout(false);
			this.groupBox4.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void FrmUncertaintyAnalysis_Load(object sender, System.EventArgs e)
		{
			this.comboBoxDiameter.Text="4.26";	
			this.txtPressure.Text="6.0";
			this.txtGasSuperficialVelocity.Text="10.0";
			this.txtLiquidSuperficialVelocity.Text="5.0";
			this.txtT8SubcoolingDegree.Text="-5";		   									   
			this.txtAmbientTemperature.Text="20";
			this.cmdChange.Enabled=false;
			this.comboBoxPosition.Enabled=false;
			this.cmdCalculate.Enabled=false;
		}

		private void cmdComfirm_Click(object sender, System.EventArgs e)
		{
			P=100000*double.Parse(txtPressure.Text);
			D=double.Parse(comboBoxDiameter.Text)/1000;
			Ugs=double.Parse(txtGasSuperficialVelocity.Text);
			Uls=double.Parse(txtLiquidSuperficialVelocity.Text);
			Ta=double.Parse(txtAmbientTemperature.Text)+273.15;
			T8_subcooling=double.Parse(txtT8SubcoolingDegree.Text);
			calDeducedData();
			calDataUncertainty();
			this.cmdChange.Enabled=true;
		}

		private void calDeducedData()
		{
			double T3_Temporary;
			R134aProperty R134a_Temporary;
			R134aPropertyUncertainty R134aUncertainty_Temporary;
			R134a_Temporary=new R134aProperty(20+273.15,P);
			Tsat=R134a_Temporary.SaturatedTemperature;
			R134a_Saturated=new R134aProperty(Tsat,P);
			R134a_Point4=R134a_Saturated;
			R134a_Point0=R134a_Saturated;
			R134a_ObservationPoint=R134a_Saturated;
			Tw=Tsat+5.0;
			K_T8toT3=0.29;
			switch (comboBoxDiameter.Text)
			{
				case "1.10":
				{
					K_T3toT4=0.048;
					K=2.125*K_T3toT4;
					break;
				}
				case "2.01":
				{
					K_T3toT4=0.04;
					K=2.15*K_T3toT4;
					break;
				}
				case "2.88":
				{
					K_T3toT4=0.044;
					K=2.35*K_T3toT4;
					break;
				}
				case "4.26":
				{
					K_T3toT4=0.068;
					K=1.65*K_T3toT4;
					break;
				}
			}
			T8=(Tsat+double.Parse(txtT8SubcoolingDegree.Text)<Ta?(Tsat+Ta)/2.0:Tsat+double.Parse(txtT8SubcoolingDegree.Text));
			T3=T8;
			T4=Tsat;
			T0=Tsat;
			m=(Ugs*R134a_Saturated.VapourDensity+Uls*R134a_Saturated.LiquidDensity)*Math.PI*Math.Pow(D,2)/4;
			x=Ugs*R134a_Saturated.VapourDensity/(Ugs*R134a_Saturated.VapourDensity+Uls*R134a_Saturated.LiquidDensity);
			Q_loss=K*(Tw-Ta);
			do
			{
				T3_Temporary=T3;
				R134aUncertainty_Temporary=new R134aPropertyUncertainty((T8+T3)/2,P,0.0,0.0);
				T3=Ta+(T8-Ta)*Math.Pow(Math.E,-1*K_T8toT3/(m*R134aUncertainty_Temporary.LiquidEnthalpy_TemperatureDerivative));
			}while (Math.Abs(T3-T3_Temporary)>0.00001);
			R134a_Point3=new R134aProperty(T3,P);
			Q=m*((R134a_Saturated.LiquidEnthalpy-R134a_Point3.LiquidEnthalpy)+x*R134a_Saturated.LatentHeat)+Q_loss;

			this.txtSatTemperature.Text=Math.Round((Tsat-273.15),2).ToString();
			this.txtWellTemperature.Text=Math.Round((Tw-273.15),2).ToString();
			this.txtThermallossCoefficient_T8toT3.Text=Math.Round(K_T8toT3,2).ToString();
			this.txtThermallossCoefficient_T3toT4.Text=Math.Round(K_T3toT4,3).ToString();
			this.txtThermallossCoefficient_T3toT.Text=Math.Round(K,3).ToString();
			this.txtTemperature_T8.Text=Math.Round((T8-273.15),2).ToString();
			this.txtTemperature_T3.Text=Math.Round((T3-273.15),2).ToString();
			this.txtTemperature_T4.Text=Math.Round((T4-273.15),2).ToString();
			this.txtTemperature_T0.Text=Math.Round((T0-273.15),2).ToString();
			this.txtFlowrate.Text=Math.Round((3600*m),2).ToString();
			this.txtQuality.Text=Math.Round(100*x,2).ToString();
			this.txtThermalloss.Text=Math.Round(Q_loss,2).ToString();
			this.txtPower.Text=Math.Round(Q,2).ToString();
		}

		private void calDataUncertainty()
		{
			double M=3600*m;
			this.txtP3Error.Text="";
			this.txtP4Error.Text="";
			this.txtP0Error.Text="";
			this.txtPressureError.Text="";
			this.txtDiameterError.Text="";
			this.txtFlowrateError.Text="";
			this.txtPowerError.Text="";
			this.txtAlarm.Text="";
			switch (comboBoxDiameter.Text)
			{
				case "1.10":
				{
					this.txtDiameterUncertainty.Text="0.36";
					break;
				}
				case "2.01":
				{
					this.txtDiameterUncertainty.Text="0.17";
					break;
				}
				case "2.88":
				{
					this.txtDiameterUncertainty.Text="0.06";
					break;
				}
				case "4.26":
				{
					this.txtDiameterUncertainty.Text="0.11";
					break;
				}
			}
			this.txtP3Uncertainty.Text="0.42";
			this.txtP4Uncertainty.Text="0.26";
			this.txtP0Uncertainty.Text="0.26";
			this.txtPressureUncertainty.Text="";
			this.txtT3Uncertainty.Text="0.16";
			this.txtT4Uncertainty.Text="0.16";
			this.txtT0Uncertainty.Text="0.16";
			this.txtTTUncertainty.Text="0.16";
			if (M<0.5) this.txtAlarm.Text="Flow rate is too small!";
			else if (M<2.95) this.txtFlowrateUncertainty.Text="0.54";
			else if (M<5.40) this.txtFlowrateUncertainty.Text="0.20";
			else if (M<7.85) this.txtFlowrateUncertainty.Text="0.17";
			else if (M<15.2) this.txtFlowrateUncertainty.Text="0.16";
			else if (M<25) this.txtFlowrateUncertainty.Text="0.15";
			else if (M<54) this.txtFlowrateUncertainty.Text="0.22";
			else if (M<78.5) this.txtFlowrateUncertainty.Text="0.18";
			else if (M<127.5) this.txtFlowrateUncertainty.Text="0.17";
			else if (M<201) this.txtFlowrateUncertainty.Text="0.16";
			else if (M<500) this.txtFlowrateUncertainty.Text="0.15";
			else this.txtAlarm.Text="Flow rate is too big!";
			if (Q<2.68) 
			{
				this.txtPowerError.Text="0.013";
				this.txtPowerUncertainty.Text="";
			}
			else if (Q<4.1) this.txtPowerUncertainty.Text="0.49";
			else if (Q<42.8) this.txtPowerUncertainty.Text="0.44";
			else if (Q<1070) this.txtPowerUncertainty.Text="0.20";
			else this.txtPowerUncertainty.Text="0.10";
		}

		private void cmdChange_Click(object sender, System.EventArgs e)
		{
			double temporaryArgument;
			U_P3=double.Parse(this.txtP3Uncertainty.Text)/100;
			U_P4=double.Parse(this.txtP4Uncertainty.Text)/100;
			U_P0=double.Parse(this.txtP0Uncertainty.Text)/100;
			U_P=(U_P4+2*U_P0)/3.0;
			temporaryArgument=100*U_P;
			this.txtPressureUncertainty.Text=temporaryArgument.ToString();
			E_T3=double.Parse(this.txtT3Uncertainty.Text);
			E_T4=double.Parse(this.txtT4Uncertainty.Text);
			E_T0=double.Parse(this.txtT0Uncertainty.Text);
			E_TT=double.Parse(this.txtTTUncertainty.Text);
			U_D=double.Parse(this.txtDiameterUncertainty.Text)/100;
			U_m=double.Parse(this.txtFlowrateUncertainty.Text)/100;
			if (Q<2.68)
			{
				E_Q=0.013;
				U_Q=E_Q/Q;
			}
			else
			{
				U_Q=double.Parse(this.txtPowerUncertainty.Text)/100;
				E_Q=Q*U_Q;
			}
			E_P3=U_P3*P;
			E_P4=U_P4*P;
			E_P0=U_P0*P;
			E_P=U_P*P;
			E_D=U_D*D;
			E_m=U_m*m;
			temporaryArgument=E_P3/100000;
			this.txtP3Error.Text=temporaryArgument.ToString();
			temporaryArgument=E_P4/100000;
			this.txtP4Error.Text=temporaryArgument.ToString();
			temporaryArgument=E_P0/100000;
			this.txtP0Error.Text=temporaryArgument.ToString();
			temporaryArgument=E_P/100000;
			this.txtPressureError.Text=temporaryArgument.ToString();
			temporaryArgument=E_D*1000;
			this.txtDiameterError.Text=temporaryArgument.ToString();
			temporaryArgument=E_m*3600;
			this.txtFlowrateError.Text=temporaryArgument.ToString();
			this.txtPowerError.Text=E_Q.ToString();
			temporaryArgument=U_Q*100;
			this.txtPowerUncertainty.Text=temporaryArgument.ToString();
			this.comboBoxPosition.Enabled=true;
			this.comboBoxPosition.Text="Point 4";
			this.cmdCalculate.Enabled=true;
		}

		private void comboBoxPosition_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			R134aUncertainty_Point3=new R134aPropertyUncertainty(T3,P,E_T3,E_P3);
			R134aUncertainty_Point4=new R134aPropertyUncertainty(T4,P,E_T4,E_P4);
			R134aUncertainty_Point0=new R134aPropertyUncertainty(T0,P,E_T0,E_P0);
			R134aUncertainty_ObservationPoint=new R134aPropertyUncertainty((T4+2*T0)/3.0,P,(E_T4+2*E_T0)/3.0,(E_P4+2*E_P0)/3.0);
			switch(comboBoxPosition.Text)
			{
				case "Point 3":
				{
					R134aParameter=R134a_Point3;
					R134aUncertainty=R134aUncertainty_Point3;
					break;
				}
				case "Point 4":
				{
					R134aParameter=R134a_Point4;
					R134aUncertainty=R134aUncertainty_Point4;
					break;
				}
				default: //include "Point 0"
				{
					R134aParameter=R134a_Point0;
					R134aUncertainty=R134aUncertainty_Point0;
					break;
				}
			}
			state=R134aParameter.State;
			this.txtState.Text=state;
			this.txtP.Text=(R134aParameter.Pressure/100000).ToString();
			this.txtT.Text=Math.Round(R134aParameter.Temperature-273.15,2).ToString();
			this.calR134aProperty();
			this.calR134aPropertyDerivative();
			this.calR134aPropertyError();
		}

		private void calR134aProperty()
		{
			Ts=R134aParameter.SaturatedTemperature;
			Ps=R134aParameter.SaturatedPressure;
			Rol=R134aParameter.LiquidDensity;
			Rov=R134aParameter.VapourDensity;
			Hl=R134aParameter.LiquidEnthalpy;
			Hv=R134aParameter.VapourEnthalpy;
			Hfg=R134aParameter.LatentHeat;
			Mul=R134aParameter.SaturatedLiquidViscosity;
			Muv=R134aParameter.SaturatedVapourViscosity;
			St=R134aParameter.SurfaceTension;

			this.txtSaturatedTemperature.Text=(Ts!=-999&&state=="two-phase"?(Math.Round(Ts-273.15,2)).ToString():"");
			this.txtSaturatedPressure.Text=(Ps!=-999&&state=="two-phase"?(Math.Round(Ps/100000,2)).ToString():"");
			this.txtLiquidDensity.Text=(Rol!=-999?(Math.Round(Rol,2)).ToString():"");
			this.txtVapourDensity.Text=(Rov!=-999?(Math.Round(Rov,2)).ToString():"");
			this.txtLiquidEnthalpy.Text=(Hl!=-999?(Math.Round(Hl/1000,3)).ToString():"");
			this.txtVapourEnthalpy.Text=(Hv!=-999?(Math.Round(Hv/1000,3)).ToString():"");
			this.txtLatentHeat.Text=(Hfg!=-999?(Math.Round(Hfg/1000,3)).ToString():"");
			this.txtSaturatedLiquidViscosity.Text=(Mul!=-999?(Math.Round(Mul*1000000,2)).ToString():"");
			this.txtSaturatedVapourViscosity.Text=(Muv!=-999?(Math.Round(Muv*1000000,2)).ToString():"");
			this.txtSurfaceTension.Text=(St!=-999?(Math.Round(St*1000,2)).ToString():"");
		}

		private void calR134aPropertyDerivative()
		{
			Ts_dP=R134aUncertainty.SaturatedTemperature_PressureDerivative;
			Rol_dP=R134aUncertainty.LiquidDensity_PressureDerivative;
			Rov_dP=R134aUncertainty.VapourDensity_PressureDerivative;
			Hl_dP=R134aUncertainty.LiquidEnthalpy_PressureDerivative;
			Hv_dP=R134aUncertainty.VapourEnthalpy_PressureDerivative;
			Hfg_dP=R134aUncertainty.LatentHeat_PressureDerivative;
			Mul_dP=R134aUncertainty.SaturatedLiquidViscosity_PressureDerivative;
			Muv_dP=R134aUncertainty.SaturatedVapourViscosity_PressureDerivative;
			St_dP=R134aUncertainty.SurfaceTension_PressureDerivative;
			Ps_dT=R134aUncertainty.SaturatedPressure_TemperatureDerivative;
			Rol_dT=R134aUncertainty.LiquidDensity_TemperatureDerivative;
			Rov_dT=R134aUncertainty.VapourDensity_TemperatureDerivative;
			Hl_dT=R134aUncertainty.LiquidEnthalpy_TemperatureDerivative;
			Hv_dT=R134aUncertainty.VapourEnthalpy_TemperatureDerivative;
			Hfg_dT=R134aUncertainty.LatentHeat_TemperatureDerivative;
			Mul_dT=R134aUncertainty.SaturatedLiquidViscosity_TemperatureDerivative;
			Muv_dT=R134aUncertainty.SaturatedVapourViscosity_TemperatureDerivative;
			St_dT=R134aUncertainty.SurfaceTension_TemperatureDerivative;

			this.txtSaturatedTemperature_DP.Text=(Ts_dP!=-999?(Math.Round(Ts_dP*100000,3)).ToString():"");
			this.txtSaturatedPressure_DT.Text=(Ps_dT!=-999?(Math.Round(Ps_dT/100000,3)).ToString():"");
			this.txtLiquidDensity_DP.Text=(Rol_dP!=-999?(Math.Round(Rol_dP*100000,3)).ToString():"");
			this.txtLiquidDensity_DT.Text=(Rol_dT!=-999?(Math.Round(Rol_dT,3)).ToString():"");
			this.txtVapourDensity_DP.Text=(Rov_dP!=-999?(Math.Round(Rov_dP*100000,3)).ToString():"");
			this.txtVapourDensity_DT.Text=(Rov_dT!=-999?(Math.Round(Rov_dT,3)).ToString():"");
			this.txtLiquidEnthalpy_DP.Text=(Hl_dP!=-999?(Math.Round(Hl_dP*100000/1000,3)).ToString():"");
			this.txtLiquidEnthalpy_DT.Text=(Hl_dT!=-999?(Math.Round(Hl_dT/1000,3)).ToString():"");
			this.txtVapourEnthalpy_DP.Text=(Hv_dP!=-999?(Math.Round(Hv_dP*100000/1000,3)).ToString():"");
			this.txtVapourEnthalpy_DT.Text=(Hv_dT!=-999?(Math.Round(Hv_dT/1000,3)).ToString():"");
			this.txtLatentHeat_DP.Text=(Hfg_dP!=-999?(Math.Round(Hfg_dP*100000/1000,3)).ToString():"");
			this.txtLatentHeat_DT.Text=(Hfg_dT!=-999?(Math.Round(Hfg_dT/1000,3)).ToString():"");
			this.txtSaturatedLiquidViscosity_DP.Text=(Mul_dP!=-999?(Math.Round(Mul_dP*100000*1000000,3)).ToString():"");
			this.txtSaturatedLiquidViscosity_DT.Text=(Mul_dT!=-999?(Math.Round(Mul_dT*1000000,3)).ToString():"");
			this.txtSaturatedVapourViscosity_DP.Text=(Muv_dP!=-999?(Math.Round(Muv_dP*100000*1000000,3)).ToString():"");
			this.txtSaturatedVapourViscosity_DT.Text=(Muv_dT!=-999?(Math.Round(Muv_dT*1000000,3)).ToString():"");
			this.txtSurfaceTension_DP.Text=(St_dP!=-999?(Math.Round(St_dP*100000*1000,3)).ToString():"");
			this.txtSurfaceTension_DT.Text=(St_dT!=-999?(Math.Round(St_dT*1000,3)).ToString():"");
		}

		private void calR134aPropertyError()
		{

			E_Ps=R134aUncertainty.SaturatedPressure_Error;
			E_Ts=R134aUncertainty.SaturatedTemperature_Error;
			E_Rol=R134aUncertainty.LiquidDensity_Error;
			E_Rov=R134aUncertainty.VapourDensity_Error;
			E_Hl=R134aUncertainty.LiquidEnthalpy_Error;
			E_Hv=R134aUncertainty.VapourEnthalpy_Error;
			E_Hfg=R134aUncertainty.LatentHeat_Error;
			E_Mul=R134aUncertainty.SaturatedLiquidViscosity_Error;
			E_Muv=R134aUncertainty.SaturatedVapourViscosity_Error;
			E_St=R134aUncertainty.SurfaceTension_Error;
			U_Ps=R134aUncertainty.SaturatedPressure_Uncertainty;
			U_Ts=R134aUncertainty.SaturatedTemperature_Uncertainty;
			U_Rol=R134aUncertainty.LiquidDensity_Uncertainty;
			U_Rov=R134aUncertainty.VapourDensity_Uncertainty;
			U_Hl=R134aUncertainty.LiquidEnthalpy_Uncertainty;
			U_Hv=R134aUncertainty.VapourEnthalpy_Uncertainty;
			U_Hfg=R134aUncertainty.LatentHeat_Uncertainty;
			U_Mul=R134aUncertainty.SaturatedLiquidViscosity_Uncertainty;
			U_Muv=R134aUncertainty.SaturatedVapourViscosity_Uncertainty;
			U_St=R134aUncertainty.SurfaceTension_Uncertainty;

			this.txtSaturatedTemperatureError.Text=(E_Ts!=-999?(Math.Round(E_Ts,3)).ToString():"");
			this.txtSaturatedPressureError.Text=(E_Ps!=-999?(Math.Round(E_Ps/100000,3)).ToString():"");
			this.txtLiquidDensityError.Text=(E_Rol!=-999?(Math.Round(E_Rol,3)).ToString():"");
			this.txtVapourDensityError.Text=(E_Rov!=-999?(Math.Round(E_Rov,3)).ToString():"");
			this.txtLiquidEnthalpyError.Text=(E_Hl!=-999?(Math.Round(E_Hl/1000,3)).ToString():"");
			this.txtVapourEnthalpyError.Text=(E_Hv!=-999?(Math.Round(E_Hv/1000,3)).ToString():"");
			this.txtLatentHeatError.Text=(E_Hfg!=-999?(Math.Round(E_Hfg/1000,3)).ToString():"");
			this.txtSaturatedLiquidViscosityError.Text=(E_Mul!=-999?(Math.Round(E_Mul*1000000,3)).ToString():"");
			this.txtSaturatedVapourViscosityError.Text=(E_Muv!=-999?(Math.Round(E_Muv*1000000,3)).ToString():"");
			this.txtSurfaceTensionError.Text=(E_St!=-999?(Math.Round(E_St*1000,3)).ToString():"");

			this.txtSaturatedTemperatureUncertainty.Text=(U_Ts!=-999?(Math.Round(U_Ts*100,3)).ToString():"");
			this.txtSaturatedPressureUncertainty.Text=(U_Ps!=-999?(Math.Round(U_Ps*100,3)).ToString():"");
			this.txtLiquidDensityUncertainty.Text=(U_Rol!=-999?(Math.Round(U_Rol*100,3)).ToString():"");
			this.txtVapourDensityUncertainty.Text=(U_Rov!=-999?(Math.Round(U_Rov*100,3)).ToString():"");
			this.txtLiquidEnthalpyUncertainty.Text=(U_Hl!=-999?(Math.Round(U_Hl*100,3)).ToString():"");
			this.txtVapourEnthalpyUncertainty.Text=(U_Hv!=-999?(Math.Round(U_Hv*100,3)).ToString():"");
			this.txtLatentHeatUncertainty.Text=(U_Hfg!=-999?(Math.Round(U_Hfg*100,3)).ToString():"");
			this.txtSaturatedLiquidViscosityUncertainty.Text=(U_Mul!=-999?(Math.Round(U_Mul*100,3)).ToString():"");
			this.txtSaturatedVapourViscosityUncertainty.Text=(U_Muv!=-999?(Math.Round(U_Muv*100,3)).ToString():"");
			this.txtSurfaceTensionUncertainty.Text=(U_St!=-999?(Math.Round(U_St*100,3)).ToString():"");
		}

		private void cmdExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void cmdCalculate_Click(object sender, System.EventArgs e)
		{
			this.comboBoxPosition_SelectedIndexChanged(sender,e);
			this.calThermallossCoefficientError();
			this.calThermallossError();
			this.calQualityError();
			this.calSuperficialVelocityError();
			this.cmdChange.Enabled=false;
			this.comboBoxPosition.Enabled=false;
			this.cmdCalculate.Enabled=false;
		}
		private void calThermallossCoefficientError()
		{
			double t_Ambient,u_Temporary;
			double P_Single,e_m,T3_Single,T4_Single,H3_Single,H4_Single,E_H3,E_H4;
			R134aProperty SingleR134a_Point3,SingleR134a_Point4;
			R134aPropertyUncertainty SingleR134aUncertainty_Point3,SingleR134aUncertainty_Point4;

			E_AverageWallTemperatureDifference=Math.Sqrt(16.0/15.0)*E_TT;
			P_Single=14.0*100000;
			e_m=-999;
			t_Ambient=-999;
			T3_Single=-999;
			T4_Single=-999;

			switch (comboBoxDiameter.Text)
			{
				case "1.10":
				{
					e_m=0.54/100;  //m=0.52kg/hr
					t_Ambient=23.16+273.15;
					T3_Single=48.15+273.15;
					T4_Single=43.82+273.15;
					break;
				}
				case "2.01":
				{
					e_m=0.54/100; //m=0.97kg/hr
					t_Ambient=19.6+273.15;
					T3_Single=33.2+273.15;
					T4_Single=31.9+273.15;
					break;
				}
				case "2.88":
				{
					e_m=0.54/100;  //m=1.31kg/hr
					t_Ambient=20.97+273.15;
					T3_Single=39.93+273.15;
					T4_Single=38.6+273.15;
					break;
				}
				case "4.26":
				{
					e_m=0.54/100;  //m=2.03kg/hr
					t_Ambient=19.8+273.15;
					T3_Single=39.1+273.15;
					T4_Single=37.6+273.15;
					break;
				}
			}
			SingleR134a_Point3=new R134aProperty(T3_Single,P_Single);
			SingleR134a_Point4=new R134aProperty(T4_Single,P_Single);
			SingleR134aUncertainty_Point3=new R134aPropertyUncertainty(T3_Single,P_Single,E_T3,E_P3);
			SingleR134aUncertainty_Point4=new R134aPropertyUncertainty(T4_Single,P_Single,E_T4,E_P4);
			H3_Single=SingleR134a_Point3.LiquidEnthalpy;
			H4_Single=SingleR134a_Point4.LiquidEnthalpy;
			E_H3=SingleR134aUncertainty_Point3.LiquidEnthalpy_Error;
			E_H4=SingleR134aUncertainty_Point4.LiquidEnthalpy_Error;
			U_K=Math.Sqrt(Math.Pow(e_m,2)+(Math.Pow(E_H3,2)+Math.Pow(E_H4,2))/Math.Pow(H3_Single-H4_Single,2)+Math.Pow(E_AverageWallTemperatureDifference/((T3_Single+T4_Single)/2-t_Ambient),2));
			u_Temporary=Math.Round(100*U_K,4);
			this.txtThermallossCoefficientUncertainty.Text=u_Temporary.ToString();
		}

		private void calThermallossError()
		{
			E_Qloss=Math.Round(Math.Sqrt(Math.Pow((Tw-Ta)*U_K*K,2)+Math.Pow(K*E_AverageWallTemperatureDifference,2)),4);
			U_Qloss=E_Qloss/Q_loss;
			this.txtThermallossUncertainty.Text=E_Qloss.ToString();
		}
		private void calQualityError()
		{
			double h_mixture,hfg,hl,e_hl,e_h3,e_hfg,e_Temporary;
			h_mixture=this.R134a_Point3.LiquidEnthalpy+(Q-Q_loss)/m;
			e_h3=this.R134aUncertainty_Point3.LiquidEnthalpy_Error;
			E_Hmixture=Math.Sqrt(Math.Pow(e_h3,2)+Math.Pow(E_Q/m,2)+Math.Pow(E_Qloss/m,2)+Math.Pow((Q-Q_loss)*E_m/(m*m),2));
			hfg=this.R134a_ObservationPoint.LatentHeat;
			hl=this.R134a_ObservationPoint.LiquidEnthalpy;
			e_hl=this.R134aUncertainty_ObservationPoint.LiquidEnthalpy_Error;
			e_hfg=this.R134aUncertainty_ObservationPoint.LatentHeat_Error;
			E_x=Math.Sqrt(Math.Pow(E_Hmixture/hfg,2)+Math.Pow(e_hl/hfg,2)+Math.Pow((h_mixture-hl)*e_hfg/(hfg*hfg),2));
			e_Temporary=Math.Round(100*E_x,4);
			this.txtQualityUncertainty.Text=e_Temporary.ToString();
		}

		private void calSuperficialVelocityError()
		{
			double A;
			A=Math.PI*D*D/4;
			E_Ugs=Math.Pow(x*E_m/(A*this.R134a_ObservationPoint.VapourDensity),2);
			E_Ugs=E_Ugs+Math.Pow(m*E_x/(A*this.R134a_ObservationPoint.VapourDensity),2);
			E_Ugs=E_Ugs+Math.Pow(8*m*x*E_D/(Math.PI*D*D*D*this.R134a_ObservationPoint.VapourDensity),2);
			E_Ugs=E_Ugs+Math.Pow(m*x*this.R134aUncertainty_ObservationPoint.VapourDensity_Error/(A*Math.Pow(this.R134a_ObservationPoint.VapourDensity,2)),2);
			E_Ugs=Math.Round(Math.Sqrt(E_Ugs),4);
			E_Uls=Math.Pow((1-x)*E_m/(A*this.R134a_ObservationPoint.LiquidDensity),2);
			E_Uls=E_Uls+Math.Pow(m*E_x/(A*this.R134a_ObservationPoint.LiquidDensity),2);
			E_Uls=E_Uls+Math.Pow(8*m*(1-x)*E_D/(Math.PI*D*D*D*this.R134a_ObservationPoint.LiquidDensity),2);
			E_Uls=E_Uls+Math.Pow(m*(1-x)*this.R134aUncertainty_ObservationPoint.LiquidDensity_Error/(A*Math.Pow(this.R134a_ObservationPoint.LiquidDensity,2)),2);
			E_Uls=Math.Round(Math.Sqrt(E_Uls),4);
			this.txtUgsUncertainty.Text=E_Ugs.ToString();
			this.txtUlsUncertainty.Text=E_Uls.ToString();
		}
	}
}
