Attribute VB_Name = "CalculThermalLoss"
Option Explicit

Sub CalThermalLoss()
   Dim i As Integer
   Dim T8 As Single, Qf8 As Single
   Dim E2 As Single, E3 As Single, E4 As Single, E8 As Single
   Dim DiffTempAavg As Single, DiffTempBavg As Single, DiffTempCavg As Single
   
  'the outlet parameters of preheaters (single phase flow)
     T8 = SysTemperature(8)  'unit "K"
     Qf8 = Qf(T8)  'unit "Kg/m3"
     Hf8 = H(T8, Qf8)  'unit "J/Kg"

  'the liquid energy at the inlet of preheater
     E2 = Hf2 * FlowRate  'unit "W"
  'the liquid energy at the outlet of preheater
     E8 = Hf8 * FlowRate  'unit "W"
  'the liquid energy at the inlet of test section
     E3 = Hf3 * FlowRate  'unit "W"
  'the power loss in prheater
     ThermalLossA = E8 - E2 - Power1 'unit "W"
  'the power loss between prheater and test section
     ThermalLossB = E3 - E8 'unit "W"
  'the liquid energy at the outlet of test section
     E4 = Hf4 * FlowRate  'unit "W"
  'the power loss in the test section
     ThermalLossC = E4 - E3 - Power2 'unit "W"
     
     ThermalLossTotalNo = ThermalLossTotalNo + 1
     ThermalLossAtotal = ThermalLossAtotal + ThermalLossA
     ThermalLossBtotal = ThermalLossBtotal + ThermalLossB
     ThermalLossCtotal = ThermalLossCtotal + ThermalLossC
     ThermalLossAavg = ThermalLossAtotal / ThermalLossTotalNo
     ThermalLossBavg = ThermalLossBtotal / ThermalLossTotalNo
     ThermalLossCavg = ThermalLossCtotal / ThermalLossTotalNo
     DiffTempAtotal = DiffTempAtotal + PreheaterAvgTempDiff
     DiffTempBtotal = DiffTempBtotal + PipeAvgTempDiff
     DiffTempCtotal = DiffTempCtotal + TestsectionAvgTempDiff
     DiffTempAavg = DiffTempAtotal / ThermalLossTotalNo
     DiffTempBavg = DiffTempBtotal / ThermalLossTotalNo
     DiffTempCavg = DiffTempCtotal / ThermalLossTotalNo
     ThermalLossAcoefficient = ThermalLossAavg / DiffTempAavg
     ThermalLossBcoefficient = ThermalLossBavg / DiffTempBavg
     ThermalLossCcoefficient = ThermalLossCavg / DiffTempCavg
End Sub



