Attribute VB_Name = "CalculParameters"
Option Explicit

Sub CalParameters()
    Dim QvAvg As Single, QfAvg As Single, HvAvg As Single, HfAvg As Single
    Dim RequiredLiquidFlowRate As Single, RequiredVapourFlowRate As Single
    Dim Qf3Avg As Single, Hf3Avg As Single, InputFluidEnergy As Single, OutputFliudEnergy As Single

     ParametersTotalNo = ParametersTotalNo + 1
     P3total = P3total + SysPressure(3) / 100000
     T3total = T3total + SysTemperature(3) - 273.15
     P4total = P4total + SysPressure(4) / 100000
     T4total = T4total + SysTemperature(4) - 273.15
     P0total = P0total + SysPressure(0) / 100000
     T0total = T0total + SysTemperature(0) - 273.15
     TheralLosstotal = TheralLosstotal + ThermalLoss3
     
     P3Avg = P3total / ParametersTotalNo
     T3Avg = T3total / ParametersTotalNo
     P4Avg = P4total / ParametersTotalNo
     T4Avg = T4total / ParametersTotalNo
     P0Avg = P0total / ParametersTotalNo
     T0Avg = T0total / ParametersTotalNo
     TheralLossAvg = TheralLosstotal / ParametersTotalNo 'unit "W"
     
     PAvg = ObservationPositionRatio * P0Avg + (1 - ObservationPositionRatio) * P4Avg
     TAvg = Ts(100000 * PAvg) - 273.15
     
     QvAvg = Qv(TAvg + 273.15, PAvg * 100000)
     QfAvg = Qf(TAvg + 273.15)
     HvAvg = H(TAvg + 273.15, QvAvg)
     HfAvg = H(TAvg + 273.15, QfAvg)
     RequiredLiquidFlowRate = pi * (Val(Di) / 1000) ^ 2 / 4 * Uls * QfAvg 'unit "Kg/s"
     RequiredVapourFlowRate = pi * (Val(Di) / 1000) ^ 2 / 4 * Ugs * QvAvg 'unit "Kg/s"
     RequiredFlowRate = 3600 * (RequiredLiquidFlowRate + RequiredVapourFlowRate) 'unit "Kg/h"

     Qf3Avg = Qf(T3Avg + 273.15)
     Hf3Avg = H(T3Avg + 273.15, Qf3Avg)
     InputFluidEnergy = RequiredFlowRate / 3600 * Hf3Avg 'unit "W"
     OutputFliudEnergy = RequiredLiquidFlowRate * HfAvg + RequiredVapourFlowRate * HvAvg 'unit "W"
     RequiredPower = OutputFliudEnergy - InputFluidEnergy - TheralLossAvg 'unit "W"
     
End Sub


