Attribute VB_Name = "DataConvert"
Option Explicit

Sub CalibratedData(CalibratedResult() As Single)
   Dim i As Integer
        For i = 1 To Val(ThermocoupleQuantityi)
            CalibratedResult(i) = 51519300# * OriginalResult(i) ^ 3 - 443639# * OriginalResult(i) ^ 2 + 25321.8 * OriginalResult(i) + 0.204026   'unit "C"
            If CalibratedResult(i) > 80 Then
                CalibratedResult(i) = -20385700# * OriginalResult(i) ^ 3 + 475514# * OriginalResult(i) ^ 2 + 21293.1 * OriginalResult(i) + 6.14897   'unit "C"
            End If
        Next i
        CalibratedResult(5) = (CalibratedResult(4) + CalibratedResult(6)) / 2 'No 3 thermocouple wire was damaged!!
        'CalibratedResult(13) = (CalibratedResult(12) + CalibratedResult(14)) / 2 'No 5 thermocouple wire was damaged!!
        
        CalibratedResult(18) = 44517000# * OriginalResult(18) ^ 3 - 767335# * OriginalResult(18) ^ 2 + 25857.5 * OriginalResult(18) + 0.108318 - 0.13 'unit "C"
        CalibratedResult(20) = 42701800# * OriginalResult(20) ^ 3 - 771824# * OriginalResult(20) ^ 2 + 25872.5 * OriginalResult(20) + 0.1 - 0.05 'unit "C"
        CalibratedResult(19) = 42701800# * OriginalResult(19) ^ 3 - 771824# * OriginalResult(19) ^ 2 + 25872.5 * OriginalResult(19) + 0.01 'unit "C"
        For i = 41 To 57
          CalibratedResult(i) = OriginalResult(i) 'unit "C"
        Next i
        CalibratedResult(61) = 1.00282 * OriginalResult(61) + 0.151393 'unit "C"
        CalibratedResult(62) = 49708500# * OriginalResult(62) ^ 3 - 458791# * OriginalResult(62) ^ 2 + 25490.2 * OriginalResult(62) + 0.03044 'unit "C"
        CalibratedResult(65) = 1.00343 * OriginalResult(65) + 0.139379 'unit "C"
        CalibratedResult(66) = 1.00265 * OriginalResult(66) + 0.00156191 'unit "C"
        CalibratedResult(67) = OriginalResult(67) 'unit "C"
        CalibratedResult(68) = 48445100# * OriginalResult(68) ^ 3 - 409933# * OriginalResult(68) ^ 2 + 25262.7 * OriginalResult(68) + 0.172138 'unit "C"
        For i = 69 To 72
          CalibratedResult(i) = OriginalResult(i) 'unit "C"
        Next i
        Select Case frmMain.ComboDiffPressTransChoice(0).Text
        Case "100in.-24%"
            CalibratedResult(101) = 0.00764138 * OriginalResult(101) - 0.0156251 + 0.0006 'unit "bar", 24% capacity
            If OriginalResult(101) >= 10 Then
                DP1alarm = "Change DP1!"
            Else
                DP1alarm = ""
            End If
        Case "100in.-100%"
            CalibratedResult(101) = 0.0311361 * OriginalResult(101) - 0.0622722 - 0.0035 'unit "bar", 100% capacity
            If (CalibratedResult(101) < 0.06 Or OriginalResult(101) >= 10) Then
                DP1alarm = "Change DP1!"
            Else
                DP1alarm = ""
            End If
        Case "25psi-50%"
            CalibratedResult(101) = 0.112016 * OriginalResult(101) - 0.224394 'unit "bar", 50% capacity
            If (CalibratedResult(101) < 0.249 Or OriginalResult(101) >= 10) Then
                DP1alarm = "Change DP1!"
            Else
                DP1alarm = ""
            End If
        Case "25psi-100%"
            CalibratedResult(101) = 0.213418 * OriginalResult(101) - 0.424859 'unit "bar", 100% capacity
            If CalibratedResult(101) < 0.895 Then
                DP1alarm = "Change DP1!"
            ElseIf OriginalResult(101) > 10 Then
                DP1alarm = "DP1 overflow!!"
            End If
        End Select
        Select Case frmMain.ComboDiffPressTransChoice(1).Text
        Case "100in.-100%"
            CalibratedResult(102) = 0.0311361 * OriginalResult(102) - 0.0622722 - 0.0035 'unit "bar", 100% capacity
        Case "25psi-50%"
            CalibratedResult(102) = 0.112016 * OriginalResult(102) - 0.224394 'unit "bar", 50% capacity
        End Select
        If OriginalResult(117) = 0 Then
            CalibratedResult(117) = 12#
        Else
            CalibratedResult(117) = OriginalResult(117) 'unit "V"
        End If
        CalibratedResult(105) = 4.96635 * OriginalResult(105) - 9.9838 'unit "bar"
        CalibratedResult(106) = 83.7547 * OriginalResult(106) - 0.0252332 - Val(AmbientPressure) 'unit "bar"
        CalibratedResult(106) = CalibratedResult(106) * 12# / CalibratedResult(117) 'unit "bar"
        CalibratedResult(107) = 167.801 * OriginalResult(107) + 0.12464 - Val(AmbientPressure) 'unit "bar"
        CalibratedResult(107) = CalibratedResult(107) * 12# / CalibratedResult(117) 'unit "bar"
        CalibratedResult(108) = 83.6674 * OriginalResult(108) - 0.458972 - Val(AmbientPressure) 'unit "bar"
        CalibratedResult(108) = CalibratedResult(108) * 12# / CalibratedResult(117)  'unit "bar"
        CalibratedResult(109) = 4.95764 * OriginalResult(109) - 10.0253 'unit "bar"
        CalibratedResult(110) = 83.185 * OriginalResult(110) - 0.479726 - Val(AmbientPressure) 'unit "bar"
        CalibratedResult(110) = CalibratedResult(110) * 12# / CalibratedResult(117)  'unit "bar"
        CalibratedResult(113) = (3.125 * OriginalResult(113) - 6.25 - 0.03) / 3600   'unit "Kg/s"
        CalibratedResult(114) = (62.5 * OriginalResult(114) - 125 - 0.3078 + 0.078) / 3600 'unit "Kg/s"
  End Sub

Sub CalculatedData()
   Dim i As Integer, Max As Single

    For i = 1 To 20
        While ChannelSelection(i) = 1 And CalibratedResult(i) = Null
            DoEvents
        Wend
    Next i
    
    For i = 41 To 116
        While ChannelSelection(i) = 1 And CalibratedResult(i) = Null
            DoEvents
        Wend
    Next i
    
    If ChannelSelection(113) = 1 And ChannelSelection(114) = 1 Then FlowRate = CalibratedResult(113) + CalibratedResult(114) 'unit "Kg/s"
    If ChannelSelection(113) = 1 And ChannelSelection(114) = 0 Then FlowRate = CalibratedResult(113) 'unit "Kg/s"
    If ChannelSelection(113) = 0 And ChannelSelection(114) = 1 Then FlowRate = CalibratedResult(114) 'unit "Kg/s"
    If ChannelSelection(113) = 0 And ChannelSelection(114) = 0 Then MsgBox ("No flowmeter is selected"): Stop
    While FlowRate = 0#
        DoEvents
    Wend

  ' Preheater Max. Inside Temperature
    PreheaterMaxTemp = CalibratedResult(41)
    PreheaterMaxTempNo = 1
    For i = 2 To 6
        If PreheaterMaxTemp < CalibratedResult(40 + i) Then
            PreheaterMaxTemp = CalibratedResult(40 + i)
            PreheaterMaxTempNo = i
        End If
    Next i

  ' Preheaters Inside-Outside Temperature Difference
    PreheaterInsideAvgTemp = 0
    PreheaterOutsideAvgTemp = 0
    For i = 1 To 6
        PreheaterInsideAvgTemp = PreheaterInsideAvgTemp + CalibratedResult(40 + i) / 6
        PreheaterOutsideAvgTemp = PreheaterOutsideAvgTemp + CalibratedResult(46 + i) / 6
    Next
    PreheaterAvgTempDiff = PreheaterOutsideAvgTemp - PreheaterInsideAvgTemp
    
  ' Preheaters-Test Section Pipe Inside-Outside Temperature Difference
    PipeAvgTempDiff = CalibratedResult(54) - CalibratedResult(53)
 
  ' Test Section Inside-Outside Temperature Difference
    TestsectionWallAvgTemp = 0
    For i = 1 To Val(ThermocoupleQuantityi)
       TestsectionWallAvgTemp = TestsectionWallAvgTemp + CalibratedResult(i) / Val(ThermocoupleQuantityi)
    Next i
    TestsectionAvgTempDiff = CalibratedResult(55) - TestsectionWallAvgTemp
    
  ' Pressure Different Transducer Tube Wall Temperature
    DP1TubeWallTemperature = CalibratedResult(56)
        
  ' Room Temperature
    RoomTemperature = CalibratedResult(69)
    
  'State and Sturated Tempeeerature
   SysTemperature(0) = CalibratedResult(20) + 273.15  'unit "K"
   SysTemperature(1) = CalibratedResult(61) + 273.15 'unit "K"
   SysTemperature(2) = CalibratedResult(62) + 273.15  'unit "K"
   SysTemperature(3) = CalibratedResult(18) + 273.15  'unit "K"
   SysTemperature(4) = CalibratedResult(19) + 273.15  'unit "K"
   SysTemperature(5) = CalibratedResult(65) + 273.15  'unit "K"
   SysTemperature(6) = CalibratedResult(66) + 273.15  'unit "K"
   SysTemperature(7) = CalibratedResult(67) + 273.15  'unit "K"
   SysTemperature(8) = CalibratedResult(68) + 273.15  'unit "K"
   DiffPressure(0) = 100000# * CalibratedResult(101) 'unit "Pa"
   DiffPressure(1) = 100000# * CalibratedResult(102) 'unit "Pa"
   SysPressure(0) = 100000# * (CalibratedResult(110) + Val(AmbientPressure)) 'unit "Pa-a"
   SysPressure(1) = 100000# * (CalibratedResult(105) + Val(AmbientPressure)) 'unit "Pa-a"
   SysPressure(2) = 100000# * (CalibratedResult(106) + Val(AmbientPressure)) 'unit "Pa-a"
   SysPressure(3) = 100000# * (CalibratedResult(107) + Val(AmbientPressure)) 'unit "Pa-a"
   SysPressure(4) = 100000# * (CalibratedResult(108) + Val(AmbientPressure)) 'unit "Pa-a"
   SysPressure(5) = 100000# * (CalibratedResult(109) + Val(AmbientPressure)) 'unit "Pa-a"
   For i = 0 To 5
    SysSatTemp(i) = Ts(SysPressure(i))  'unit "K"
    DiffTemperature(i) = SysSatTemp(i) - SysTemperature(i)
    If DiffTemperature(i) <= -1 * SatTempRange Then
        SysState(i) = "VAPOUR"
    ElseIf DiffTemperature(i) >= SatTempRange Then
        SysState(i) = "LIQUID"
    Else
        SysState(i) = "TWO PHASE"
    End If
   Next i
   
  'ThermalLoss
    ThermalLoss1 = ThermalLoss1coefficient * PreheaterAvgTempDiff
    ThermalLoss2 = ThermalLoss2coefficient * PipeAvgTempDiff
    ThermalLoss3 = ThermalLoss3LengthCoefficient * ThermalLoss3coefficient * TestsectionAvgTempDiff
  'Heat flux in test section
     Heatflux = 1000000 * Power2 / (pi * Val(Di) * Val(Lengthi)) 'unit "W/m2"
  'the inlet parameters of preheaters
     T2 = SysTemperature(2)  'unit "K"
     P2 = SysPressure(2)  'unit "Pa-a"
     Qf2 = Qf(T2)  'unit "Kg/m3"
     Hf2 = H(T2, Qf2)  'unit "J/Kg"
  'the conservation of energy between the inlet of test section and the preheaters
     InputPower1 = Power1  'unit "W"
     InputEnthalpy1 = Hf2   'unit "J/Kg"
     InputFlowEnergy1 = InputEnthalpy1 * FlowRate   'unit "W"
     OutputEnergy1 = InputFlowEnergy1 + InputPower1 + ThermalLoss1 + ThermalLoss2  'unit "W"
     OutputEnthalpy1 = OutputEnergy1 / FlowRate   'unit "J/Kg"
  'the inlet parameters of test section
     T3 = SysTemperature(3)  'unit "K"
     P3 = SysPressure(3) 'unit "Pa-a"
     Qf3 = Qf(T3)  'unit "Kg/m3"
     Qv3 = Qv(T3, P3)  'unit "Kg/m3"
     Hf3 = H(T3, Qf3)  'unit "J/Kg"
     Hv3 = H(T3, Qv3)  'unit "J/Kg"
     Muf3 = Muf(T3)  'unit "Pa.s"
     Muv3 = Muv(T3)  'unit "Pa.s"
     Musup3 = Musup(T3, P3) 'unit "Pa.s"
  'the inlet quality of test section
     T3s = Ts(P3)  'unit "K"
     P3s = P3 'unit "Pa-a"
     St3s = St(T3s) 'unit "N/m"
     Qf3s = Qf(T3s)  'unit "Kg/m3"
     Qv3s = Qv(T3s, P3s)  'unit "Kg/m3"
     Hf3s = H(T3s, Qf3s)  'unit "J/Kg"
     Hv3s = H(T3s, Qv3s)  'unit "J/Kg"
    If SysState(3) <> "LIQUID" Then
        InletQuality = (OutputEnthalpy1 - Hf3s) / (Hv3s - Hf3s)
    End If
    If SysState(3) = "LIQUID" Then
        InletQuality = (Hf3 - Hf3s) / (Hv3s - Hf3s)
    End If
  'the conservation of energy in the test section
     InputPower2 = Power2  'unit "W"
    If SysState(3) <> "LIQUID" Then
        InputEnthalpy2 = OutputEnthalpy1   'unit "J/Kg"
    End If
    If SysState(3) = "LIQUID" Then
        InputEnthalpy2 = Hf3   'unit "J/Kg"
    End If
     InputFlowEnergy2 = InputEnthalpy2 * FlowRate   'unit "W"
     OutputEnergy2 = InputFlowEnergy2 + InputPower2 + ThermalLoss3   'unit "W"
     OutputEnthalpy2 = OutputEnergy2 / FlowRate   'unit "J/Kg"
  'the outlet parameters of test section
     T4 = SysTemperature(4) 'unit "K"
     P4 = SysPressure(4) 'unit "Pa-a"
     Qf4 = Qf(T4)  'unit "Kg/m3"
     Qv4 = Qv(T4, P4)  'unit "Kg/m3"
     Hf4 = H(T4, Qf4)  'unit "J/Kg"
     Hv4 = H(T4, Qv4)  'unit "J/Kg"
     Muf4 = Muf(T4)  'unit "Pa.s"
     Muv4 = Muv(T4)  'unit "Pa.s"
     Musup4 = Musup(T4, P4) 'unit "Pa.s"
     T4s = Ts(P4)  'unit "K"
     P4s = P4 'unit "Pa-a"
     St4s = St(T4s) 'unit "N/m"
     Qf4s = Qf(T4s)  'unit "Kg/m3"
     Qv4s = Qv(T4s, P4s)  'unit "Kg/m3"
     Hf4s = H(T4s, Qf4s)  'unit "J/Kg"
     Hv4s = H(T4s, Qv4s)  'unit "J/Kg"
  'the observation point parameters
     ExperimentalPressure = (CalibratedResult(108) + Val(AmbientPressure)) * (1 - ObservationPositionRatio) + (CalibratedResult(110) + Val(AmbientPressure)) * ObservationPositionRatio 'unit "bar-a"
     ExperimentalTemperature = Ts(100000 * ExperimentalPressure) - 273.15 'unit "C"
     Tex = ExperimentalTemperature + 273.15 'unit "K"
     Pex = 100000 * ExperimentalPressure 'unit "Pa-a"
     Qfex = Qf(Tex)  'unit "Kg/m3"
     Qvex = Qv(Tex, Pex)  'unit "Kg/m3"
     Hfex = H(Tex, Qfex)  'unit "J/Kg"
     Hvex = H(Tex, Qvex)  'unit "J/Kg"
     Mufex = Muf(Tex)  'unit "Pa.s"
     Muvex = Muv(Tex)  'unit "Pa.s"
     Musupex = Musup(Tex, Pex) 'unit "Pa.s"
     Texs = Ts(Pex)  'unit "K"
     Pexs = Pex 'unit "Pa-a"
     Stexs = St(Texs) 'unit "N/m"
     Qfexs = Qf(Texs)  'unit "Kg/m3"
     Qvexs = Qv(Texs, Pexs)  'unit "Kg/m3"
     Hfexs = H(Texs, Qfexs)  'unit "J/Kg"
     Hvexs = H(Texs, Qvexs)  'unit "J/Kg"
     If IsHeatTransfer = True Then
        OutletQuality = (OutputEnthalpy2 - Hf4s) / (Hv4s - Hf4s)
     ElseIf IsFlowPatterns = True Then
        OutletQuality = (OutputEnthalpy2 - Hfexs) / (Hvexs - Hfexs)
     End If
   'the mass flux in test section
    MassFlux = 4 * FlowRate / (pi * (Val(Di) / 1000) ^ 2)
  'the superficial velocity in test section
    If InletQuality <= 0 Then
     InletLiquidVelocity = 4 * FlowRate / (Qf3 * pi * (Val(Di) / 1000) ^ 2)
     InletVapourVelocity = 0
    ElseIf InletQuality >= 1 Then
     InletLiquidVelocity = 0
     InletVapourVelocity = 4 * FlowRate / (Qv3 * pi * (Val(Di) / 1000) ^ 2)
    Else
     InletLiquidVelocity = 4 * (1 - InletQuality) * FlowRate / (Qf3s * pi * (Val(Di) / 1000) ^ 2)
     InletVapourVelocity = 4 * InletQuality * FlowRate / (Qv3s * pi * (Val(Di) / 1000) ^ 2)
    End If
     If IsHeatTransfer = True Then
        If OutletQuality <= 0 Then
            OutletLiquidVelocity = 4 * FlowRate / (Qf4 * pi * (Val(Di) / 1000) ^ 2)
            OutletVapourVelocity = 0
        ElseIf OutletQuality >= 1 Then
            OutletLiquidVelocity = 0
            OutletVapourVelocity = 4 * FlowRate / (Qv4 * pi * (Val(Di) / 1000) ^ 2)
        Else
            OutletLiquidVelocity = 4 * (1 - OutletQuality) * FlowRate / (Qf4s * pi * (Val(Di) / 1000) ^ 2)
            OutletVapourVelocity = 4 * OutletQuality * FlowRate / (Qv4s * pi * (Val(Di) / 1000) ^ 2)
        End If
     ElseIf IsFlowPatterns = True Then
        If OutletQuality <= 0 Then
            OutletLiquidVelocity = 4 * FlowRate / (Qfex * pi * (Val(Di) / 1000) ^ 2)
            OutletVapourVelocity = 0
        ElseIf OutletQuality >= 1 Then
            OutletLiquidVelocity = 0
            OutletVapourVelocity = 4 * FlowRate / (Qvex * pi * (Val(Di) / 1000) ^ 2)
        Else
            OutletLiquidVelocity = 4 * (1 - OutletQuality) * FlowRate / (Qfexs * pi * (Val(Di) / 1000) ^ 2)
            OutletVapourVelocity = 4 * OutletQuality * FlowRate / (Qvexs * pi * (Val(Di) / 1000) ^ 2)
        End If
     End If
    
End Sub


